//	Medianblur version 0.84
//  copyright (C) Tonny Petersen (tsp@person.dk) 2004

// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA, or visit
// http://www.gnu.org/copyleft/gpl.html .

#include "stdafx.h"
#include "avisynth.h"
#include "MedianBlur.h"
#include "MEDIAN.cpp"
//#include <memory.h>

#define ASM



int ticks;


#ifdef _MANAGED
#pragma managed(push, off)
#endif

BOOL __stdcall APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
	
    return TRUE;
}


MedianBlur::MedianBlur(PClip cl1,int rady,int radu,int radv,bool cb,IScriptEnvironment* env):
	GenericVideoFilter(cl1),_radius(0),_radiusy(rady),_radiusu(radu),_radiusv(radv),calcborder(cb),N(0),x(0),n(0),w(0),h(0)//,median(0),searchto(0)
	{}


void MedianBlur::CalcFrame(PVideoFrame &src, PVideoFrame &dst, int plane)
{
	const BYTE* srcp = src->GetReadPtr(plane);
	BYTE* dstp = dst->GetWritePtr(plane);

	const unsigned int dst_pitch = dst->GetPitch(plane);
	const unsigned int dst_width = dst->GetRowSize(plane);
	const unsigned int dst_height = dst->GetHeight(plane);
	
	const unsigned int src_pitch = src->GetPitch(plane);
	const unsigned int src_width = src->GetRowSize(plane);
	const unsigned int src_height = src->GetHeight(plane);
	const unsigned int vecsize =(_radius+2)*(_radius+2); 
	
	if(src_height<N||src_width<N)
		return;

	if(!calcborder)
	{
	
	for(w=_radius;w<dst_width-_radius;w++){
		h=_radius;
		*(dstp+(w+h*dst_pitch))=radixmedianInit(srcp+w-_radius,src_pitch);
		radixmedianRemove(srcp+w-_radius);
		for(h=_radius+1;h<dst_height-_radius;h++){
			*(dstp+(h*dst_pitch+w))=radixmedianAdd(srcp+w-_radius+(h+_radius)*src_pitch);
			radixmedianRemove(srcp+w-_radius+(h-_radius)*src_pitch);
			}
	}
	
		
	for(w=0;w<dst_width;w++){
		for(h=dst_height-_radius;h<dst_height;h++)
			dstp[h*dst_pitch+w]=srcp[h*src_pitch+w];
		for(h=0;h<_radius;h++)
			dstp[h*dst_pitch+w]=srcp[h*src_pitch+w];
	}
	for(h=_radius;h<dst_height-_radius;h++){
		for(w=0;w<_radius;w++)
			dstp[h*dst_pitch+w]=srcp[h*src_pitch+w];
		for(w=dst_width-_radius;w<dst_width;w++)
			dstp[h*dst_pitch+w]=srcp[h*src_pitch+w];
	}
	}
	else
	{
	for(w=0;w<_radius;w++){
		*(dstp+w)=radixmedianInitXY(srcp,src_pitch,w+_radius+1,_radius+1);
		h=1;
		for(;h<_radius;h++)
			*(dstp+w+h*dst_pitch)=radixmedianAddXY(srcp+(h+_radius)*src_pitch,_radius+h+1);
		for(;h<src_height-_radius-1;h++){
			*(dstp+w+h*dst_pitch)=radixmedianAddXY(srcp+(h+_radius)*src_pitch,N);
			radixmedianRemoveXY(srcp+(h-_radius)*src_pitch);
		}
		*(dstp+w+h*dst_pitch)=radixmedianAddXY(srcp+(h+_radius)*src_pitch,N);
		h++;
		for(;h<src_height;h++)
			*(dstp+w+h*dst_pitch)=radixmedianRemoveXY(srcp+(h-_radius)*src_pitch,src_height-h+_radius);
	}
	for(;w<src_width-_radius;w++){
		*(dstp+w)=radixmedianInitXY(srcp+w-_radius,src_pitch,N,_radius+1);
		h=1;
		for(;h<_radius;h++)
			*(dstp+w+h*dst_pitch)=radixmedianAddXY(srcp+w-_radius+(h+_radius)*src_pitch,_radius+h+1);
		for(;h<src_height-_radius-1;h++){
			*(dstp+w+h*dst_pitch)=radixmedianAdd(srcp+w-_radius+(h+_radius)*src_pitch);
			radixmedianRemove(srcp+w-_radius+(h-_radius)*src_pitch);
		}
		*(dstp+w+h*dst_pitch)=radixmedianAdd(srcp+w-_radius+(h+_radius)*src_pitch);
		h++;
		for(;h<src_height;h++)
			*(dstp+w+h*dst_pitch)=radixmedianRemoveXY(srcp+w-_radius+(h-_radius-1)*src_pitch,src_height-h+_radius);
	}
	for(;w<src_width;w++){
		*(dstp+w)=radixmedianInitXY(srcp+w-_radius,src_pitch,src_width-w+_radius,_radius+1);
		h=1;
		for(;h<_radius;h++)
			*(dstp+w+h*dst_pitch)=radixmedianAddXY(srcp+w-_radius+(h+_radius)*src_pitch,_radius+h+1);
		for(;h<src_height-_radius-1;h++){
			*(dstp+w+h*dst_pitch)=radixmedianAddXY(srcp+w-_radius+(h+_radius)*src_pitch,N);
			radixmedianRemoveXY(srcp+w-_radius+(h-_radius)*src_pitch);
		}
		*(dstp+w+h*dst_pitch)=radixmedianAddXY(srcp+w-_radius+(h+_radius)*src_pitch,N);
		h++;
		for(;h<src_height;h++)
			*(dstp+w+h*dst_pitch)=radixmedianRemoveXY(srcp+w-_radius+(h-_radius)*src_pitch,src_height-h+_radius);
	}
	}
}

BYTE MedianBlur::radixmedianInit (const BYTE *source,unsigned int pitch)
{
	memset (count, 0, sizeof (count));
	n=0;
	unsigned int i=0;
	//for (i=0; i<(N*N); i++ )
	for(unsigned int y=0;y<N;y++){
		for(unsigned int x=0;x<N;x++)
            count[source[i+x]]++;
		i+=pitch;}
			//count[source[i%N+(i/N)*pitch]]++;
  	
	for (i=0;n<((N*N+1)>>1);i++)
		n=n+count[i];
	
	i--;
	median=i;	
	return(i);
}


BYTE MedianBlur::radixmedianInitXY(const BYTE *source,unsigned int pitch,unsigned int X,unsigned int Y)
{
	memset (count, 0, sizeof (count));
	x=X;
	n=0;
	unsigned int i;


  	i=0;
	for(unsigned int yo=0;yo<Y;yo++){
		for(unsigned int xo=0;xo<X;xo++)
			count[source[i+xo]]++;
		i+=pitch;}
	for (i=0;n<((x*Y+1)>>1);i++)
		n=n+count[i];
	i--;
	median=i;
	return(i);
}

void MedianBlur::radixmedianRemove(const BYTE *source)
{
#ifndef ASM
	unsigned int i;
	for (i=0; i<N; i++ ){
		count[source[i]]--;
		if(source[i]<=median)
			n--;
	}
#else
		__asm{
		mov edi,[source]
		mov esi,this
		mov edx,[esi+median]
		mov eax,[esi+n]
		mov ecx,[esi+N]
L1:
		dec ecx
		jz	i0
		
		movzx ebx,byte ptr [edi+ecx]
		dec dword ptr [esi+4*ebx+count]
		cmp edx,ebx
		adc eax,0xFFFFFFFF

		jmp L1
i0:	
		movzx ebx,byte ptr [edi]
		dec dword ptr [esi+4*ebx+count]
		cmp edx,ebx
		adc eax,0xFFFFFFFF

		mov [esi+n],eax
		
	}
#endif
}

BYTE MedianBlur::radixmedianRemoveXY(const BYTE *source,unsigned int Y)
{
	unsigned int i;
	unsigned int imedian=(x*Y+1)>>1;
	for (i=0; i<x; i++ ){
		count[source[i]]--;
		if(source[i]<=median)
			n--;
	}
	
	if(n<imedian){
		for(i=median+1;n<imedian;i++)
			n=n+count[i];
		i--;
	}
	else if(n==imedian&&(n-count[median])<imedian) 
		return(median);
	else{
		for(i=median;n-count[i]>=imedian;i--)
			n=n-count[i];
		}
	median=i;
	return(i);
}

void MedianBlur::radixmedianRemoveXY(const BYTE *source)
{
	unsigned int i;
	for (i=0; i<x; i++ ){
		count[source[i]]--;
		if(source[i]<=median)
			n--;
	}
}

BYTE MedianBlur::radixmedianAdd(const BYTE *source)
{
	unsigned int i;
	unsigned int imedian=(N*N+1)>>1;
	#ifdef ASM
	//i(loop counter)=ecx,source[i]=ebx,n=eax,median=edx
	__asm{
		mov edi,[source]
		mov esi,this
		mov edx,[esi+median]
		mov eax,[esi+n]
		mov ecx,[esi+N]
L1:
		dec ecx
		jz	i0
		
		movzx ebx,byte ptr [edi+ecx]
		inc dword ptr [esi+4*ebx+count]
		cmp edx,ebx
		sbb eax,0xFFFFFFFF

		jmp L1
i0:	
		movzx ebx,byte ptr [edi]
		inc dword ptr [esi+4*ebx+count]
		cmp edx,ebx
		sbb eax,0xFFFFFFFF

		mov [esi+n],eax
		
	}
#else
	for (i=0; i<N; i++ ){
		count[source[i]]++;
		if(source[i]<=median)
			n++;
	}
#endif
	if(n<imedian){
		for(i=median+1;n<imedian;i++)
			n=n+count[i];
		i--;
	}
	else if((n==imedian&&n-count[median]<imedian)) //||(n-count[median])<imedian) 
		return(median);
	else{
		for(i=median;n-count[i]>=imedian;i--)
			n=n-count[i];
		}
	median=i;
	return(i);
}

BYTE MedianBlur::radixmedianAddXY(const BYTE *source,unsigned int Y)
{
	unsigned int i;
	unsigned int imedian=(x*Y+1)>>1;
	for (i=0; i<x; i++ ){
		count[source[i]]++;
		if(source[i]<=median)
			n++;
	}
	if(n<imedian){
		for(i=median+1;n<imedian;i++)
			n=n+count[i];
		i--;
	}
	else if(n==imedian&&(n-count[median])<imedian) 
		return(median);
	else{
		for(i=median;n-count[i]>=imedian;i--)
			n=n-count[i];
		}
	median=i;
	return(i);
}

//******************************************************************************************************************
//******************************************************************************************************************
//**************			MedianBlurWeight								****************************************
//******************************************************************************************************************
//******************************************************************************************************************

MedianBlurWeight::MedianBlurWeight(PClip cl1,int rady,int radu,int radv,int wy,int wu,int wv,bool cb,IScriptEnvironment* env):
	MedianBlur(cl1,rady,radu,radv,cb,env),_weighty(wy),_weightu(wu),_weightv(wv),spitch(0),sp(0),_offset(0)
	{}


PVideoFrame __stdcall MedianBlurWeight::GetFrame(int n, IScriptEnvironment* env)
{
	ticks=GetTickCount();
	if(!vi.IsYV12())
		env->ThrowError("only yv12 supported");
	PVideoFrame src = child->GetFrame(n, env);
	PVideoFrame dst = env->NewVideoFrame(vi);

	if(_radiusy>0)
		_radius=_radiusy,_weight=_weighty,spitch = src->GetPitch(PLANAR_Y),sp = src->GetReadPtr(PLANAR_Y),
		N=1+2*_radius,CalcFrame(src,dst,PLANAR_Y);
	else if(_radiusy==0)
		env->BitBlt(dst->GetWritePtr(PLANAR_Y), dst->GetPitch(PLANAR_Y), src->GetReadPtr(PLANAR_Y), src->GetPitch(PLANAR_Y),src->GetRowSize(PLANAR_Y), src->GetHeight(PLANAR_Y));
	else if(_radiusy>-256)
		memset (dst->GetWritePtr(PLANAR_Y), -_radiusy, dst->GetPitch(PLANAR_Y)*dst->GetHeight(PLANAR_Y));
	if(_radiusu>0)
		_radius=_radiusu,_weight=_weightu,spitch=src->GetPitch(PLANAR_U),sp=src->GetReadPtr(PLANAR_U),N=1+2*_radius,CalcFrame(src,dst,PLANAR_U);
	else if(_radiusu==0)
		env->BitBlt(dst->GetWritePtr(PLANAR_U), dst->GetPitch(PLANAR_U), src->GetReadPtr(PLANAR_U), src->GetPitch(PLANAR_U),src->GetRowSize(PLANAR_U), src->GetHeight(PLANAR_U));
	else if(_radiusu>-256)
		memset (dst->GetWritePtr(PLANAR_U), -_radiusu, dst->GetPitch(PLANAR_U)*dst->GetHeight(PLANAR_U));
	if(_radiusv>0)
		_radius=_radiusv,_weight=_weightv,spitch = src->GetPitch(PLANAR_V),sp = src->GetReadPtr(PLANAR_V),N=1+2*_radius,CalcFrame(src,dst,PLANAR_V);
	else if(_radiusv==0)
		env->BitBlt(dst->GetWritePtr(PLANAR_V), dst->GetPitch(PLANAR_V), src->GetReadPtr(PLANAR_V), src->GetPitch(PLANAR_V),src->GetRowSize(PLANAR_V), src->GetHeight(PLANAR_V));
	else if(_radiusv>-256)
		memset (dst->GetWritePtr(PLANAR_V), -_radiusv, dst->GetPitch(PLANAR_V)*dst->GetHeight(PLANAR_V));
	ticks=GetTickCount()-ticks;
	env->SetVar("DEBUG",ticks);
	return dst;
}

BYTE MedianBlurWeight::radixmedianInit (const BYTE *source,unsigned int pitch)
{
	memset (count, 0, sizeof (count));
	n=0;
	unsigned int i=0;
	_offset=w+h*spitch;
	for(unsigned int y=0;y<N;y++){
		for(unsigned int x=0;x<N;x++)
            count[source[i+x]]++;
		i+=pitch;}

  	count[sp[_offset]]+=_weight;

	for (i=0;n<((N*N+1+_weight)>>1);i++)
		n=n+count[i];
	
	i--;
	median=i;	
	return(i);
}

BYTE MedianBlurWeight::radixmedianInitXY(const BYTE *source,unsigned int pitch,unsigned int X,unsigned int Y)
{
	memset (count, 0, sizeof (count));
	x=X;
	n=0;
	unsigned int i;
	unsigned int imedian=(x*Y+1+_weight)>>1;
	_offset=w;
	i=0;
	for(unsigned int yo=0;yo<Y;yo++){
		for(unsigned int xo=0;xo<X;xo++)
			count[source[xo+i]]++;;
		i+=pitch;}
  	count[sp[_offset]]+=_weight;

	for (i=0;n<imedian;i++)
		n=n+count[i];

	i--;
	median=i;

	count[sp[_offset]]-=_weight;
	if(sp[_offset]<=median)
		n-=_weight;

	return(i);
}

void MedianBlurWeight::radixmedianRemove(const BYTE *source)
{
	#ifdef ASM
	__asm{
		mov edi,[source]
		mov esi,this
		mov edx,[esi+median]
		mov eax,[esi+n]
		mov ecx,[esi+N]
L1:
		dec ecx
		jz	i0
		
		movzx ebx,byte ptr [edi+ecx]
		dec dword ptr [esi+4*ebx+count]
		cmp edx,ebx
		adc eax,0xFFFFFFFF

		jmp L1
i0:	
		movzx ebx,byte ptr [edi]
		dec dword ptr [esi+4*ebx+count]
		cmp edx,ebx
		adc eax,0xFFFFFFFF
		
		mov edi,[MedianBlurWeight::sp+esi]//edi=sp   lea?
		/*
		mov ecx,eax			//ecx=n			
		mov ebx,edx			//ebx=median
		mov edx,[esi+h]		//edx=h
		mov eax,[esi+spitch]//eax=spitch
		mul edx				//eax=h*spitch
		lea edi,[edi+eax]	//edi=sp+w+h*spitch	
		mov eax,[esi+w]
		lea edi,[edi+eax]
		mov eax,[esi+_weight]//eax=_weight
		movzx edi,byte ptr[edi]
		sub [esi+4*edi+count],eax	//count[edi]-=_weight
		
		mov edx,0xFFFFFFFF		//edx=FFFFFFFF
		cmp ebx,edi				//median-centerval median<centerval->cf=1
		adc edx,0				//cf=0->edx=0xFFFFFFFF else edx=0x00000000
		and eax,edx				//cf=1->eax=0 else eax=_weight
		sub ecx,eax				//n=n-ecx (0 if centerval>median else _weight if centerval<=median)

		mov [esi+n],ecx			//n=ecx
		*/

		mov ebx,[esi+_offset]	//ebx=offset
		mov ecx,[esi+_weight]	//ecx=weight
		
		lea edi,[edi+ebx]		//edi=sp+offset
		
		movzx edi,byte ptr[edi] //edi = center BYTE	
		sub [esi+4*edi+count],ecx //count[edi]+=_weight
		
		mov ebx,0xFFFFFFFF		//ebx=FFFFFFFF
		cmp edx,edi				//median-centerval median<centerval->cf=1
		adc ebx,0				//cf=0->ebx=0xFFFFFFFF else ebx=0x00000000
		and ecx,ebx				//cf=1->ecx=0 else ecx=_weight
		sub eax,ecx				//n=n-ecx (0 if centerval>median else _weight if centerval<=median)

		mov [esi+n],eax			//n=eax
		
	}
#else
	unsigned int i;
	for (i=0; i<N; i++ ){
		count[source[i]]--;
		if(source[i]<=median)
			n--;
	}
	count[sp[_offset]]-=_weight;
	if(sp[_offset]<=median)
		n-=_weight;
#endif
}

BYTE MedianBlurWeight::radixmedianRemoveXY(const BYTE *source,unsigned int Y)
{
	unsigned int i;
	unsigned int imedian=(x*Y+1+_weight)>>1;
	for (i=0; i<x; i++ ){
		count[source[i]]--;
		if(source[i]<=median)
			n--;
	}
	_offset+=spitch;
	count[sp[_offset]]+=_weight;
	if(sp[_offset]<=median)
		n+=_weight;


	if(n<imedian){
		for(i=median+1;n<imedian;i++)
			n=n+count[i];
		i--;
	}
	else if(n==imedian&&(n-count[median])<imedian){ 
		count[sp[w+h*spitch]]-=_weight;
		if(sp[w+h*spitch]<=median)
			n-=_weight;
		return(median);
	}
	else{
		for(i=median;n-count[i]>=imedian;i--)
			n=n-count[i];
		}
	median=i;
	count[sp[_offset]]-=_weight;
	if(sp[_offset]<=median)
		n-=_weight;
	return(i);
}

BYTE MedianBlurWeight::radixmedianAdd(const BYTE *source)
{
	unsigned int i;
	unsigned int imedian=(N*N+1+_weight)>>1;
#ifdef ASM
	__asm{
		mov edi,[source]
		mov esi,this
		mov edx,[esi+median]
		mov eax,[esi+n]
		mov ecx,[esi+N]
L1:
		dec ecx
		jz	i0
		
		movzx ebx,byte ptr [edi+ecx]
		inc dword ptr [esi+4*ebx+count]
		cmp edx,ebx
		sbb eax,0xFFFFFFFF

		jmp L1
i0:	
		movzx ebx,byte ptr [edi]
		inc dword ptr [esi+4*ebx+count]
		cmp edx,ebx
		sbb eax,0xFFFFFFFF
		
		mov edi,[MedianBlurWeight::sp+esi]//edi=sp   lea?
		/*
		mov ecx,eax			//ecx=n			
		mov ebx,edx			//ebx=median
		mov edx,[esi+h]		//edx=h
		mov eax,[esi+spitch]//eax=spitch
		mul edx				//eax=h*spitch
		lea edi,[edi+eax]	//edi=sp+h*spitch	
		mov eax,[esi+w]
		lea edi,[edi+eax]	//edi=sp+w+h*spitch	
		mov eax,[esi+_weight]//eax=_weight
		movzx edi,byte ptr[edi]
		add [esi+4*edi+count],eax	//count[edi]+=_weight
		
		mov edx,0xFFFFFFFF		//edx=FFFFFFFF
		cmp ebx,edi				//median-centerval median<centerval->cf=1
		adc edx,0				//cf=0->edx=0xFFFFFFFF else edx=0x00000000
		and eax,edx				//cf=1->eax=0 else eax=_weight
		add ecx,eax				//n=n+ecx (0 if centerval>median else _weight if centerval<=median)

		mov [esi+n],ecx			//n=ecx
		*/
		mov ebx,[esi+_offset]	//ebx=offset
		mov ecx,[esi+_weight]	//ecx=weight
		add ebx,[esi+spitch]	//ebx=offset+spitch(next line)	
		lea edi,[edi+ebx]		//edi=sp+offset
		mov [esi+_offset],ebx	//offset=ebx
		movzx edi,byte ptr[edi] //edi = center BYTE	
		add [esi+4*edi+count],ecx //count[edi]+=_weight
		
		mov ebx,0xFFFFFFFF		//ebx=FFFFFFFF
		cmp edx,edi				//median-centerval median<centerval->cf=1
		adc ebx,0				//cf=0->ebx=0xFFFFFFFF else ebx=0x00000000
		and ecx,ebx				//cf=1->ecx=0 else ecx=_weight
		add eax,ecx				//n=n+ecx (0 if centerval>median else _weight if centerval<=median)

		mov [esi+n],eax			//n=eax
	}
#else
	_offset+=spitch;
	for (i=0; i<N; i++ ){
		count[source[i]]++;
		if(source[i]<=median)
			n++;
	}
	count[sp[_offset]]+=_weight;
	if(sp[_offset]<=median)
		n+=_weight;
#endif
	
	if(n<imedian){
		for(i=median+1;n<imedian;i++)
			n=n+count[i];
		i--;
	}
	else if((n==imedian&&n-count[median]<imedian))
		return(median);
	else{
		for(i=median;n-count[i]>=imedian;i--)
			n=n-count[i];
		}
	median=i;
	return(i);
}

BYTE MedianBlurWeight::radixmedianAddXY(const BYTE *source,unsigned int Y)
{
	unsigned int i;
	unsigned int imedian=(x*Y+1+_weight)>>1;
	_offset+=spitch;

	for (i=0; i<x; i++ ){
		count[source[i]]++;
		if(source[i]<=median)
			n++;
	}
	count[sp[_offset]]+=_weight;
	if(sp[_offset]<=median)
		n+=_weight;


	if(n<imedian){
		for(i=median+1;n<imedian;i++)
			n=n+count[i];
		i--;
	}
	else if(n==imedian&&(n-count[median])<imedian){ 
		count[sp[w+h*spitch]]-=_weight;
		if(sp[w+h*spitch]<=median)
			n-=_weight;
		return(median);
		}
	else{
		for(i=median;n-count[i]>=imedian;i--)
			n=n-count[i];
		}
	median=i;
	count[sp[_offset]]-=_weight;
	if(sp[_offset]<=median)
		n-=_weight;
	return(i);
}



//******************************************************************************************************************
//******************************************************************************************************************
//**************			MedianBlurBin									****************************************
//******************************************************************************************************************
//******************************************************************************************************************

MedianBlurBin::MedianBlurBin(PClip cl1,int rady,int radu,int radv,int ty,int tu,int tv,bool cb,IScriptEnvironment* env):
	MedianBlur(cl1,rady,radu,radv,cb,env),_thresy(ty),_thresu(tu),_thresv(tv),_thres(0),iSSE(false)
	{}

void MedianBlurBin::tinit(){
		_t=_thres;
		_t+=_thres<<8;
		_t+=_t<<16;
		_t+=_t<<32;
		
	}

PVideoFrame __stdcall MedianBlurBin::GetFrame(int n, IScriptEnvironment* env)
{
	ticks=GetTickCount();
	if(!vi.IsYV12())
		env->ThrowError("only yv12 supported");
	iSSE=(env->GetCPUFlags()&CPUF_INTEGER_SSE)!=0;
	//iSSE=false;
	PVideoFrame src = child->GetFrame(n, env);

	PVideoFrame dst = env->NewVideoFrame(vi);

	if(_radiusy>0)
		_radius=_radiusy,_thres=_thresy,tinit(),N=1+2*_radius,CalcFrame(src,dst,PLANAR_Y);
	else if(_radiusy==0)
		env->BitBlt(dst->GetWritePtr(PLANAR_Y), dst->GetPitch(PLANAR_Y), src->GetReadPtr(PLANAR_Y), src->GetPitch(PLANAR_Y),src->GetRowSize(PLANAR_Y), src->GetHeight(PLANAR_Y));
	else if(_radiusy>-256)
		memset (dst->GetWritePtr(PLANAR_Y), -_radiusy, dst->GetPitch(PLANAR_Y)*dst->GetHeight(PLANAR_Y));
	if(_radiusu>0)
		_radius=_radiusu,_thres=_thresu,tinit(),N=1+2*_radius,CalcFrame(src,dst,PLANAR_U);
	else if(_radiusu==0)
		env->BitBlt(dst->GetWritePtr(PLANAR_U), dst->GetPitch(PLANAR_U), src->GetReadPtr(PLANAR_U), src->GetPitch(PLANAR_U),src->GetRowSize(PLANAR_U), src->GetHeight(PLANAR_U));
	else if(_radiusu>-256)
		memset (dst->GetWritePtr(PLANAR_U), -_radiusu, dst->GetPitch(PLANAR_U)*dst->GetHeight(PLANAR_U));
	if(_radiusv>0)
		_radius=_radiusv,_thres=_thresv,tinit(),N=1+2*_radius,CalcFrame(src,dst,PLANAR_V);
	else if(_radiusv==0)
		env->BitBlt(dst->GetWritePtr(PLANAR_V), dst->GetPitch(PLANAR_V), src->GetReadPtr(PLANAR_V), src->GetPitch(PLANAR_V),src->GetRowSize(PLANAR_V), src->GetHeight(PLANAR_V));
	else if(_radiusv>-256)
		memset (dst->GetWritePtr(PLANAR_V), -_radiusv, dst->GetPitch(PLANAR_V)*dst->GetHeight(PLANAR_V));
	ticks=GetTickCount()-ticks;
	env->SetVar("DEBUG",ticks);
	return dst;
}

BYTE MedianBlurBin::radixmedianInit (const BYTE *source,unsigned int pitch)
{
	n=0;
	unsigned int imedian=(N*N+1)>>1;
	if(iSSE)
	{
	
	n=iasm(N,N,source,pitch);
	}
	else
	{
		unsigned int i=0;
		for(unsigned int y=0;y<N;y++){
		for(unsigned int x=0;x<N;x++)
            n+=(source[i+x]>_thres);
		i+=pitch;}
		//for (unsigned int i=0; i<(N*N); i++ )
		//	n+=(source[i%N+(i/N)*pitch]>_thres);
	}
		
  	if(n<imedian)
		return(0);
	else
		return(255);



}


BYTE MedianBlurBin::radixmedianInitXY(const BYTE *source,unsigned int pitch,unsigned int X,unsigned int Y)
{
	x=X;
	n=0;
	unsigned int imedian=(x*Y+1)>>1;
	if(iSSE)
	{
		n=iasm(x,Y,source,pitch);
	}
	else
	{
	unsigned int i;
	for (i=0; i<(x*Y); i++ )
		n+=(source[i%N+(i/N)*pitch]>_thres);
	}
  	if(n<imedian)
		return(0);
	else
		return(255);
}

void MedianBlurBin::radixmedianRemove(const BYTE *source)
{
	
	if(iSSE)
	{
	n-=arasm(N,source);
	}
	else
	{
	unsigned int i;
	for (i=0; i<N; i++ )
		n-=(source[i]>_thres);
	}
	
}

BYTE MedianBlurBin::radixmedianRemoveXY(const BYTE *source,unsigned int Y)
{
	
	
	unsigned int imedian=(x*Y+1)>>1;
	if(iSSE)
		n-=arasm(x,source);
	else
	{
	for (unsigned int i=0; i<x; i++ )
		n-=(source[i]>_thres);
	}
  	if(n<imedian)
		return(0);
	else
		return(255);
}

void MedianBlurBin::radixmedianRemoveXY(const BYTE *source)
{
	if(iSSE)
		n-=arasm(x,source);
	else
	{
	 for (unsigned int i=0; i<x; i++ )
		n-=(source[i]>_thres);
	}
}

BYTE MedianBlurBin::radixmedianAdd(const BYTE *source)
{
	
	unsigned int imedian=(N*N+1)>>1;
	if(iSSE)
	{
	//int nn=n;
	//for (unsigned int i=0; i<N; i++ )
	//	n+=(source[i]>_thres);
	//if(nn+arasm(N,source)!=n)
	//	n=n;
	n+=arasm(N,source);
	}
	else
	{
	for (unsigned int i=0; i<N; i++ )
		n+=(source[i]>_thres);
	}
		
	
	if(n<imedian)
		return(0);
	else
		return(255);
}

BYTE MedianBlurBin::radixmedianAddXY(const BYTE *source,unsigned int Y)
{
	unsigned int imedian=(x*Y+1)>>1;
	if(iSSE)
		n+=arasm(x,source);
	else
	{
	for (unsigned int i=0; i<x; i++ )
		n+=(source[i]>_thres);
	}
	if(n<imedian)
		return(0);
	else
		return(255);
}

int MedianBlurBin::arasm(int x,const BYTE *source){
	__declspec(align(16)) unsigned __int64 ff=0xffffffffffffffff;
	__declspec(align(16)) unsigned __int64 fe=0xfefefefefefefefe;
	__declspec(align(16)) unsigned __int64 modu = (8-x%8)<<3;
	__declspec(align(16)) int retval=0xbadbad00;
	__declspec(align(16)) unsigned int nloop = x>>3;
	__int64 ta=_t;
		__asm {
	//edi source pointer
	//eax offset
	// edx inner loop(x)
	// ecx outer loop(y)
	mov edi,source
	movq mm4,[ff]			//FFFF x4 constant
	mov edx,nloop
	
	pxor mm2,mm2		//0 constant
	movq mm5,fe			//FEFE x 4 constant
	pxor mm3,mm3
	movq mm7,modu
	
	xor eax,eax			//offset 0
	movq mm1,[ta]	//threshold
	
	mov edx,nloop
	cmp edx,0
	jz lastx
xloop:
	movq mm0,[eax+edi]		//first 8 byte of source
	
							//source>threshold?01:00

	psubusb mm0,mm1			//source-thresholdmask
	pcmpeqb mm0,mm2			//if threhold>source->FF
	pxor mm0,mm4;			//invert result(00)
	psubusb mm0,mm5			//subtract FE from mask to get 01
	
	
	psadbw mm0,mm2		//number of bytes greater than threshold
	paddd mm3,mm0		//add to total sum
	add eax,8			//next 8 byte
	dec edx				//last part of line?
	jz lastx
	jmp xloop
lastx:					//use lshift >>8*mod
	movq mm0,[eax+edi]
	psrlq	mm1,mm7
	psubusb mm0,mm1
	pcmpeqb mm0,mm2
	psrlq mm4,mm7
	pxor mm0,mm4
	pand mm0,mm4
	psubusb mm0,mm5
	psadbw mm0,mm2
	paddd mm3,mm0
	add eax,8
		
	movd retval,mm3		
	
	emms	
		}
	return retval;
	}

int MedianBlurBin::iasm(int x,int y,const BYTE *source,unsigned int pitch){
	__declspec(align(16)) __int64 ta=_t;
	//__declspec(align(16)) int NN=x;
	__declspec(align(16)) unsigned __int64 ff=0xffffffffffffffff;
	__declspec(align(16)) unsigned __int64 fe=0xfefefefefefefefe;
	__declspec(align(16)) unsigned __int64 modu = (8-x%8)<<3;
	__declspec(align(16)) int retval=0xbadbad00;
	__declspec(align(16)) unsigned int nloop = x>>3;
	
		__asm {
	//edi source pointer
	//eax offset
	// edx inner loop(x)
	// ecx outer loop(y)
	mov edi,source
	
	mov edx,nloop
	mov ecx,y
	
	movq mm4,ff			//FFFF x4 constant
	pxor mm2,mm2		//0 constant
	movq mm5,fe			//FEFE x 4 constant
	pxor mm3,mm3
	movq mm7,modu
	

yloop:
	xor eax,eax			//offset 0
	movq mm1,[ta]	//threshold
	movq mm4,ff
	mov edx,nloop
	cmp edx,0
	jz lastx
xloop:
	movq mm0,[eax+edi]		//first 8 byte of source
	
							//source>threshold?01:00

	psubusb mm0,mm1			//source-thresholdmask
	pcmpeqb mm0,mm2			//if threhold>source->FF
	pxor mm0,mm4;			//invert result(00)
	psubusb mm0,mm5			//subtract FE from mask to get 01
	
	
	psadbw mm0,mm2		//number of bytes greater than threshold
	paddd mm3,mm0		//add to total sum
	add eax,8			//next 8 byte
	dec edx				//last part of line?
	jz lastx
	jmp xloop
lastx:					//use lshift >>8*mod
	movq mm0,[eax+edi]
	psrlq	mm1,mm7
	psubusb mm0,mm1
	pcmpeqb mm0,mm2
	psrlq mm4,mm7
	pxor mm0,mm4
	pand mm0,mm4
	psubusb mm0,mm5
	psadbw mm0,mm2
	paddd mm3,mm0
	add eax,8
	add edi,pitch
	dec ecx
	jnz yloop
	
	movd retval,mm3			
	
	emms	
	}
	return retval;
	}

//******************************************************************************************************************
//******************************************************************************************************************
//**************			MedianBlurTemp									****************************************
//******************************************************************************************************************
//******************************************************************************************************************
MedianBlurTemp::MedianBlurTemp(PClip cl1,int rady,int radu,int radv,int tradius,bool _MC,bool cb,bool _markscenechange,int blksize,int pel,int lambda, int thSCD1, int thSCD2,int searchparam,bool spfull,bool bsfull,IScriptEnvironment* env):
	MedianBlur(cl1,rady,radu,radv,cb,env),_trad(tradius),twidth((tradius<<1)+1),MC(_MC),markscenechange(_markscenechange),scenechange(false) 
	{
		if(MC){
			int idx=GetTickCount()%1024;
			clipa=new PClip[twidth];
			PClip vectors;
			AVSValue MVAnalyseArgs[]={child,blksize,pel,false,lambda,1,idx,searchparam};
			//AVSValue MVAnalyseArgs[]={child,blksize,pel,false,lambda,idx};
			const char *MVAnalyseArgsNames[]={0,"blksize","pel","isb","lambda","delta","idx","searchparam"};

			AVSValue MVCompensateArgs[]={child,vectors,thSCD1,thSCD2};
			const char *MVCompensateArgsNames[]={0,"vectors","thSCD1","thSCD2"};

			unsigned int i=0;
			for(int pf=_trad;pf>0;pf--){
				MVAnalyseArgs[5]=pf;
				vectors = env->Invoke("MVAnalyse",AVSValue(MVAnalyseArgs,8),MVAnalyseArgsNames).AsClip();
				MVCompensateArgs[1]=vectors;
				clipa[i++]=env->Invoke("MVCompensate",AVSValue(MVCompensateArgs,4),MVCompensateArgsNames).AsClip();

			}
			i++;
			MVAnalyseArgs[3]=true;
			if(!spfull)
				MVAnalyseArgs[7]=1;
			if(!bsfull)
				MVAnalyseArgs[7]=1;
			for(int pf=1;pf<=_trad;pf++){
				MVAnalyseArgs[5]=pf;
				vectors =  env->Invoke("MVAnalyse",AVSValue(MVAnalyseArgs,8),MVAnalyseArgsNames).AsClip();
				MVCompensateArgs[1]=vectors;
				clipa[i++]=env->Invoke("MVCompensate",AVSValue(MVCompensateArgs,4),MVCompensateArgsNames).AsClip();
			}
		}
	
	
	
	
	
	
	}
MedianBlurTemp::~MedianBlurTemp()
{
	delete[] clipa;
}

PVideoFrame __stdcall MedianBlurTemp::GetFrame(int n, IScriptEnvironment* env)
{
	ticks=GetTickCount();
	if(!vi.IsYV12())
		env->ThrowError("only yv12 supported");
	PVideoFrame src = child->GetFrame(n, env);

	PVideoFrame dst = env->NewVideoFrame(vi);

	if(src->GetPitch(1)!=dst->GetPitch(1))
		Alignpitch(src,env);

	//CalcSrca

	srca = new PVideoFrame[twidth];
	if(MC){

	unsigned int i=0;
	for(int pf=_trad;pf>0;pf--){
		srca[i]=clipa[i]->GetFrame(n,env);
		if(srca[i]->GetPitch(1)!=dst->GetPitch(1))
			Alignpitch(srca[i],env);
		i++;
	}
	srca[i++]=src;
	for(int pf=1;pf<=_trad;pf++){

		srca[i]=clipa[i]->GetFrame(n,env);
		if(srca[i]->GetPitch(1)!=dst->GetPitch(1))
			Alignpitch(srca[i],env);
		i++;
	}
	if(markscenechange&&_trad)
		if(srca[0]->GetReadPtr(PLANAR_Y)==src->GetReadPtr(PLANAR_Y)||srca[twidth-1]->GetReadPtr(PLANAR_Y)==src->GetReadPtr(PLANAR_Y))
			scenechange=true;
		else
			scenechange=false;
	}
	else
	for(unsigned int i=0;i<twidth;i++)
		srca[i]=child->GetFrame(n+(i-_trad),env);
		


	if(_radiusy>=0)
		_radius=_radiusy,N=1+2*_radius,CalcFrame(src,dst,PLANAR_Y,n,env);
	else if(_radiusy==-1)
		env->BitBlt(dst->GetWritePtr(PLANAR_Y), dst->GetPitch(PLANAR_Y), src->GetReadPtr(PLANAR_Y), src->GetPitch(PLANAR_Y),src->GetRowSize(PLANAR_Y), src->GetHeight(PLANAR_Y));
	else if(_radiusy>-256)
		memset (dst->GetWritePtr(PLANAR_Y), -_radiusy, dst->GetPitch(PLANAR_Y)*dst->GetHeight(PLANAR_Y));
	if(_radiusu>=0)
		_radius=_radiusu,N=1+2*_radius,CalcFrame(src,dst,PLANAR_U,n,env);
	else if(_radiusu==-1)
		env->BitBlt(dst->GetWritePtr(PLANAR_U), dst->GetPitch(PLANAR_U), src->GetReadPtr(PLANAR_U), src->GetPitch(PLANAR_U),src->GetRowSize(PLANAR_U), src->GetHeight(PLANAR_U));
	else if(_radiusu>-256)
		memset (dst->GetWritePtr(PLANAR_U), -_radiusu, dst->GetPitch(PLANAR_U)*dst->GetHeight(PLANAR_U));
	if(_radiusv>=0)
		_radius=_radiusv,N=1+2*_radius,CalcFrame(src,dst,PLANAR_V,n,env);
	else if(_radiusv==-1)
		env->BitBlt(dst->GetWritePtr(PLANAR_V), dst->GetPitch(PLANAR_V), src->GetReadPtr(PLANAR_V), src->GetPitch(PLANAR_V),src->GetRowSize(PLANAR_V), src->GetHeight(PLANAR_V));
	else if(_radiusv>-256)
		memset (dst->GetWritePtr(PLANAR_V), -_radiusv, dst->GetPitch(PLANAR_V)*dst->GetHeight(PLANAR_V));
		if(scenechange){
		BYTE *dstp=dst->GetWritePtr(PLANAR_Y);
		unsigned int pitch=dst->GetPitch(PLANAR_Y);
		unsigned int height=dst->GetHeight(PLANAR_Y);
		unsigned int i,j;
		for(i=1;i<(height>>4);i++)
			for(j=1;j<(pitch>>4);j++)
				dstp[j+i*pitch]=128;			
		
		dstp=dst->GetWritePtr(PLANAR_U);
		pitch=dst->GetPitch(PLANAR_U);
		height=dst->GetHeight(PLANAR_U);
		for(i=1;i<(height>>4);i++)
			for(j=1;j<(pitch>>4);j++)
				dstp[j+i*pitch]=1;
		
		dstp=dst->GetWritePtr(PLANAR_V);
		pitch=dst->GetPitch(PLANAR_V);
		height=dst->GetHeight(PLANAR_V);
		for(i=1;i<(height>>4);i++)
			for(j=1;j<(pitch>>4);j++)
				dstp[j+i*pitch]=255;
	}
	delete[] srca;
	ticks=GetTickCount()-ticks;
    env->SetVar("DEBUG",ticks);
	return dst;
}

void MedianBlurTemp::Alignpitch(PVideoFrame &src1,IScriptEnvironment* env){
	PVideoFrame temp=src1;
	src1=env->NewVideoFrame(vi);
	for(unsigned int plane=1;plane<8;plane<<=1){
		unsigned int pitch=src1->GetPitch(plane);
		unsigned int old_pitch=temp->GetPitch(plane);
		unsigned int height=src1->GetHeight(plane);
		unsigned int rowsize=src1->GetRowSize(plane);
		BYTE* dstp=src1->GetWritePtr(plane);
		const BYTE* srcp=temp->GetReadPtr(plane);
        env->BitBlt(dstp,pitch, srcp, old_pitch, rowsize, height);


		
	}
}

void MedianBlurTemp::CalcFrame(PVideoFrame &src, PVideoFrame &dst, int plane,int nframe, IScriptEnvironment* env)
{
	srcpa = new const BYTE*[twidth];
	for(unsigned int i=0;i<twidth;i++)
		srcpa[i]=srca[i]->GetReadPtr(plane);


	const BYTE* srcp = src->GetReadPtr(plane);
	BYTE* dstp = dst->GetWritePtr(plane);
	
	const unsigned int dst_pitch = dst->GetPitch(plane);
	const unsigned int dst_width = dst->GetRowSize(plane);
	const unsigned int dst_height = dst->GetHeight(plane);
	
	const unsigned int src_pitch = src->GetPitch(plane);
	const unsigned int src_width = src->GetRowSize(plane);
	const unsigned int src_height = src->GetHeight(plane);
	const unsigned int vecsize =(_radius+2)*(_radius+2); 
	
	if(src_height<N||src_width<N)
		return;

	if(!calcborder||_radius==0)
	{
	
	for(w=_radius;w<dst_width-_radius;w++){
		h=_radius;
		unsigned int soffset=w-_radius;
		*(dstp+(w+h*dst_pitch))=radixmedianInit(soffset,src_pitch);
		radixmedianRemove(soffset);
		unsigned int aoffset=soffset+(2*_radius+1)*src_pitch;
		unsigned int roffset=soffset+src_pitch;
		for(h=_radius+1;h<dst_height-_radius;h++){
			*(dstp+(h*dst_pitch+w))=radixmedianAdd(aoffset);
			radixmedianRemove(roffset);
			aoffset+=src_pitch;
			roffset+=src_pitch;
			}
	}
		
	for(w=0;w<dst_width;w++){
		for(h=dst_height-_radius;h<dst_height;h++)
			dstp[h*dst_pitch+w]=srcp[h*src_pitch+w];
		for(h=0;h<_radius;h++)
			dstp[h*dst_pitch+w]=srcp[h*src_pitch+w];
	}
	for(h=_radius;h<dst_height-_radius;h++){
		for(w=0;w<_radius;w++)
			dstp[h*dst_pitch+w]=srcp[h*src_pitch+w];
		for(w=dst_width-_radius;w<dst_width;w++)
			dstp[h*dst_pitch+w]=srcp[h*src_pitch+w];
	}
	}
	else
	{
	
	for(w=0;w<_radius;w++){
		*(dstp+w)=radixmedianInitXY(0,src_pitch,w+_radius+1,_radius+1);
		h=1;
		for(;h<_radius;h++)
			*(dstp+w+h*dst_pitch)=radixmedianAddXY((h+_radius)*src_pitch,_radius+h+1);
		for(;h<src_height-_radius-1;h++){
			*(dstp+w+h*dst_pitch)=radixmedianAddXY((h+_radius)*src_pitch,N);
			radixmedianRemoveXY((h-_radius)*src_pitch);
		}
		*(dstp+w+h*dst_pitch)=radixmedianAddXY((h+_radius)*src_pitch,N);
		h++;
		for(;h<src_height;h++)
			*(dstp+w+h*dst_pitch)=radixmedianRemoveXY((h-_radius-1)*src_pitch,src_height-h+_radius);
	}
	for(;w<src_width-_radius;w++){
		*(dstp+w)=radixmedianInitXY(w-_radius,src_pitch,N,_radius+1);
		h=1;
		for(;h<_radius;h++)
			*(dstp+w+h*dst_pitch)=radixmedianAddXY(w-_radius+(h+_radius)*src_pitch,_radius+h+1);
		for(unsigned int aoffset=w-_radius+(h+_radius)*src_pitch, roffset=w-_radius+(h-_radius)*src_pitch;h<src_height-_radius-1;h++,aoffset+=src_pitch,roffset+=src_pitch){
			*(dstp+w+h*dst_pitch)=radixmedianAdd(aoffset);
			radixmedianRemove(roffset);
		}
		*(dstp+w+h*dst_pitch)=radixmedianAdd(w-_radius+(h+_radius)*src_pitch);
		h++;
		for(;h<src_height;h++)
			*(dstp+w+h*dst_pitch)=radixmedianRemoveXY(w-_radius+(h-_radius-1)*src_pitch,src_height-h+_radius);
	}
	for(;w<src_width;w++){
		*(dstp+w)=radixmedianInitXY(w-_radius,src_pitch,src_width-w+_radius,_radius+1);
		h=1;
		for(;h<_radius;h++)
			*(dstp+w+h*dst_pitch)=radixmedianAddXY(w-_radius+(h+_radius)*src_pitch,_radius+h+1);
		for(;h<src_height-_radius-1;h++){
			*(dstp+w+h*dst_pitch)=radixmedianAddXY(w-_radius+(h+_radius)*src_pitch,N);
			radixmedianRemoveXY(w-_radius+(h-_radius)*src_pitch);
		}
		*(dstp+w+h*dst_pitch)=radixmedianAddXY(w-_radius+(h+_radius)*src_pitch,N);
		h++;
		for(;h<src_height;h++)
			*(dstp+w+h*dst_pitch)=radixmedianRemoveXY(w-_radius+(h-_radius)*src_pitch,src_height-h+_radius);
	}
	}
	//delete[] srca;
	delete[] srcpa;
}


BYTE MedianBlurTemp::radixmedianInit (unsigned int offset,unsigned int pitch)
{
	memset (count, 0, sizeof (count));
	n=0;
	unsigned int i,j;
	const BYTE* source=0;
	for(j=0;j<twidth;j++)
	{
		source=srcpa[j]+offset;
		i=0;
		for(unsigned int y=0;y<N;y++){
			for(unsigned int x=0;x<N;x++)
				count[source[i+x]]++;
			i+=pitch;}

	}
	for (i=0;n<((twidth*N*N+1)>>1);i++)
		n=n+count[i];
	i--;
	median=i;	
	return(i);
}


BYTE MedianBlurTemp::radixmedianInitXY(unsigned int offset,unsigned int pitch,unsigned int X,unsigned int Y)
{
	memset (count, 0, sizeof (count));
	x=X;
	n=0;

	unsigned int i,j;
	const BYTE* source=0;
	for(j=0;j<twidth;j++)
	{
		source=srcpa[j]+offset;
		i=0;
		for(unsigned int yo=0;yo<Y;yo++){
			for(unsigned int xo=0;xo<X;xo++)
				count[source[i+xo]]++;
			i+=pitch;}

	}
	for (i=0;n<((twidth*x*Y+1)>>1);i++)
		n=n+count[i];
	i--;
	median=i;
	return(i);
}

void MedianBlurTemp::radixmedianRemove(unsigned int _offset)
{
#ifdef ASM
		unsigned int j=0;
		__asm{
		//i(loop counter)=ecx,source[i]=ebx,n=eax,median=edx
		
		mov esi,this
				
		mov edx,[esi+median]
		mov eax,[esi+n]
		
		xor ebx,ebx
L0:
		mov edi,[esi+srcpa]
		mov edi,[edi+4*ebx]
		
		//mov ebx,[ebp+8]
		mov ebx,[_offset]
		lea edi,[edi+ebx  ]
		mov ecx,[esi+N]
L1:
		
		
		
		dec ecx
		jz	i0
		
		movzx ebx,byte ptr [edi+ecx]
		dec dword ptr [esi+4*ebx+count]
		cmp edx,ebx
		adc eax,0xFFFFFFFF

		jmp L1
i0:	
		movzx ebx,byte ptr [edi]
		dec dword ptr [esi+4*ebx+count]
		cmp edx,ebx
		adc eax,0xFFFFFFFF

		
		mov ebx,j
		inc ebx
		mov j,ebx
		cmp ebx,[esi+twidth]  
		jnz L0
		mov [esi+n],eax
	}

#else
	unsigned int i,j;
	const BYTE* source=0;

	for(j=0;j<twidth;j++){
		source=srcpa[j]+_offset;
		for (i=0; i<N; i++ ){
			count[source[i]]--;
			if(source[i]<=median)
				n--;
		}
	}
#endif
}

BYTE MedianBlurTemp::radixmedianRemoveXY(unsigned int offset,unsigned int Y)
{
	
	unsigned int imedian=(twidth*x*Y+1)>>1;
	unsigned int i,j;
	const BYTE* source=0;
	
		


	for(j=0;j<twidth;j++){
		source=srcpa[j]+offset;
		for (i=0; i<x; i++ ){
			count[source[i]]--;
			if(source[i]<=median)
				n--;
		}
	}
	
	if(n<imedian){
		for(i=median+1;n<imedian;i++)
			n=n+count[i];
		i--;
	}
	else if(n==imedian&&(n-count[median])<imedian) 
		return(median);
	else{
		for(i=median;n-count[i]>=imedian;i--)
			n=n-count[i];
		}
	median=i;
	return(i);
}

void MedianBlurTemp::radixmedianRemoveXY(unsigned int offset)
{
	unsigned int i,j;
	const BYTE* source=0;
	for(j=0;j<twidth;j++){
		source=srcpa[j]+offset;
		for (i=0; i<x; i++ ){
			count[source[i]]--;
			if(source[i]<=median)
				n--;
		}
	}
}

BYTE MedianBlurTemp::radixmedianAdd(unsigned int _offset)
{
	unsigned int imedian=(twidth*N*N+1)>>1;
	unsigned int i,j;
	#ifdef ASM
		j=0;
		__asm{
		//i(loop counter)=ecx,source[i]=ebx,n=eax,median=edx
		
		mov esi,this
				
		mov edx,[esi+median]
		mov eax,[esi+n]
		
		xor ebx,ebx
L0:
		mov edi,[esi+srcpa]
		mov edi,[edi+4*ebx]
		
		//mov ebx,[ebp+8]
		mov ebx,[_offset]
		lea edi,[edi+ebx  ]
		mov ecx,[esi+N]
L1:
		dec ecx
		jz	i0
		
		movzx ebx,byte ptr [edi+ecx]
		inc dword ptr [esi+4*ebx+count]
		cmp edx,ebx
		sbb eax,0xFFFFFFFF

		jmp L1
i0:	
		movzx ebx,byte ptr [edi]
		inc dword ptr [esi+4*ebx+count]
		cmp edx,ebx
		sbb eax,0xFFFFFFFF

		mov ebx,j
		inc ebx
		mov j,ebx
		cmp ebx,[esi+twidth]  //?
		jnz L0

		mov [esi+n],eax
	}

#else
		
	
	const BYTE* source=0;
	for(j=0;j<twidth;j++){
		source=srcpa[j]+_offset;
		for (i=0; i<N; i++ ){
			count[source[i]]++;
			if(source[i]<=median)
				n++;
		}
	}
#endif



	if(n<imedian){
		for(i=median+1;n<imedian;i++)
			n=n+count[i];
		i--;
	}
	else if((n==imedian&&n-count[median]<imedian)) //||(n-count[median])<imedian) 
		return(median);
	else{
		for(i=median;n-count[i]>=imedian;i--)
			n=n-count[i];
		}
	median=i;
	return(i);
}

BYTE MedianBlurTemp::radixmedianAddXY(unsigned int offset,unsigned int Y)
{
	unsigned int imedian=(twidth*x*Y+1)>>1;
	unsigned int i,j;
	const BYTE* source=0;
	for(j=0;j<twidth;j++){
		source=srcpa[j]+offset;
		for (i=0; i<x; i++ ){
			count[source[i]]++;
			if(source[i]<=median)
				n++;
		}
	}
	if(n<imedian){
		for(i=median+1;n<imedian;i++)
			n=n+count[i];
		i--;
	}
	else if(n==imedian&&(n-count[median])<imedian) 
		return(median);
	else{
		for(i=median;n-count[i]>=imedian;i--)
			n=n-count[i];
		}
	median=i;
	return(i);
}

//******************************************************************************************************************
//******************************************************************************************************************
//**************			MedianBlurMMX									****************************************
//******************************************************************************************************************
//******************************************************************************************************************
MedianBlurMMX::MedianBlurMMX(PClip cl1,int rady,int radu,int radv,bool cb,IScriptEnvironment* env):
	MedianBlur(cl1,rady,radu,radv,cb,env)
	{}

	PVideoFrame __stdcall MedianBlurMMX::GetFrame(int n, IScriptEnvironment* env)
{
	ticks=GetTickCount();
	if(!vi.IsYV12())
		env->ThrowError("only yv12 supported");
	bool iSSE=(env->GetCPUFlags()&CPUF_INTEGER_SSE)!=0;
	//iSSE=false;
	PVideoFrame src = child->GetFrame(n, env);
	PVideoFrame dst = env->NewVideoFrame(vi);

	if((_radiusy>3&&iSSE)||(_radiusy>0&&!iSSE))
		_radius=_radiusy,N=1+2*_radius,CalcFrame(src,dst,PLANAR_Y);
	else if(_radiusy>0)
		_radius=_radiusy,N=1+2*_radius,CalcFrameMMX(src,dst,PLANAR_Y);
	else if(_radiusy==0)
		env->BitBlt(dst->GetWritePtr(PLANAR_Y), dst->GetPitch(PLANAR_Y), src->GetReadPtr(PLANAR_Y), src->GetPitch(PLANAR_Y),src->GetRowSize(PLANAR_Y), src->GetHeight(PLANAR_Y));
	else if(_radiusy>-256)
		memset (dst->GetWritePtr(PLANAR_Y), -_radiusy, dst->GetPitch(PLANAR_Y)*dst->GetHeight(PLANAR_Y));
	if((_radiusu>3&&iSSE)||(_radiusu>0&&!iSSE))
		_radius=_radiusu,N=1+2*_radius,CalcFrame(src,dst,PLANAR_U);
	else if(_radiusu>0)
		_radius=_radiusu,N=1+2*_radius,CalcFrameMMX(src,dst,PLANAR_U);
	else if(_radiusu==0)
		env->BitBlt(dst->GetWritePtr(PLANAR_U), dst->GetPitch(PLANAR_U), src->GetReadPtr(PLANAR_U), src->GetPitch(PLANAR_U),src->GetRowSize(PLANAR_U), src->GetHeight(PLANAR_U));
	else if(_radiusu>-256)
		memset (dst->GetWritePtr(PLANAR_U), -_radiusu, dst->GetPitch(PLANAR_U)*dst->GetHeight(PLANAR_U));
	if((_radiusv>3&&iSSE)||(_radiusv>0&&!iSSE))
		_radius=_radiusv,N=1+2*_radius,CalcFrame(src,dst,PLANAR_V);
	else if(_radiusv>0)
		_radius=_radiusv,N=1+2*_radius,CalcFrameMMX(src,dst,PLANAR_V);
	else if(_radiusv==0)
		env->BitBlt(dst->GetWritePtr(PLANAR_V), dst->GetPitch(PLANAR_V), src->GetReadPtr(PLANAR_V), src->GetPitch(PLANAR_V),src->GetRowSize(PLANAR_V), src->GetHeight(PLANAR_V));
	else if(_radiusv>-256)
		memset (dst->GetWritePtr(PLANAR_V), -_radiusv, dst->GetPitch(PLANAR_V)*dst->GetHeight(PLANAR_V));
	
	ticks=GetTickCount()-ticks;
	env->SetVar("DEBUG",ticks);
	return dst;
}

void MedianBlurMMX::CalcFrameMMX(PVideoFrame &src, PVideoFrame &dst, int plane)
{
	
	const BYTE* srcp = src->GetReadPtr(plane);
	BYTE* dstp = dst->GetWritePtr(plane);
	
	const unsigned int dst_pitch = dst->GetPitch(plane);
	const unsigned int dst_width = dst->GetRowSize(plane);
	const unsigned int dst_height = dst->GetHeight(plane);
	
	const unsigned int src_pitch = src->GetPitch(plane);
	const unsigned int src_width = src->GetRowSize(plane);
	const unsigned int src_height = src->GetHeight(plane);

	
	if(src_height<N||src_width<N)
		return;

	if(!calcborder)
	{
	
	for(w=dst_width-_radius-(dst_width-2*_radius)%8;w<dst_width-_radius;w++){
		h=_radius;
		*(dstp+(w+h*dst_pitch))=radixmedianInit(srcp+w-_radius,src_pitch);
		radixmedianRemove(srcp+w-_radius);
		for(h=_radius+1;h<dst_height-_radius;h++){
			*(dstp+(h*dst_pitch+w))=radixmedianAdd(srcp+w-_radius+(h+_radius)*src_pitch);
			radixmedianRemove(srcp+w-_radius+(h-_radius)*src_pitch);
			}
	}

	for(w=_radius;w<dst_width-_radius-16;w+=16)
		for(h=_radius;h<dst_height-_radius;h++)
			CalcBatcherMedian16(N,N,src_pitch,srcp+w-_radius+(h-_radius)*src_pitch,dstp+w+h*dst_pitch);
			//CalcMedian16(N,N,src_pitch,srcp+w-_radius+(h-_radius)*src_pitch,dstp+w+h*dst_pitch);
	w=dst_width-_radius-16;
	for(h=_radius;h<dst_height-_radius;h++)
		//CalcMedian(N,N,src_pitch,srcp+w-_radius+(h-_radius)*src_pitch,dstp+w+h*dst_pitch);
		CalcBatcherMedian16(N,N,src_pitch,srcp+w-_radius+(h-_radius)*src_pitch,dstp+w+h*dst_pitch);
	
	//125(1) 141(2) 141(3)	141(4) 157(5) 157(6) 156(7) 312/328sse 
		
	for(w=0;w<dst_width;w++){
		for(h=dst_height-_radius;h<dst_height;h++)
			dstp[h*dst_pitch+w]=srcp[h*src_pitch+w];
		for(h=0;h<_radius;h++)
			dstp[h*dst_pitch+w]=srcp[h*src_pitch+w];
	}
	for(h=_radius;h<dst_height-_radius;h++){
		for(w=0;w<_radius;w++)
			dstp[h*dst_pitch+w]=srcp[h*src_pitch+w];
		for(w=dst_width-_radius;w<dst_width;w++)
			dstp[h*dst_pitch+w]=srcp[h*src_pitch+w];
	}
	}
	else
	{

	for(w=0;w<_radius;w++){
		*(dstp+w)=radixmedianInitXY(srcp,src_pitch,w+_radius+1,_radius+1);
		h=1;
		for(;h<_radius;h++)
			*(dstp+w+h*dst_pitch)=radixmedianAddXY(srcp+(h+_radius)*src_pitch,_radius+h+1);
		for(;h<src_height-_radius-1;h++){
			*(dstp+w+h*dst_pitch)=radixmedianAddXY(srcp+(h+_radius)*src_pitch,N);
			radixmedianRemoveXY(srcp+(h-_radius)*src_pitch);
		}
		*(dstp+w+h*dst_pitch)=radixmedianAddXY(srcp+(h+_radius)*src_pitch,N);
		h++;
		for(;h<src_height;h++)
			*(dstp+w+h*dst_pitch)=radixmedianRemoveXY(srcp+(h-_radius)*src_pitch,src_height-h+_radius);
	}
	for(;w<dst_width-_radius-16;w+=16){
		CalcMedian16(N,_radius+1,src_pitch,srcp+w-_radius,dstp+w);

		h=1;
		for(;h<_radius;h++)
			CalcMedian16(N,_radius+h+1,src_pitch,srcp+w-_radius,dstp+w+h*dst_pitch);

		for(;h<src_height-_radius;h++){
			CalcBatcherMedian16(N,N,src_pitch,srcp+w-_radius+(h-_radius)*src_pitch,dstp+w+h*dst_pitch);

		}
		for(;h<src_height;h++)
			CalcMedian16(N,src_height-h+_radius,src_pitch,srcp+w-_radius+(h-_radius)*src_pitch,dstp+w+h*dst_pitch);

	}

		w=dst_width-_radius-16;
		CalcMedian16(N,_radius+1,src_pitch,srcp+w-_radius,dstp+w);

		h=1;
		for(;h<_radius;h++)
			CalcMedian16(N,_radius+h+1,src_pitch,srcp+w-_radius,dstp+w+h*dst_pitch);

		for(;h<src_height-_radius;h++){
			CalcBatcherMedian16(N,N,src_pitch,srcp+w-_radius+(h-_radius)*src_pitch,dstp+w+h*dst_pitch);

		}
		for(;h<src_height;h++)
			CalcMedian16(N,src_height-h+_radius,src_pitch,srcp+w-_radius+(h-_radius)*src_pitch,dstp+w+h*dst_pitch);
	for(w=dst_width-_radius;w<src_width;w++){
		*(dstp+w)=radixmedianInitXY(srcp+w-_radius,src_pitch,src_width-w+_radius,_radius+1);
		h=1;
		for(;h<_radius;h++)
			*(dstp+w+h*dst_pitch)=radixmedianAddXY(srcp+w-_radius+(h+_radius)*src_pitch,_radius+h+1);
		for(;h<src_height-_radius-1;h++){
			*(dstp+w+h*dst_pitch)=radixmedianAddXY(srcp+w-_radius+(h+_radius)*src_pitch,N);
			radixmedianRemoveXY(srcp+w-_radius+(h-_radius)*src_pitch);
		}
		*(dstp+w+h*dst_pitch)=radixmedianAddXY(srcp+w-_radius+(h+_radius)*src_pitch,N);
		h++;
		for(;h<src_height;h++)
			*(dstp+w+h*dst_pitch)=radixmedianRemoveXY(srcp+w-_radius+(h-_radius)*src_pitch,src_height-h+_radius);
	}
	}
}

void MedianBlurMMX::CalcMedian(unsigned int x,unsigned int y,unsigned int pitch,const BYTE *srcp,BYTE* dstp){
	unsigned int arraysize=x*y;
	
	unsigned int median=(arraysize+1)>>1;
	__declspec(align(16)) void* buffer= new BYTE[arraysize][8];
	_asm{
		xor eax,eax
		//mov edx,eax
		mov edx,y
		xor ecx,ecx
		mov edi,srcp	//edi src
		mov esi,buffer	//esi buffer
		
		movq mm2,[edi]
		inc eax
		
initloop:
		movq mm1,mm2
		movq mm2,[edi+eax]
		movq mm3,mm1
		pminub mm1,mm2		//mm1<mm2
		pmaxub mm2,mm3
		movq [esi+ecx],mm1
		
		add ecx,8
		inc eax
		cmp eax,x
		jne initloop

		xor eax,eax
		add edi,pitch
		
		dec edx
		jnz initloop
		

//bubblesort
		//ecx=arraysize
		mov edx,median
		dec edx
		shl edx,3
outerloop:
		sub ecx,8
		xor eax,eax		//eax innerloop count
		
		movq mm2,[esi]
innerloop:
		movq mm1,mm2
		movq mm2,[esi+eax+8]
		movq mm3,mm1
		pminub mm1,mm2		//mm1<mm2
		pmaxub mm2,mm3
		movq [esi+eax],mm1
		add eax,8
		cmp eax,ecx
		jne innerloop
		
		cmp ecx,edx
		jne outerloop
		mov edi,dstp
		movq [edi],mm2

		emms
	}

		delete[] buffer;
	}


void MedianBlurMMX::CalcMedian16(unsigned int x,unsigned int y,unsigned int pitch,const BYTE *srcp,BYTE* dstp){
	unsigned int arraysize=x*y;
	
	unsigned int median=(arraysize+1)>>1;
	__declspec(align(16)) void* buffer= new BYTE[arraysize][16];
	_asm{
		xor eax,eax
		//mov edx,eax
		mov edx,y
		xor ecx,ecx
		mov edi,srcp	//edi src
		mov esi,buffer	//esi buffer
		
		movq mm2,[edi]
		movq mm5,[edi+8]
		inc eax
		
initloop:
		movq mm1,mm2
		movq mm4,mm5
		movq mm2,[edi+eax]
		movq mm5,[edi+eax+8]
		movq mm3,mm1
		movq mm6,mm4
		pminub mm1,mm2		//mm1<mm2
		pminub mm4,mm5
		pmaxub mm2,mm3
		pmaxub mm5,mm6
		movq [esi+ecx],mm1
		movq [esi+ecx+8],mm4
		add ecx,16
		inc eax
		cmp eax,x
		jne initloop

		xor eax,eax
		add edi,pitch
		
		dec edx
		jnz initloop
		

//bubblesort
		//ecx=arraysize
		mov edx,median
		dec edx
		shl edx,4
outerloop:
		sub ecx,16
		xor eax,eax		//eax innerloop count
		
		movq mm2,[esi]
		movq mm5,[esi+8]
innerloop:
		movq mm1,mm2
		movq mm4,mm5
		movq mm2,[esi+eax+16]
		movq mm5,[esi+eax+24]
		movq mm3,mm1
		movq mm6,mm4
		pminub mm1,mm2		//mm1<mm2
		pminub mm4,mm5
		pmaxub mm2,mm3
		pmaxub mm5,mm6
		movq [esi+eax],mm1
		movq [esi+eax+8],mm4
		add eax,16
		cmp eax,ecx
		jne innerloop
		
		cmp ecx,edx
		jne outerloop
		mov edi,dstp
		movq [edi],mm2
		movq [edi+8],mm5

		emms
	}

		delete[] buffer;
	}

void MedianBlurMMX::CalcBatcherMedian16(unsigned int x,unsigned int y,unsigned int pitch,const BYTE *srcp,BYTE *dstp){
	unsigned int arraysize=x*y;
	__declspec(align(16)) BYTE (*buffer)[16]= new BYTE[arraysize][16];
	
	if(arraysize==49)
	__asm{
		mov edi,buffer
		mov esi,srcp
		mov eax,pitch
		
		MEDIAN16_3

		mov edi,dstp
		movq [edi],mm2
		movq [edi+8],mm5
		emms
	}
	else if(arraysize==25)
		__asm{
		mov edi,buffer
		mov esi,srcp
		mov eax,pitch

		MEDIAN16_2

		mov edi,dstp
		movq [edi],mm2
		movq [edi+8],mm5
		emms
	}
	else if(arraysize==9)
				__asm{
		mov edi,buffer
		mov esi,srcp
		mov eax,pitch

		MEDIAN16_1

		mov edi,dstp
		movq [edi],mm2
		movq [edi+8],mm5
		emms
	}

delete[] buffer;
}


//******************************************************************************************************************
//******************************************************************************************************************
//**************					ML3Dex									****************************************
//******************************************************************************************************************
//******************************************************************************************************************

ML3Dex::ML3Dex(PClip cl1,bool _MC,int y,int u, int v,bool _markscenechange,int blksize,int pel,int lambda, int thSCD1, int thSCD2,int searchparam,bool spfull,bool bsfull,IScriptEnvironment* env) : 
GenericVideoFilter(cl1),MC(_MC),_y(y),_u(u),_v(v),markscenechange(_markscenechange),iSSE(true),scenechange(false)
{
	PClip vectors;
	int idx=GetTickCount()%1024;
	AVSValue MVAnalyseArgs[]={child,blksize,pel,false,lambda,idx,searchparam};
	const char *MVAnalyseArgsNames[]={0,"blksize","pel","isb","lambda","idx","searchparam"};
	
	//markscenechange=_markscenechange;

	vectors = env->Invoke("MVAnalyse",AVSValue(MVAnalyseArgs,7),MVAnalyseArgsNames).AsClip();
	AVSValue MVCompensateArgs[4]={child,vectors,thSCD1,thSCD2};
	const char *MVCompensateArgsNames[]={0,"vectors","thSCD1","thSCD2"};
	
	clipa[0]=env->Invoke("MVCompensate",AVSValue(MVCompensateArgs,4),MVCompensateArgsNames).AsClip();
	
	MVAnalyseArgs[3]=true;
	if(!spfull)
				MVAnalyseArgs[6]=1;
	if(!bsfull)
				MVAnalyseArgs[1]=8;
    vectors = env->Invoke("MVAnalyse",AVSValue(MVAnalyseArgs,7),MVAnalyseArgsNames).AsClip();
	MVCompensateArgs[1]=vectors;
	clipa[2]=env->Invoke("MVCompensate",AVSValue(MVCompensateArgs,4),MVCompensateArgsNames).AsClip();


}

PVideoFrame __stdcall ML3Dex::GetFrame(int n, IScriptEnvironment* env)
{
	ticks=GetTickCount();
	if(!vi.IsYV12())
		env->ThrowError("only yv12 supported");
	iSSE=(env->GetCPUFlags()&CPUF_INTEGER_SSE)!=0;
	
	PVideoFrame src = child->GetFrame(n, env);
	PVideoFrame dst = env->NewVideoFrame(vi);
	if(src->GetPitch(1)!=dst->GetPitch(1))
		Alignpitch(src,env);
	//CalcSrca

	if(MC){
	
	srca[0]=clipa[0]->GetFrame(n,env);
	srca[1]=src;
	srca[2]=clipa[2]->GetFrame(n,env);

	if(markscenechange)
		if(srca[0]->GetReadPtr(PLANAR_Y)==srca[1]->GetReadPtr(PLANAR_Y)||srca[2]->GetReadPtr(PLANAR_Y)==srca[1]->GetReadPtr(PLANAR_Y))
			scenechange=true;
		else
			scenechange=false;
	}
	else{
	srca[0]=child->GetFrame(n-1,env);
	srca[1]=src;
	srca[2]=child->GetFrame(n+1,env);
	}	
	if(srca[0]->GetPitch(1)!=dst->GetPitch(1))
		Alignpitch(srca[0],env);
	if(srca[2]->GetPitch(1)!=dst->GetPitch(1))
		Alignpitch(srca[2],env);

	if(_y==3)
		CalcFrame(PLANAR_Y,src,dst);
	else if(_y=2)
		env->BitBlt(dst->GetWritePtr(PLANAR_Y), dst->GetPitch(PLANAR_Y), src->GetReadPtr(PLANAR_Y), src->GetPitch(PLANAR_Y),src->GetRowSize(PLANAR_Y), src->GetHeight(PLANAR_Y));
	else if(_y<1&&_y>-256)
		memset (dst->GetWritePtr(PLANAR_Y), -_y, dst->GetPitch(PLANAR_Y)*dst->GetHeight(PLANAR_Y));

	if(_u==3)
		CalcFrame(PLANAR_U,src,dst);
	else if(_u=2)
		env->BitBlt(dst->GetWritePtr(PLANAR_U), dst->GetPitch(PLANAR_U), src->GetReadPtr(PLANAR_U), src->GetPitch(PLANAR_U),src->GetRowSize(PLANAR_U), src->GetHeight(PLANAR_U));
	else if(_u<1&&_u>-256)
		memset (dst->GetWritePtr(PLANAR_U), -_u, dst->GetPitch(PLANAR_U)*dst->GetHeight(PLANAR_U));


	if(_v==3)
		CalcFrame(PLANAR_V,src,dst);
	else if(_v=2)
		env->BitBlt(dst->GetWritePtr(PLANAR_V), dst->GetPitch(PLANAR_V), src->GetReadPtr(PLANAR_V), src->GetPitch(PLANAR_V),src->GetRowSize(PLANAR_V), src->GetHeight(PLANAR_V));
	else if(_v<1&&_v>-256)
		memset (dst->GetWritePtr(PLANAR_V), -_v, dst->GetPitch(PLANAR_V)*dst->GetHeight(PLANAR_V));


	if(scenechange){
		BYTE *dstp=dst->GetWritePtr(PLANAR_Y);
		unsigned int pitch=dst->GetPitch(PLANAR_Y);
		unsigned int height=dst->GetHeight(PLANAR_Y);
		unsigned int i,j;
		for(i=1;i<(height>>4);i++)
			for(j=1;j<(pitch>>4);j++)
				dstp[j+i*pitch]=128;			
		
		dstp=dst->GetWritePtr(PLANAR_U);
		pitch=dst->GetPitch(PLANAR_U);
		height=dst->GetHeight(PLANAR_U);
		for(i=1;i<(height>>4);i++)
			for(j=1;j<(pitch>>4);j++)
				dstp[j+i*pitch]=1;
		
		dstp=dst->GetWritePtr(PLANAR_V);
		pitch=dst->GetPitch(PLANAR_V);
		height=dst->GetHeight(PLANAR_V);
		for(i=1;i<(height>>4);i++)
			for(j=1;j<(pitch>>4);j++)
				dstp[j+i*pitch]=255;
	}


	ticks=GetTickCount()-ticks;
    env->SetVar("DEBUG",ticks);
	env->SetVar("isse",iSSE);
	

	return dst;

}

void ML3Dex::Alignpitch(PVideoFrame &src1,IScriptEnvironment* env){
	PVideoFrame temp=src1;
	src1=env->NewVideoFrame(vi);
	for(unsigned int plane=1;plane<8;plane<<=1){
		unsigned int pitch=src1->GetPitch(plane);
		unsigned int old_pitch=temp->GetPitch(plane);
		unsigned int height=src1->GetHeight(plane);
		unsigned int rowsize=src1->GetRowSize(plane);
		BYTE* dstp=src1->GetWritePtr(plane);
		const BYTE* srcp=temp->GetReadPtr(plane);
		env->BitBlt(dstp,pitch, srcp, old_pitch, rowsize, height);
		
	}
}


void ML3Dex::CalcFrame(int plane,PVideoFrame &src,PVideoFrame &dst){
	srcpa[0]=srca[0]->GetReadPtr(plane);
	srcpa[1]=srca[1]->GetReadPtr(plane);
	srcpa[2]=srca[2]->GetReadPtr(plane);
	

	const BYTE* srcp = src->GetReadPtr(plane);
	BYTE* dstp = dst->GetWritePtr(plane);
	
	const unsigned int dst_pitch = dst->GetPitch(plane);
	const unsigned int src_pitch = src->GetPitch(plane);
	const unsigned int width = src->GetRowSize(plane);
	const unsigned int height = src->GetHeight(plane);
	BYTE* doffset=dstp+dst_pitch;
	unsigned int soffset=0;
	memcpy(dstp,srcp,width);
	for(unsigned int h=1;h<height-1;h++){
		
		for(unsigned int w=1;w<width-17;w+=8)
			CalcPixel(soffset+w-1,doffset+w,src_pitch);
		CalcPixel(soffset+width-18,doffset+width-17,src_pitch);
		soffset+=src_pitch;
		*doffset=srcp[soffset];
		*(doffset+width-1)=srcp[soffset+width-1];
		doffset+=dst_pitch;
		
	}
	memcpy(doffset,srcp+soffset+src_pitch,width);		
}	


void ML3Dex::CalcPixel(unsigned int _offset,BYTE* dstp,unsigned int pitch){


	if(iSSE){

	__asm{
		mov ecx,this
		lea edi,[ecx+medianbuffer]
		lea ebx,[ecx+srcpa]
		mov esi,[ebx+4]
		mov edx,[ebx+8]
		mov ebx,[ebx]
		mov eax,_offset
		add ebx,eax
		add esi,eax
		add edx,eax
		mov eax,pitch

		MEDIAN_W5  //?

		movq [ecx+medianmedianbuffer],mm2
		movq [ecx+medianmedianbuffer+8],mm5

		MEDIAN_W6  //?

		movq [ecx+medianmedianbuffer+16],mm2
		movq [ecx+medianmedianbuffer+24],mm5

		MEDIAN_W7

		movq [ecx+medianmedianbuffer+32],mm2
		movq [ecx+medianmedianbuffer+40],mm5

		
		MEDIAN_W8

		movq [ecx+medianmedianbuffer+48],mm2
		movq [ecx+medianmedianbuffer+56],mm5
				
		MEDIAN_W9

		movq [ecx+medianmedianbuffer+64],mm2
		movq [ecx+medianmedianbuffer+72],mm5

		lea edi,[ecx+medianmedianbuffer]

		MEDIAN_MM

		mov eax,[dstp]
		movq [eax],mm2
		movq [eax+8],mm5

		emms

	}
	
	}
	else{
		unsigned int buffer[11];
		unsigned int medians[5];
		for(int i=0;i<16;i++){

			//W5
			buffer[0]=srcpa[0][_offset+i+pitch+1];
			buffer[1]=srcpa[1][_offset+i+1];
			buffer[2]=srcpa[1][_offset+i+pitch];
			buffer[3]=srcpa[1][_offset+i+pitch+1];
			buffer[4]=srcpa[1][_offset+i+pitch+2];
			buffer[5]=srcpa[1][_offset+i+2*pitch+1];
			buffer[6]=srcpa[2][_offset+i+pitch+1];
			medians[0]=quick_select(buffer,7);
			//dstp[i]=medians[0];

			//W6
			buffer[0]=srcpa[0][_offset+i+pitch+1];
			buffer[1]=srcpa[1][_offset+i+0];
			buffer[2]=srcpa[1][_offset+i+2];
			buffer[3]=srcpa[1][_offset+i+pitch+1];
			buffer[4]=srcpa[1][_offset+i+2*pitch];
			buffer[5]=srcpa[1][_offset+i+2*pitch+2];
			buffer[6]=srcpa[2][_offset+i+pitch+1];
			medians[1]=quick_select(buffer,7);
			//dstp[i]=medians[1];

			//W7
			buffer[0]=srcpa[0][_offset+i+pitch+1];
			buffer[1]=srcpa[1][_offset+i+pitch+1];
			buffer[2]=srcpa[2][_offset+i+pitch+1];
			medians[2]=quick_select(buffer,3);

			//dstp[i]=medians[2];


			//W8
			buffer[0]=srcpa[1][_offset+i+pitch+1];
			buffer[1]=srcpa[0][_offset+i+1];
			buffer[2]=srcpa[0][_offset+i+pitch];
			buffer[3]=srcpa[0][_offset+i+pitch+1];
			buffer[4]=srcpa[0][_offset+i+pitch+2];
			buffer[5]=srcpa[0][_offset+i+2*pitch+1];
			buffer[6]=srcpa[2][_offset+i+1];
			buffer[7]=srcpa[2][_offset+i+pitch];
			buffer[8]=srcpa[2][_offset+i+pitch+1];
			buffer[9]=srcpa[2][_offset+i+pitch+2];
			buffer[10]=srcpa[2][_offset+i+2*pitch+1];
			medians[3]=quick_select(buffer,11);
			//dstp[i]=medians[3];

			//W9
			buffer[0]=srcpa[1][_offset+i+pitch+1];
			buffer[1]=srcpa[0][_offset+i+0];
			buffer[2]=srcpa[0][_offset+i+2];
			buffer[3]=srcpa[0][_offset+i+pitch+1];
			buffer[4]=srcpa[0][_offset+i+2*pitch];
			buffer[5]=srcpa[0][_offset+i+2*pitch+2];
			buffer[6]=srcpa[2][_offset+i+0];
			buffer[7]=srcpa[2][_offset+i+2];
			buffer[8]=srcpa[2][_offset+i+pitch+1];
			buffer[9]=srcpa[2][_offset+i+2*pitch];
			buffer[10]=srcpa[2][_offset+i+2*pitch+2];
			medians[4]=quick_select(buffer,11);
			//dstp[i]=medians[4];

			dstp[i]=quick_select(medians,5);
		}




	}
}

//******************************************************************************************************************
//******************************************************************************************************************


/*AVSValue __cdecl Create_MedianBlur(AVSValue args, void* user_data, IScriptEnvironment* env){
	return new MedianBlur(args[0].AsClip(),args[1].AsInt(2),args[2].AsInt(2),args[3].AsInt(2),args[4].AsBool(true),env);
}*/


AVSValue __cdecl Create_MedianBlurMMX(AVSValue args, void* user_data, IScriptEnvironment* env){
	
	return new MedianBlurMMX(args[0].AsClip(),args[1].AsInt(2),args[2].AsInt(2),args[3].AsInt(2),args[4].AsBool(true),env);
}

AVSValue __cdecl Create_ml3dex(AVSValue args, void* user_data, IScriptEnvironment* env){
	
	return new ML3Dex(args[0].AsClip(),args[1].AsBool(true),args[2].AsInt(3),args[3].AsInt(2),args[4].AsInt(2),args[5].AsBool(false),
			args[6].AsInt(8),args[7].AsInt(1),args[8].AsInt(1000),args[9].AsInt(200),args[10].AsInt(200),args[11].AsInt(1),args[12].AsBool(false),args[13].AsBool(false),env);
}

AVSValue __cdecl Create_MedianBlurcw(AVSValue args, void* user_data, IScriptEnvironment* env){
	return new MedianBlurWeight(args[0].AsClip(),args[1].AsInt(2),args[2].AsInt(2),args[3].AsInt(2),
		args[4].AsInt(1),args[5].AsInt(1),args[6].AsInt(1),args[7].AsBool(true),env);
}

AVSValue __cdecl Create_MedianBlurb(AVSValue args, void* user_data, IScriptEnvironment* env){
	return new MedianBlurBin(args[0].AsClip(),args[1].AsInt(2),args[2].AsInt(0),args[3].AsInt(0),
		args[4].AsInt(127),args[5].AsInt(127),args[6].AsInt(127),args[7].AsBool(true),env);
}

AVSValue __cdecl Create_MedianBlurt(AVSValue args, void* user_data, IScriptEnvironment* env){
	return new MedianBlurTemp(args[0].AsClip(),args[1].AsInt(2),args[2].AsInt(2),args[3].AsInt(2),args[4].AsInt(1),args[5].AsBool(false),args[6].AsBool(true),args[7].AsBool(false),
		args[8].AsInt(4),args[9].AsInt(1),args[10].AsInt(1000),args[11].AsInt(200),args[12].AsInt(175),args[13].AsInt(1),args[14].AsBool(false),args[15].AsBool(false),env);
}


extern "C" __declspec(dllexport) const char* __stdcall AvisynthPluginInit2(IScriptEnvironment* env) {
	env->AddFunction("medianblur", "c[radiusy]i[radiusu]i[radiusv]i[calcborder]b", Create_MedianBlurMMX, 0);
	env->AddFunction("medianblurcw", "c[radiusy]i[radiusu]i[radiusv]i[weighty]i[weightu]i[weightv]i[calcborder]b", Create_MedianBlurcw,0);
	env->AddFunction("medianblurb", "c[radiusy]i[radiusu]i[radiusv]i[thresholdy]i[thresholdu]i[thresholdv]i[calcborder]b", Create_MedianBlurb,0);
	env->AddFunction("medianblurt", "c[radiusy]i[radiusu]i[radiusv]i[temporalradius]i[mc]b[calcborder]b[markscenechange]b[blksize]i[pel]i[lambda]i[thSCD1]i[thSCD2]i[searchparam]i[spfull]b[bsfull]b", Create_MedianBlurt,0);
	env->AddFunction("ml3dex", "c[mc]b[Y]i[U]i[V]i[markscenechange]b[blksize]i[pel]i[lambda]i[thSCD1]i[thSCD2]i[searchparam]i[spfull]b[bsfull]b", Create_ml3dex, 0);
return "medianblur version 0.84";
}











#ifdef _MANAGED
#pragma managed(pop)
#endif


