// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA, or visit
// http://www.gnu.org/copyleft/gpl.html .

//asm mediancalc

//edi = temp buffer
//esi = srcp
//eax = pitch
//mm2 & mm5 contains the 16 medians
//regbuffer 2
#define MEDIAN16_1 {__asm mov ecx,eax \
__asm shl ecx,1 \
__asm  add ecx,eax  \
__asm  mov edx,eax  \
__asm  shl edx,2  \
__asm  add edx,eax  \
/*first:last 1:2  save 1:1  load 1:1  swap 0:0  reverse 0  loadbuffer 0:0  savebuffer 0:1*/ \
__asm  movq mm1,[esi+1]  \
__asm  movq mm4,[esi+1+8] \
__asm  movq mm0,[esi+2]  \
__asm  movq mm7,[esi+2+8]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm0 \
__asm  pminub mm4,mm7 \
__asm  pmaxub mm0,mm3   \
__asm  pmaxub mm7,mm6   \
 \
 \
/*first:last 0:1  save 1:1  load 1:0  swap 0:1  reverse 1  loadbuffer 0:0  savebuffer 1:0*/ \
__asm  movq mm2,[esi+0]  \
__asm  movq mm5,[esi+0+8] \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+0],mm2   \
__asm  movq [edi+8],mm5   \
 \
 \
/*first:last 1:2  save 1:1  load 0:0  swap 1:0  reverse 0  loadbuffer 0:1  savebuffer 1:1*/ \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm0 \
__asm  pminub mm4,mm7 \
__asm  pmaxub mm0,mm3   \
__asm  pmaxub mm7,mm6   \
__asm  movq [edi+16],mm1   \
__asm  movq [edi+24],mm4   \
 \
 \
/*first:last 4:5  save 1:1  load 1:1  swap 0:0  reverse 0  loadbuffer 0:0  savebuffer 0:1*/ \
__asm  movq mm1,[esi+1*eax+1]  \
__asm  movq mm4,[esi+1*eax+1+8] \
__asm  movq mm2,[esi+1*eax+2]  \
__asm  movq mm5,[esi+1*eax+2+8]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+80],mm2   \
__asm  movq [edi+88],mm5   \
 \
 \
/*first:last 3:4  save 1:1  load 1:0  swap 0:1  reverse 1  loadbuffer 0:0  savebuffer 1:0*/ \
__asm  movq mm2,[esi+1*eax+0]  \
__asm  movq mm5,[esi+1*eax+0+8] \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+48],mm2   \
__asm  movq [edi+56],mm5   \
 \
 \
/*first:last 4:5  save 1:1  load 0:0  swap 1:0  reverse 0  loadbuffer 0:1  savebuffer 1:1*/ \
__asm  movq mm2,[edi+80]    \
__asm  movq mm5,[edi+88]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+64],mm1   \
__asm  movq [edi+72],mm4   \
__asm  movq [edi+80],mm2   \
__asm  movq [edi+88],mm5   \
 \
 \
/*first:last 7:8  save 1:1  load 1:1  swap 0:0  reverse 0  loadbuffer 0:0  savebuffer 0:1*/ \
__asm  movq mm1,[esi+2*eax+1]  \
__asm  movq mm4,[esi+2*eax+1+8] \
__asm  movq mm2,[esi+2*eax+2]  \
__asm  movq mm5,[esi+2*eax+2+8]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+128],mm2   \
__asm  movq [edi+136],mm5   \
 \
 \
/*first:last 6:7  save 1:1  load 1:0  swap 0:1  reverse 1  loadbuffer 0:0  savebuffer 1:0*/ \
__asm  movq mm2,[esi+2*eax+0]  \
__asm  movq mm5,[esi+2*eax+0+8] \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+96],mm2   \
__asm  movq [edi+104],mm5   \
 \
 \
/*first:last 7:8  save 1:1  load 0:0  swap 1:0  reverse 0  loadbuffer 0:1  savebuffer 1:0*/ \
__asm  movq mm2,[edi+128]    \
__asm  movq mm5,[edi+136]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+112],mm1   \
__asm  movq [edi+120],mm4   \
 \
 \
/*first:last 5:8  save 1:0  load 0:0  swap 0:0  reverse 0  loadbuffer 1:0  savebuffer 0:0*/ \
__asm  movq mm1,[edi+80]  \
__asm  movq mm4,[edi+88]  \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
 \
 \
/*first:last 2:5  save 1:0  load 0:0  swap 0:1  reverse 1  loadbuffer 1:0  savebuffer 1:0*/ \
__asm  pminub mm0,mm1 \
__asm  pminub mm7,mm4 \
 \
 \
/*first:last 0:3  save 0:1  load 0:0  swap 0:0  reverse 1  loadbuffer 1:1  savebuffer 0:0*/ \
__asm  movq mm2,[edi+0]  \
__asm  movq mm5,[edi+8]  \
__asm  movq mm1,[edi+48]    \
__asm  movq mm4,[edi+56]   \
__asm  pmaxub mm1,mm2 \
__asm  pmaxub mm4,mm5 \
 \
 \
/*first:last 3:6  save 0:1  load 0:0  swap 1:0  reverse 0  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm2,[edi+96]    \
__asm  movq mm5,[edi+104]   \
__asm  pmaxub mm2,mm1 \
__asm  pmaxub mm5,mm4 \
__asm  movq [edi+96],mm2   \
__asm  movq [edi+104],mm5   \
 \
 \
/*first:last 4:7  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+64]  \
__asm  movq mm4,[edi+72]  \
__asm  movq mm2,[edi+112]    \
__asm  movq mm5,[edi+120]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+112],mm2   \
__asm  movq [edi+120],mm5   \
 \
 \
/*first:last 1:4  save 0:1  load 0:0  swap 0:1  reverse 1  loadbuffer 1:0  savebuffer 0:0*/ \
__asm  movq mm2,[edi+16]  \
__asm  movq mm5,[edi+24]  \
__asm  pmaxub mm1,mm2 \
__asm  pmaxub mm4,mm5 \
 \
 \
/*first:last 4:7  save 1:0  load 0:0  swap 1:0  reverse 0  loadbuffer 0:1  savebuffer 0:0*/ \
__asm  movq mm2,[edi+112]    \
__asm  movq mm5,[edi+120]   \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
 \
 \
/*first:last 4:2  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm0 \
__asm  pminub mm4,mm7 \
__asm  pmaxub mm0,mm3   \
__asm  pmaxub mm7,mm6   \
 \
 \
/*first:last 6:4  save 0:1  load 0:0  swap 0:1  reverse 1  loadbuffer 1:0  savebuffer 0:0*/ \
__asm  movq mm2,[edi+96]  \
__asm  movq mm5,[edi+104]  \
__asm  pmaxub mm1,mm2 \
__asm  pmaxub mm4,mm5 \
 \
 \
/*first:last 4:2  save 1:0  load 0:0  swap 1:0  reverse 0  loadbuffer 0:1  savebuffer 1:0*/ \
__asm  pminub mm1,mm0 \
__asm  pminub mm4,mm7 \
 \
 \
__asm movq mm2,mm1 \
__asm movq mm5,mm4 \
}
//asm mediancalc

//edi = temp buffer
//esi = srcp
//eax = pitch
//mm2 & mm5 contains the 16 medians
//regbuffer 12
#define MEDIAN16_2 {__asm mov ecx,eax \
__asm shl ecx,1 \
__asm  add ecx,eax  \
__asm  mov edx,eax  \
__asm  shl edx,2  \
__asm  add edx,eax  \
/*first:last 0:1  save 1:1  load 1:1  swap 0:0  reverse 0  loadbuffer 0:0  savebuffer 1:1*/ \
__asm  movq mm1,[esi+0]  \
__asm  movq mm4,[esi+0+8] \
__asm  movq mm2,[esi+1]  \
__asm  movq mm5,[esi+1+8]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+0],mm1   \
__asm  movq [edi+8],mm4   \
__asm  movq [edi+16],mm2   \
__asm  movq [edi+24],mm5   \
 \
 \
/*first:last 3:4  save 1:1  load 1:1  swap 0:0  reverse 0  loadbuffer 0:0  savebuffer 1:0*/ \
__asm  movq mm1,[esi+3]  \
__asm  movq mm4,[esi+3+8] \
__asm  movq mm2,[esi+4]  \
__asm  movq mm5,[esi+4+8]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+48],mm1   \
__asm  movq [edi+56],mm4   \
 \
 \
/*first:last 2:4  save 1:1  load 1:0  swap 0:0  reverse 0  loadbuffer 0:0  savebuffer 0:1*/ \
__asm  movq mm1,[esi+2]  \
__asm  movq mm4,[esi+2+8] \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+64],mm2   \
__asm  movq [edi+72],mm5   \
 \
 \
/*first:last 2:3  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 1:1*/ \
__asm  movq mm2,[edi+48]    \
__asm  movq mm5,[edi+56]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+32],mm1   \
__asm  movq [edi+40],mm4   \
__asm  movq [edi+48],mm2   \
__asm  movq [edi+56],mm5   \
 \
 \
/*first:last 6:7  save 1:1  load 1:1  swap 0:0  reverse 0  loadbuffer 0:0  savebuffer 1:0*/ \
__asm  movq mm1,[esi+1*eax+1]  \
__asm  movq mm4,[esi+1*eax+1+8] \
__asm  movq mm2,[esi+1*eax+2]  \
__asm  movq mm5,[esi+1*eax+2+8]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+96],mm1   \
__asm  movq [edi+104],mm4   \
 \
 \
/*first:last 5:7  save 1:1  load 1:0  swap 0:0  reverse 0  loadbuffer 0:0  savebuffer 0:1*/ \
__asm  movq mm1,[esi+1*eax+0]  \
__asm  movq mm4,[esi+1*eax+0+8] \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+112],mm2   \
__asm  movq [edi+120],mm5   \
 \
 \
/*first:last 5:6  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm2,[edi+96]    \
__asm  movq mm5,[edi+104]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+96],mm2   \
__asm  movq [edi+104],mm5   \
 \
 \
/*first:last 2:5  save 1:1  load 0:0  swap 0:1  reverse 1  loadbuffer 1:0  savebuffer 1:1*/ \
__asm  movq mm2,[edi+32]  \
__asm  movq mm5,[edi+40]  \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+32],mm2   \
__asm  movq [edi+40],mm5   \
__asm  movq [edi+80],mm1   \
__asm  movq [edi+88],mm4   \
 \
 \
/*first:last 9:10  save 1:1  load 1:1  swap 0:0  reverse 1  loadbuffer 0:0  savebuffer 1:0*/ \
__asm  movq mm2,[esi+1*eax+4]  \
__asm  movq mm5,[esi+1*eax+4+8] \
__asm  movq mm1,[esi+2*eax+0]  \
__asm  movq mm4,[esi+2*eax+0+8]  \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+144],mm2   \
__asm  movq [edi+152],mm5   \
 \
 \
/*first:last 8:10  save 1:1  load 1:0  swap 0:0  reverse 1  loadbuffer 0:0  savebuffer 0:1*/ \
__asm  movq mm2,[esi+1*eax+3]  \
__asm  movq mm5,[esi+1*eax+3+8] \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+160],mm1   \
__asm  movq [edi+168],mm4   \
 \
 \
/*first:last 8:9  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 0:1  savebuffer 1:1*/ \
__asm  movq mm1,[edi+144]    \
__asm  movq mm4,[edi+152]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+128],mm2   \
__asm  movq [edi+136],mm5   \
__asm  movq [edi+144],mm1   \
__asm  movq [edi+152],mm4   \
 \
 \
/*first:last 12:13  save 1:1  load 1:1  swap 0:0  reverse 1  loadbuffer 0:0  savebuffer 1:0*/ \
__asm  movq mm0,[esi+2*eax+2]  \
__asm  movq mm7,[esi+2*eax+2+8] \
__asm  movq mm1,[esi+2*eax+3]  \
__asm  movq mm4,[esi+2*eax+3+8]  \
__asm  movq mm3,mm0 \
__asm  movq mm6,mm7 \
__asm  pminub mm0,mm1 \
__asm  pminub mm7,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
 \
 \
/*first:last 11:13  save 1:1  load 1:0  swap 0:0  reverse 1  loadbuffer 0:0  savebuffer 0:1*/ \
__asm  movq mm2,[esi+2*eax+1]  \
__asm  movq mm5,[esi+2*eax+1+8] \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+208],mm1   \
__asm  movq [edi+216],mm4   \
 \
 \
/*first:last 11:12  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 0:1  savebuffer 1:1*/ \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm0 \
__asm  pminub mm5,mm7 \
__asm  pmaxub mm0,mm3   \
__asm  pmaxub mm7,mm6   \
__asm  movq [edi+176],mm2   \
__asm  movq [edi+184],mm5   \
 \
 \
/*first:last 15:16  save 1:1  load 1:1  swap 0:0  reverse 1  loadbuffer 0:0  savebuffer 1:0*/ \
__asm  movq mm2,[esi+1*ecx+0]  \
__asm  movq mm5,[esi+1*ecx+0+8] \
__asm  movq mm1,[esi+1*ecx+1]  \
__asm  movq mm4,[esi+1*ecx+1+8]  \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+240],mm2   \
__asm  movq [edi+248],mm5   \
 \
 \
/*first:last 14:16  save 1:1  load 1:0  swap 0:0  reverse 1  loadbuffer 0:0  savebuffer 0:1*/ \
__asm  movq mm2,[esi+2*eax+4]  \
__asm  movq mm5,[esi+2*eax+4+8] \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+256],mm1   \
__asm  movq [edi+264],mm4   \
 \
 \
/*first:last 14:15  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+240]    \
__asm  movq mm4,[edi+248]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+240],mm1   \
__asm  movq [edi+248],mm4   \
 \
 \
/*first:last 11:14  save 1:1  load 0:0  swap 0:1  reverse 0  loadbuffer 1:0  savebuffer 1:0*/ \
__asm  movq mm1,[edi+176]  \
__asm  movq mm4,[edi+184]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+176],mm1   \
__asm  movq [edi+184],mm4   \
 \
 \
/*first:last 8:14  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:0  savebuffer 0:1*/ \
__asm  movq mm1,[edi+128]  \
__asm  movq mm4,[edi+136]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+224],mm2   \
__asm  movq [edi+232],mm5   \
 \
 \
/*first:last 8:11  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 1:1*/ \
__asm  movq mm2,[edi+176]    \
__asm  movq mm5,[edi+184]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+128],mm1   \
__asm  movq [edi+136],mm4   \
__asm  movq [edi+176],mm2   \
__asm  movq [edi+184],mm5   \
 \
 \
/*first:last 18:19  save 1:1  load 1:1  swap 0:0  reverse 0  loadbuffer 0:0  savebuffer 1:0*/ \
__asm  movq mm1,[esi+1*ecx+3]  \
__asm  movq mm4,[esi+1*ecx+3+8] \
__asm  movq mm2,[esi+1*ecx+4]  \
__asm  movq mm5,[esi+1*ecx+4+8]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+288],mm1   \
__asm  movq [edi+296],mm4   \
 \
 \
/*first:last 17:19  save 1:1  load 1:0  swap 0:0  reverse 0  loadbuffer 0:0  savebuffer 0:1*/ \
__asm  movq mm1,[esi+1*ecx+2]  \
__asm  movq mm4,[esi+1*ecx+2+8] \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+304],mm2   \
__asm  movq [edi+312],mm5   \
 \
 \
/*first:last 17:18  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 1:1*/ \
__asm  movq mm2,[edi+288]    \
__asm  movq mm5,[edi+296]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+272],mm1   \
__asm  movq [edi+280],mm4   \
__asm  movq [edi+288],mm2   \
__asm  movq [edi+296],mm5   \
 \
 \
/*first:last 21:22  save 1:1  load 1:1  swap 0:0  reverse 0  loadbuffer 0:0  savebuffer 1:0*/ \
__asm  movq mm1,[esi+4*eax+1]  \
__asm  movq mm4,[esi+4*eax+1+8] \
__asm  movq mm2,[esi+4*eax+2]  \
__asm  movq mm5,[esi+4*eax+2+8]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+336],mm1   \
__asm  movq [edi+344],mm4   \
 \
 \
/*first:last 20:22  save 1:1  load 1:0  swap 0:0  reverse 0  loadbuffer 0:0  savebuffer 0:1*/ \
__asm  movq mm1,[esi+4*eax+0]  \
__asm  movq mm4,[esi+4*eax+0+8] \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+352],mm2   \
__asm  movq [edi+360],mm5   \
 \
 \
/*first:last 20:21  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 1:1*/ \
__asm  movq mm2,[edi+336]    \
__asm  movq mm5,[edi+344]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+320],mm1   \
__asm  movq [edi+328],mm4   \
__asm  movq [edi+336],mm2   \
__asm  movq [edi+344],mm5   \
 \
 \
/*first:last 23:24  save 1:1  load 1:1  swap 0:0  reverse 0  loadbuffer 0:0  savebuffer 0:1*/ \
__asm  movq mm1,[esi+4*eax+3]  \
__asm  movq mm4,[esi+4*eax+3+8] \
__asm  movq mm2,[esi+4*eax+4]  \
__asm  movq mm5,[esi+4*eax+4+8]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+384],mm2   \
__asm  movq [edi+392],mm5   \
 \
 \
/*first:last 20:23  save 1:1  load 0:0  swap 0:1  reverse 1  loadbuffer 1:0  savebuffer 1:0*/ \
__asm  movq mm2,[edi+320]  \
__asm  movq mm5,[edi+328]  \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+320],mm2   \
__asm  movq [edi+328],mm5   \
 \
 \
/*first:last 17:23  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 1:0  savebuffer 0:1*/ \
__asm  movq mm2,[edi+272]  \
__asm  movq mm5,[edi+280]  \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+368],mm1   \
__asm  movq [edi+376],mm4   \
 \
 \
/*first:last 17:20  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+320]    \
__asm  movq mm4,[edi+328]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+320],mm1   \
__asm  movq [edi+328],mm4   \
 \
 \
/*first:last 8:17  save 0:1  load 0:0  swap 0:1  reverse 0  loadbuffer 1:0  savebuffer 0:1*/ \
__asm  movq mm1,[edi+128]  \
__asm  movq mm4,[edi+136]  \
__asm  pmaxub mm2,mm1 \
__asm  pmaxub mm5,mm4 \
__asm  movq [edi+272],mm2   \
__asm  movq [edi+280],mm5   \
 \
 \
/*first:last 3:6  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:1  savebuffer 1:0*/ \
__asm  movq mm1,[edi+48]  \
__asm  movq mm4,[edi+56]  \
__asm  movq mm2,[edi+96]    \
__asm  movq mm5,[edi+104]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+48],mm1   \
__asm  movq [edi+56],mm4   \
 \
 \
/*first:last 0:6  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:0  savebuffer 0:1*/ \
__asm  movq mm1,[edi+0]  \
__asm  movq mm4,[edi+8]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+96],mm2   \
__asm  movq [edi+104],mm5   \
 \
 \
/*first:last 0:3  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 1:1*/ \
__asm  movq mm2,[edi+48]    \
__asm  movq mm5,[edi+56]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+0],mm1   \
__asm  movq [edi+8],mm4   \
__asm  movq [edi+48],mm2   \
__asm  movq [edi+56],mm5   \
 \
 \
/*first:last 4:7  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:1  savebuffer 1:0*/ \
__asm  movq mm1,[edi+64]  \
__asm  movq mm4,[edi+72]  \
__asm  movq mm2,[edi+112]    \
__asm  movq mm5,[edi+120]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+64],mm1   \
__asm  movq [edi+72],mm4   \
 \
 \
/*first:last 1:7  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:0  savebuffer 0:1*/ \
__asm  movq mm1,[edi+16]  \
__asm  movq mm4,[edi+24]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+112],mm2   \
__asm  movq [edi+120],mm5   \
 \
 \
/*first:last 1:4  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 1:1*/ \
__asm  movq mm2,[edi+64]    \
__asm  movq mm5,[edi+72]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+16],mm1   \
__asm  movq [edi+24],mm4   \
__asm  movq [edi+64],mm2   \
__asm  movq [edi+72],mm5   \
 \
 \
/*first:last 12:15  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:1  savebuffer 1:0*/ \
__asm  movq mm2,[edi+240]    \
__asm  movq mm5,[edi+248]   \
__asm  movq mm3,mm0 \
__asm  movq mm6,mm7 \
__asm  pminub mm0,mm2 \
__asm  pminub mm7,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
 \
 \
/*first:last 9:15  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:0  savebuffer 0:1*/ \
__asm  movq mm1,[edi+144]  \
__asm  movq mm4,[edi+152]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+240],mm2   \
__asm  movq [edi+248],mm5   \
 \
 \
/*first:last 9:12  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 1:1*/ \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm0 \
__asm  pminub mm4,mm7 \
__asm  pmaxub mm0,mm3   \
__asm  pmaxub mm7,mm6   \
__asm  movq [edi+144],mm1   \
__asm  movq [edi+152],mm4   \
 \
 \
/*first:last 13:16  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:1  savebuffer 1:0*/ \
__asm  movq mm1,[edi+208]  \
__asm  movq mm4,[edi+216]  \
__asm  movq mm2,[edi+256]    \
__asm  movq mm5,[edi+264]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+208],mm1   \
__asm  movq [edi+216],mm4   \
 \
 \
/*first:last 10:16  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:0  savebuffer 0:1*/ \
__asm  movq mm1,[edi+160]  \
__asm  movq mm4,[edi+168]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+256],mm2   \
__asm  movq [edi+264],mm5   \
 \
 \
/*first:last 10:13  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 1:1*/ \
__asm  movq mm2,[edi+208]    \
__asm  movq mm5,[edi+216]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+160],mm1   \
__asm  movq [edi+168],mm4   \
__asm  movq [edi+208],mm2   \
__asm  movq [edi+216],mm5   \
 \
 \
/*first:last 21:24  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:1  savebuffer 1:0*/ \
__asm  movq mm1,[edi+336]  \
__asm  movq mm4,[edi+344]  \
__asm  movq mm2,[edi+384]    \
__asm  movq mm5,[edi+392]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+336],mm1   \
__asm  movq [edi+344],mm4   \
 \
 \
/*first:last 18:24  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:0  savebuffer 0:1*/ \
__asm  movq mm1,[edi+288]  \
__asm  movq mm4,[edi+296]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+384],mm2   \
__asm  movq [edi+392],mm5   \
 \
 \
/*first:last 18:21  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm2,[edi+336]    \
__asm  movq mm5,[edi+344]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+336],mm2   \
__asm  movq [edi+344],mm5   \
 \
 \
/*first:last 9:18  save 1:1  load 0:0  swap 0:1  reverse 1  loadbuffer 1:0  savebuffer 1:0*/ \
__asm  movq mm2,[edi+144]  \
__asm  movq mm5,[edi+152]  \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+144],mm2   \
__asm  movq [edi+152],mm5   \
 \
 \
/*first:last 0:18  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 1:0  savebuffer 0:1*/ \
__asm  movq mm2,[edi+0]  \
__asm  movq mm5,[edi+8]  \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+288],mm1   \
__asm  movq [edi+296],mm4   \
 \
 \
/*first:last 0:9  save 0:1  load 0:0  swap 0:0  reverse 1  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+144]    \
__asm  movq mm4,[edi+152]   \
__asm  pmaxub mm1,mm2 \
__asm  pmaxub mm4,mm5 \
__asm  movq [edi+144],mm1   \
__asm  movq [edi+152],mm4   \
 \
 \
/*first:last 19:22  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm2,[edi+304]  \
__asm  movq mm5,[edi+312]  \
__asm  movq mm1,[edi+352]    \
__asm  movq mm4,[edi+360]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+352],mm1   \
__asm  movq [edi+360],mm4   \
 \
 \
/*first:last 10:19  save 1:1  load 0:0  swap 0:1  reverse 0  loadbuffer 1:0  savebuffer 1:0*/ \
__asm  movq mm1,[edi+160]  \
__asm  movq mm4,[edi+168]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+160],mm1   \
__asm  movq [edi+168],mm4   \
 \
 \
/*first:last 1:19  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:0  savebuffer 0:1*/ \
__asm  movq mm1,[edi+16]  \
__asm  movq mm4,[edi+24]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+304],mm2   \
__asm  movq [edi+312],mm5   \
 \
 \
/*first:last 1:10  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm2,[edi+160]    \
__asm  movq mm5,[edi+168]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+160],mm2   \
__asm  movq [edi+168],mm5   \
 \
 \
/*first:last 1:9  save 0:1  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm2,[edi+144]    \
__asm  movq mm5,[edi+152]   \
__asm  pmaxub mm2,mm1 \
__asm  pmaxub mm5,mm4 \
__asm  movq [edi+144],mm2   \
__asm  movq [edi+152],mm5   \
 \
 \
/*first:last 11:20  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:1  savebuffer 1:0*/ \
__asm  movq mm1,[edi+176]  \
__asm  movq mm4,[edi+184]  \
__asm  movq mm2,[edi+320]    \
__asm  movq mm5,[edi+328]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+176],mm1   \
__asm  movq [edi+184],mm4   \
 \
 \
/*first:last 2:20  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:0  savebuffer 0:1*/ \
__asm  movq mm1,[edi+32]  \
__asm  movq mm4,[edi+40]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+320],mm2   \
__asm  movq [edi+328],mm5   \
 \
 \
/*first:last 2:11  save 0:1  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm2,[edi+176]    \
__asm  movq mm5,[edi+184]   \
__asm  pmaxub mm2,mm1 \
__asm  pmaxub mm5,mm4 \
__asm  movq [edi+176],mm2   \
__asm  movq [edi+184],mm5   \
 \
 \
/*first:last 12:21  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:1  savebuffer 1:0*/ \
__asm  movq mm2,[edi+336]    \
__asm  movq mm5,[edi+344]   \
__asm  movq mm3,mm0 \
__asm  movq mm6,mm7 \
__asm  pminub mm0,mm2 \
__asm  pminub mm7,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
 \
 \
/*first:last 3:21  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:0  savebuffer 0:1*/ \
__asm  movq mm1,[edi+48]  \
__asm  movq mm4,[edi+56]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+336],mm2   \
__asm  movq [edi+344],mm5   \
 \
 \
/*first:last 3:12  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm0 \
__asm  pminub mm4,mm7 \
__asm  pmaxub mm0,mm3   \
__asm  pmaxub mm7,mm6   \
 \
 \
/*first:last 3:11  save 0:1  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm2,[edi+176]    \
__asm  movq mm5,[edi+184]   \
__asm  pmaxub mm2,mm1 \
__asm  pmaxub mm5,mm4 \
__asm  movq [edi+176],mm2   \
__asm  movq [edi+184],mm5   \
 \
 \
/*first:last 13:22  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:1  savebuffer 1:0*/ \
__asm  movq mm1,[edi+208]  \
__asm  movq mm4,[edi+216]  \
__asm  movq mm2,[edi+352]    \
__asm  movq mm5,[edi+360]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+208],mm1   \
__asm  movq [edi+216],mm4   \
 \
 \
/*first:last 4:22  save 1:0  load 0:0  swap 0:0  reverse 0  loadbuffer 1:0  savebuffer 0:0*/ \
__asm  movq mm1,[edi+64]  \
__asm  movq mm4,[edi+72]  \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
 \
 \
/*first:last 4:13  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 1:0*/ \
__asm  movq mm2,[edi+208]    \
__asm  movq mm5,[edi+216]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+64],mm1   \
__asm  movq [edi+72],mm4   \
 \
 \
/*first:last 13:21  save 1:0  load 0:0  swap 1:0  reverse 1  loadbuffer 0:1  savebuffer 1:0*/ \
__asm  movq mm1,[edi+336]    \
__asm  movq mm4,[edi+344]   \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  movq [edi+208],mm2   \
__asm  movq [edi+216],mm5   \
 \
 \
/*first:last 14:23  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 1:1  savebuffer 1:0*/ \
__asm  movq mm2,[edi+224]  \
__asm  movq mm5,[edi+232]  \
__asm  movq mm1,[edi+368]    \
__asm  movq mm4,[edi+376]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+224],mm2   \
__asm  movq [edi+232],mm5   \
 \
 \
/*first:last 5:23  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 1:0  savebuffer 0:1*/ \
__asm  movq mm2,[edi+80]  \
__asm  movq mm5,[edi+88]  \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+368],mm1   \
__asm  movq [edi+376],mm4   \
 \
 \
/*first:last 5:14  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+224]    \
__asm  movq mm4,[edi+232]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+224],mm1   \
__asm  movq [edi+232],mm4   \
 \
 \
/*first:last 5:17  save 0:1  load 0:0  swap 0:0  reverse 1  loadbuffer 0:1  savebuffer 0:0*/ \
__asm  movq mm1,[edi+272]    \
__asm  movq mm4,[edi+280]   \
__asm  pmaxub mm1,mm2 \
__asm  pmaxub mm4,mm5 \
 \
 \
/*first:last 11:17  save 0:1  load 0:0  swap 0:0  reverse 1  loadbuffer 1:0  savebuffer 0:0*/ \
__asm  movq mm2,[edi+176]  \
__asm  movq mm5,[edi+184]  \
__asm  pmaxub mm1,mm2 \
__asm  pmaxub mm4,mm5 \
 \
 \
/*first:last 9:17  save 0:1  load 0:0  swap 0:0  reverse 1  loadbuffer 1:0  savebuffer 0:1*/ \
__asm  movq mm2,[edi+144]  \
__asm  movq mm5,[edi+152]  \
__asm  pmaxub mm1,mm2 \
__asm  pmaxub mm4,mm5 \
__asm  movq [edi+272],mm1   \
__asm  movq [edi+280],mm4   \
 \
 \
/*first:last 15:24  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 1:1  savebuffer 1:0*/ \
__asm  movq mm2,[edi+240]  \
__asm  movq mm5,[edi+248]  \
__asm  movq mm1,[edi+384]    \
__asm  movq mm4,[edi+392]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+240],mm2   \
__asm  movq [edi+248],mm5   \
 \
 \
/*first:last 6:24  save 1:0  load 0:0  swap 0:0  reverse 1  loadbuffer 1:0  savebuffer 0:0*/ \
__asm  movq mm2,[edi+96]  \
__asm  movq mm5,[edi+104]  \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
 \
 \
/*first:last 6:15  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 0:1  savebuffer 1:0*/ \
__asm  movq mm1,[edi+240]    \
__asm  movq mm4,[edi+248]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+96],mm2   \
__asm  movq [edi+104],mm5   \
 \
 \
/*first:last 15:23  save 1:0  load 0:0  swap 1:0  reverse 0  loadbuffer 0:1  savebuffer 1:0*/ \
__asm  movq mm2,[edi+368]    \
__asm  movq mm5,[edi+376]   \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  movq [edi+240],mm1   \
__asm  movq [edi+248],mm4   \
 \
 \
/*first:last 7:16  save 1:0  load 0:0  swap 0:0  reverse 0  loadbuffer 1:1  savebuffer 0:0*/ \
__asm  movq mm1,[edi+112]  \
__asm  movq mm4,[edi+120]  \
__asm  movq mm2,[edi+256]    \
__asm  movq mm5,[edi+264]   \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
 \
 \
/*first:last 7:19  save 1:0  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 0:0*/ \
__asm  movq mm2,[edi+304]    \
__asm  movq mm5,[edi+312]   \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
 \
 \
/*first:last 7:13  save 1:0  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 0:0*/ \
__asm  movq mm2,[edi+208]    \
__asm  movq mm5,[edi+216]   \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
 \
 \
/*first:last 7:15  save 1:0  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 0:0*/ \
__asm  movq mm2,[edi+240]    \
__asm  movq mm5,[edi+248]   \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
 \
 \
/*first:last 7:14  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 1:1*/ \
__asm  movq mm2,[edi+224]    \
__asm  movq mm5,[edi+232]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+112],mm1   \
__asm  movq [edi+120],mm4   \
__asm  movq [edi+224],mm2   \
__asm  movq [edi+232],mm5   \
 \
 \
/*first:last 4:10  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:1  savebuffer 1:1*/ \
__asm  movq mm1,[edi+64]  \
__asm  movq mm4,[edi+72]  \
__asm  movq mm2,[edi+160]    \
__asm  movq mm5,[edi+168]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+64],mm1   \
__asm  movq [edi+72],mm4   \
__asm  movq [edi+160],mm2   \
__asm  movq [edi+168],mm5   \
 \
 \
/*first:last 6:12  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+96]  \
__asm  movq mm4,[edi+104]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm0 \
__asm  pminub mm4,mm7 \
__asm  pmaxub mm0,mm3   \
__asm  pmaxub mm7,mm6   \
 \
 \
/*first:last 4:6  save 1:1  load 0:0  swap 0:1  reverse 1  loadbuffer 1:0  savebuffer 0:1*/ \
__asm  movq mm2,[edi+64]  \
__asm  movq mm5,[edi+72]  \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+96],mm1   \
__asm  movq [edi+104],mm4   \
 \
 \
/*first:last 4:7  save 0:1  load 0:0  swap 0:0  reverse 1  loadbuffer 0:1  savebuffer 0:0*/ \
__asm  movq mm1,[edi+112]    \
__asm  movq mm4,[edi+120]   \
__asm  pmaxub mm1,mm2 \
__asm  pmaxub mm4,mm5 \
 \
 \
/*first:last 6:7  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 1:0  savebuffer 1:1*/ \
__asm  movq mm2,[edi+96]  \
__asm  movq mm5,[edi+104]  \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+96],mm2   \
__asm  movq [edi+104],mm5   \
__asm  movq [edi+112],mm1   \
__asm  movq [edi+120],mm4   \
 \
 \
/*first:last 12:14  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 1:1  savebuffer 1:0*/ \
__asm  movq mm1,[edi+224]    \
__asm  movq mm4,[edi+232]   \
__asm  movq mm3,mm0 \
__asm  movq mm6,mm7 \
__asm  pminub mm0,mm1 \
__asm  pminub mm7,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
 \
 \
/*first:last 10:14  save 1:0  load 0:0  swap 0:0  reverse 1  loadbuffer 1:0  savebuffer 0:0*/ \
__asm  movq mm2,[edi+160]  \
__asm  movq mm5,[edi+168]  \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
 \
 \
/*first:last 10:12  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm0 \
__asm  pminub mm5,mm7 \
__asm  pmaxub mm0,mm3   \
__asm  pmaxub mm7,mm6   \
 \
 \
/*first:last 6:10  save 1:1  load 0:0  swap 0:1  reverse 0  loadbuffer 1:0  savebuffer 0:1*/ \
__asm  movq mm1,[edi+96]  \
__asm  movq mm4,[edi+104]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+160],mm2   \
__asm  movq [edi+168],mm5   \
 \
 \
/*first:last 6:17  save 0:1  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 0:0*/ \
__asm  movq mm2,[edi+272]    \
__asm  movq mm5,[edi+280]   \
__asm  pmaxub mm2,mm1 \
__asm  pmaxub mm5,mm4 \
 \
 \
/*first:last 12:17  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:0  savebuffer 1:0*/ \
__asm  movq mm3,mm0 \
__asm  movq mm6,mm7 \
__asm  pminub mm0,mm2 \
__asm  pminub mm7,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
 \
 \
/*first:last 7:17  save 1:0  load 0:0  swap 0:0  reverse 0  loadbuffer 1:0  savebuffer 0:0*/ \
__asm  movq mm1,[edi+112]  \
__asm  movq mm4,[edi+120]  \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
 \
 \
/*first:last 7:10  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 1:1*/ \
__asm  movq mm2,[edi+160]    \
__asm  movq mm5,[edi+168]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+112],mm1   \
__asm  movq [edi+120],mm4   \
__asm  movq [edi+160],mm2   \
__asm  movq [edi+168],mm5   \
 \
 \
/*first:last 12:18  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm2,[edi+288]    \
__asm  movq mm5,[edi+296]   \
__asm  movq mm3,mm0 \
__asm  movq mm6,mm7 \
__asm  pminub mm0,mm2 \
__asm  pminub mm7,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+288],mm2   \
__asm  movq [edi+296],mm5   \
 \
 \
/*first:last 7:12  save 0:1  load 0:0  swap 0:1  reverse 1  loadbuffer 1:0  savebuffer 0:0*/ \
__asm  movq mm2,[edi+112]  \
__asm  movq mm5,[edi+120]  \
__asm  pmaxub mm0,mm2 \
__asm  pmaxub mm7,mm5 \
 \
 \
/*first:last 12:20  save 1:1  load 0:0  swap 1:0  reverse 0  loadbuffer 0:1  savebuffer 1:1*/ \
__asm  movq mm2,[edi+320]    \
__asm  movq mm5,[edi+328]   \
__asm  movq mm3,mm0 \
__asm  movq mm6,mm7 \
__asm  pminub mm0,mm2 \
__asm  pminub mm7,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+320],mm2   \
__asm  movq [edi+328],mm5   \
 \
 \
/*first:last 10:18  save 1:0  load 0:0  swap 0:0  reverse 0  loadbuffer 1:1  savebuffer 0:0*/ \
__asm  movq mm1,[edi+160]  \
__asm  movq mm4,[edi+168]  \
__asm  movq mm2,[edi+288]    \
__asm  movq mm5,[edi+296]   \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
 \
 \
/*first:last 10:20  save 1:0  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 0:0*/ \
__asm  movq mm2,[edi+320]    \
__asm  movq mm5,[edi+328]   \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
 \
 \
/*first:last 10:12  save 0:1  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  pmaxub mm0,mm1 \
__asm  pmaxub mm7,mm4 \
 \
 \
__asm movq mm2,mm0 \
__asm movq mm5,mm7 \
}
//asm mediancalc

//edi = temp buffer
//esi = srcp
//eax = pitch
//mm2 & mm5 contains the 16 medians
//regbuffer 24
#define MEDIAN16_3 {__asm mov ecx,eax \
__asm shl ecx,1 \
__asm  add ecx,eax  \
__asm  mov edx,eax  \
__asm  shl edx,2  \
__asm  add edx,eax  \
/*first:last 0:32  save 1:1  load 1:1  swap 0:0  reverse 0  loadbuffer 0:0  savebuffer 1:1*/ \
__asm  movq mm1,[esi+0]  \
__asm  movq mm4,[esi+0+8] \
__asm  movq mm2,[esi+4*eax+4]  \
__asm  movq mm5,[esi+4*eax+4+8]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+0],mm1   \
__asm  movq [edi+8],mm4   \
__asm  movq [edi+512],mm2   \
__asm  movq [edi+520],mm5   \
 \
 \
/*first:last 1:33  save 1:1  load 1:1  swap 0:0  reverse 0  loadbuffer 0:0  savebuffer 0:1*/ \
__asm  movq mm1,[esi+1]  \
__asm  movq mm4,[esi+1+8] \
__asm  movq mm2,[esi+4*eax+5]  \
__asm  movq mm5,[esi+4*eax+5+8]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+528],mm2   \
__asm  movq [edi+536],mm5   \
 \
 \
/*first:last 1:17  save 1:1  load 0:1  swap 0:0  reverse 0  loadbuffer 0:0  savebuffer 1:0*/ \
__asm  movq mm2,[esi+2*eax+3]  \
__asm  movq mm5,[esi+2*eax+3+8]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+16],mm1   \
__asm  movq [edi+24],mm4   \
 \
 \
/*first:last 17:33  save 1:1  load 0:0  swap 1:0  reverse 1  loadbuffer 0:1  savebuffer 1:1*/ \
__asm  movq mm1,[edi+528]    \
__asm  movq mm4,[edi+536]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+272],mm2   \
__asm  movq [edi+280],mm5   \
__asm  movq [edi+528],mm1   \
__asm  movq [edi+536],mm4   \
 \
 \
/*first:last 2:34  save 1:1  load 1:1  swap 0:0  reverse 1  loadbuffer 0:0  savebuffer 0:1*/ \
__asm  movq mm2,[esi+2]  \
__asm  movq mm5,[esi+2+8] \
__asm  movq mm1,[esi+4*eax+6]  \
__asm  movq mm4,[esi+4*eax+6+8]  \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+544],mm1   \
__asm  movq [edi+552],mm4   \
 \
 \
/*first:last 2:18  save 1:1  load 0:1  swap 0:0  reverse 1  loadbuffer 0:0  savebuffer 1:0*/ \
__asm  movq mm1,[esi+2*eax+4]  \
__asm  movq mm4,[esi+2*eax+4+8]  \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+32],mm2   \
__asm  movq [edi+40],mm5   \
 \
 \
/*first:last 18:34  save 1:1  load 0:0  swap 1:0  reverse 0  loadbuffer 0:1  savebuffer 1:1*/ \
__asm  movq mm2,[edi+544]    \
__asm  movq mm5,[edi+552]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+288],mm1   \
__asm  movq [edi+296],mm4   \
__asm  movq [edi+544],mm2   \
__asm  movq [edi+552],mm5   \
 \
 \
/*first:last 3:35  save 1:1  load 1:1  swap 0:0  reverse 0  loadbuffer 0:0  savebuffer 0:1*/ \
__asm  movq mm1,[esi+3]  \
__asm  movq mm4,[esi+3+8] \
__asm  movq mm2,[esi+edx+0]  \
__asm  movq mm5,[esi+edx+0+8]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+560],mm2   \
__asm  movq [edi+568],mm5   \
 \
 \
/*first:last 3:19  save 1:1  load 0:1  swap 0:0  reverse 0  loadbuffer 0:0  savebuffer 1:0*/ \
__asm  movq mm2,[esi+2*eax+5]  \
__asm  movq mm5,[esi+2*eax+5+8]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+48],mm1   \
__asm  movq [edi+56],mm4   \
 \
 \
/*first:last 19:35  save 1:1  load 0:0  swap 1:0  reverse 1  loadbuffer 0:1  savebuffer 1:1*/ \
__asm  movq mm1,[edi+560]    \
__asm  movq mm4,[edi+568]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+304],mm2   \
__asm  movq [edi+312],mm5   \
__asm  movq [edi+560],mm1   \
__asm  movq [edi+568],mm4   \
 \
 \
/*first:last 4:36  save 1:1  load 1:1  swap 0:0  reverse 1  loadbuffer 0:0  savebuffer 0:1*/ \
__asm  movq mm2,[esi+4]  \
__asm  movq mm5,[esi+4+8] \
__asm  movq mm1,[esi+edx+1]  \
__asm  movq mm4,[esi+edx+1+8]  \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+576],mm1   \
__asm  movq [edi+584],mm4   \
 \
 \
/*first:last 4:20  save 1:1  load 0:1  swap 0:0  reverse 1  loadbuffer 0:0  savebuffer 1:0*/ \
__asm  movq mm1,[esi+2*eax+6]  \
__asm  movq mm4,[esi+2*eax+6+8]  \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+64],mm2   \
__asm  movq [edi+72],mm5   \
 \
 \
/*first:last 20:36  save 1:1  load 0:0  swap 1:0  reverse 0  loadbuffer 0:1  savebuffer 1:1*/ \
__asm  movq mm2,[edi+576]    \
__asm  movq mm5,[edi+584]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+320],mm1   \
__asm  movq [edi+328],mm4   \
__asm  movq [edi+576],mm2   \
__asm  movq [edi+584],mm5   \
 \
 \
/*first:last 5:37  save 1:1  load 1:1  swap 0:0  reverse 0  loadbuffer 0:0  savebuffer 0:1*/ \
__asm  movq mm1,[esi+5]  \
__asm  movq mm4,[esi+5+8] \
__asm  movq mm2,[esi+edx+2]  \
__asm  movq mm5,[esi+edx+2+8]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+592],mm2   \
__asm  movq [edi+600],mm5   \
 \
 \
/*first:last 5:21  save 1:1  load 0:1  swap 0:0  reverse 0  loadbuffer 0:0  savebuffer 1:0*/ \
__asm  movq mm2,[esi+1*ecx+0]  \
__asm  movq mm5,[esi+1*ecx+0+8]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+80],mm1   \
__asm  movq [edi+88],mm4   \
 \
 \
/*first:last 21:37  save 1:1  load 0:0  swap 1:0  reverse 1  loadbuffer 0:1  savebuffer 1:1*/ \
__asm  movq mm1,[edi+592]    \
__asm  movq mm4,[edi+600]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+336],mm2   \
__asm  movq [edi+344],mm5   \
__asm  movq [edi+592],mm1   \
__asm  movq [edi+600],mm4   \
 \
 \
/*first:last 6:38  save 1:1  load 1:1  swap 0:0  reverse 1  loadbuffer 0:0  savebuffer 0:1*/ \
__asm  movq mm2,[esi+6]  \
__asm  movq mm5,[esi+6+8] \
__asm  movq mm1,[esi+edx+3]  \
__asm  movq mm4,[esi+edx+3+8]  \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+608],mm1   \
__asm  movq [edi+616],mm4   \
 \
 \
/*first:last 6:22  save 1:1  load 0:1  swap 0:0  reverse 1  loadbuffer 0:0  savebuffer 1:0*/ \
__asm  movq mm1,[esi+1*ecx+1]  \
__asm  movq mm4,[esi+1*ecx+1+8]  \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+96],mm2   \
__asm  movq [edi+104],mm5   \
 \
 \
/*first:last 22:38  save 1:1  load 0:0  swap 1:0  reverse 0  loadbuffer 0:1  savebuffer 1:1*/ \
__asm  movq mm2,[edi+608]    \
__asm  movq mm5,[edi+616]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+352],mm1   \
__asm  movq [edi+360],mm4   \
__asm  movq [edi+608],mm2   \
__asm  movq [edi+616],mm5   \
 \
 \
/*first:last 7:39  save 1:1  load 1:1  swap 0:0  reverse 0  loadbuffer 0:0  savebuffer 0:1*/ \
__asm  movq mm1,[esi+1*eax+0]  \
__asm  movq mm4,[esi+1*eax+0+8] \
__asm  movq mm2,[esi+edx+4]  \
__asm  movq mm5,[esi+edx+4+8]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+624],mm2   \
__asm  movq [edi+632],mm5   \
 \
 \
/*first:last 7:23  save 1:1  load 0:1  swap 0:0  reverse 0  loadbuffer 0:0  savebuffer 1:0*/ \
__asm  movq mm2,[esi+1*ecx+2]  \
__asm  movq mm5,[esi+1*ecx+2+8]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+112],mm1   \
__asm  movq [edi+120],mm4   \
 \
 \
/*first:last 23:39  save 1:1  load 0:0  swap 1:0  reverse 1  loadbuffer 0:1  savebuffer 1:1*/ \
__asm  movq mm1,[edi+624]    \
__asm  movq mm4,[edi+632]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+368],mm2   \
__asm  movq [edi+376],mm5   \
__asm  movq [edi+624],mm1   \
__asm  movq [edi+632],mm4   \
 \
 \
/*first:last 8:40  save 1:1  load 1:1  swap 0:0  reverse 1  loadbuffer 0:0  savebuffer 0:1*/ \
__asm  movq mm2,[esi+1*eax+1]  \
__asm  movq mm5,[esi+1*eax+1+8] \
__asm  movq mm1,[esi+edx+5]  \
__asm  movq mm4,[esi+edx+5+8]  \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+640],mm1   \
__asm  movq [edi+648],mm4   \
 \
 \
/*first:last 8:24  save 1:1  load 0:1  swap 0:0  reverse 1  loadbuffer 0:0  savebuffer 1:0*/ \
__asm  movq mm0,[esi+1*ecx+3]  \
__asm  movq mm7,[esi+1*ecx+3+8]  \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm0 \
__asm  pminub mm5,mm7 \
__asm  pmaxub mm0,mm3   \
__asm  pmaxub mm7,mm6   \
__asm  movq [edi+128],mm2   \
__asm  movq [edi+136],mm5   \
 \
 \
/*first:last 24:40  save 1:1  load 0:0  swap 1:0  reverse 0  loadbuffer 0:1  savebuffer 1:1*/ \
__asm  movq mm2,[edi+640]    \
__asm  movq mm5,[edi+648]   \
__asm  movq mm3,mm0 \
__asm  movq mm6,mm7 \
__asm  pminub mm0,mm2 \
__asm  pminub mm7,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+640],mm2   \
__asm  movq [edi+648],mm5   \
 \
 \
/*first:last 9:41  save 1:1  load 1:1  swap 0:0  reverse 0  loadbuffer 0:0  savebuffer 0:1*/ \
__asm  movq mm1,[esi+1*eax+2]  \
__asm  movq mm4,[esi+1*eax+2+8] \
__asm  movq mm2,[esi+edx+6]  \
__asm  movq mm5,[esi+edx+6+8]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+656],mm2   \
__asm  movq [edi+664],mm5   \
 \
 \
/*first:last 9:25  save 1:1  load 0:1  swap 0:0  reverse 0  loadbuffer 0:0  savebuffer 1:0*/ \
__asm  movq mm2,[esi+1*ecx+4]  \
__asm  movq mm5,[esi+1*ecx+4+8]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+144],mm1   \
__asm  movq [edi+152],mm4   \
 \
 \
/*first:last 25:41  save 1:1  load 0:0  swap 1:0  reverse 1  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+656]    \
__asm  movq mm4,[edi+664]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+656],mm1   \
__asm  movq [edi+664],mm4   \
 \
 \
/*first:last 17:25  save 1:1  load 0:0  swap 0:1  reverse 0  loadbuffer 1:0  savebuffer 1:1*/ \
__asm  movq mm1,[edi+272]  \
__asm  movq mm4,[edi+280]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+272],mm1   \
__asm  movq [edi+280],mm4   \
__asm  movq [edi+400],mm2   \
__asm  movq [edi+408],mm5   \
 \
 \
/*first:last 10:42  save 1:1  load 1:1  swap 0:0  reverse 0  loadbuffer 0:0  savebuffer 0:1*/ \
__asm  movq mm1,[esi+1*eax+3]  \
__asm  movq mm4,[esi+1*eax+3+8] \
__asm  movq mm2,[esi+2*ecx+0]  \
__asm  movq mm5,[esi+2*ecx+0+8]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+672],mm2   \
__asm  movq [edi+680],mm5   \
 \
 \
/*first:last 10:26  save 1:1  load 0:1  swap 0:0  reverse 0  loadbuffer 0:0  savebuffer 1:0*/ \
__asm  movq mm2,[esi+1*ecx+5]  \
__asm  movq mm5,[esi+1*ecx+5+8]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+160],mm1   \
__asm  movq [edi+168],mm4   \
 \
 \
/*first:last 26:42  save 1:1  load 0:0  swap 1:0  reverse 1  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+672]    \
__asm  movq mm4,[edi+680]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+672],mm1   \
__asm  movq [edi+680],mm4   \
 \
 \
/*first:last 18:26  save 1:1  load 0:0  swap 0:1  reverse 0  loadbuffer 1:0  savebuffer 1:1*/ \
__asm  movq mm1,[edi+288]  \
__asm  movq mm4,[edi+296]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+288],mm1   \
__asm  movq [edi+296],mm4   \
__asm  movq [edi+416],mm2   \
__asm  movq [edi+424],mm5   \
 \
 \
/*first:last 11:43  save 1:1  load 1:1  swap 0:0  reverse 0  loadbuffer 0:0  savebuffer 0:1*/ \
__asm  movq mm1,[esi+1*eax+4]  \
__asm  movq mm4,[esi+1*eax+4+8] \
__asm  movq mm2,[esi+2*ecx+1]  \
__asm  movq mm5,[esi+2*ecx+1+8]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+688],mm2   \
__asm  movq [edi+696],mm5   \
 \
 \
/*first:last 11:27  save 1:1  load 0:1  swap 0:0  reverse 0  loadbuffer 0:0  savebuffer 1:0*/ \
__asm  movq mm2,[esi+1*ecx+6]  \
__asm  movq mm5,[esi+1*ecx+6+8]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+176],mm1   \
__asm  movq [edi+184],mm4   \
 \
 \
/*first:last 27:43  save 1:1  load 0:0  swap 1:0  reverse 1  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+688]    \
__asm  movq mm4,[edi+696]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+688],mm1   \
__asm  movq [edi+696],mm4   \
 \
 \
/*first:last 19:27  save 1:1  load 0:0  swap 0:1  reverse 0  loadbuffer 1:0  savebuffer 1:1*/ \
__asm  movq mm1,[edi+304]  \
__asm  movq mm4,[edi+312]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+304],mm1   \
__asm  movq [edi+312],mm4   \
__asm  movq [edi+432],mm2   \
__asm  movq [edi+440],mm5   \
 \
 \
/*first:last 12:44  save 1:1  load 1:1  swap 0:0  reverse 0  loadbuffer 0:0  savebuffer 0:1*/ \
__asm  movq mm1,[esi+1*eax+5]  \
__asm  movq mm4,[esi+1*eax+5+8] \
__asm  movq mm2,[esi+2*ecx+2]  \
__asm  movq mm5,[esi+2*ecx+2+8]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+704],mm2   \
__asm  movq [edi+712],mm5   \
 \
 \
/*first:last 12:28  save 1:1  load 0:1  swap 0:0  reverse 0  loadbuffer 0:0  savebuffer 1:0*/ \
__asm  movq mm2,[esi+4*eax+0]  \
__asm  movq mm5,[esi+4*eax+0+8]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+192],mm1   \
__asm  movq [edi+200],mm4   \
 \
 \
/*first:last 28:44  save 1:1  load 0:0  swap 1:0  reverse 1  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+704]    \
__asm  movq mm4,[edi+712]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+704],mm1   \
__asm  movq [edi+712],mm4   \
 \
 \
/*first:last 20:28  save 1:1  load 0:0  swap 0:1  reverse 0  loadbuffer 1:0  savebuffer 1:1*/ \
__asm  movq mm1,[edi+320]  \
__asm  movq mm4,[edi+328]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+320],mm1   \
__asm  movq [edi+328],mm4   \
__asm  movq [edi+448],mm2   \
__asm  movq [edi+456],mm5   \
 \
 \
/*first:last 13:45  save 1:1  load 1:1  swap 0:0  reverse 0  loadbuffer 0:0  savebuffer 0:1*/ \
__asm  movq mm1,[esi+1*eax+6]  \
__asm  movq mm4,[esi+1*eax+6+8] \
__asm  movq mm2,[esi+2*ecx+3]  \
__asm  movq mm5,[esi+2*ecx+3+8]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+720],mm2   \
__asm  movq [edi+728],mm5   \
 \
 \
/*first:last 13:29  save 1:1  load 0:1  swap 0:0  reverse 0  loadbuffer 0:0  savebuffer 1:0*/ \
__asm  movq mm2,[esi+4*eax+1]  \
__asm  movq mm5,[esi+4*eax+1+8]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+208],mm1   \
__asm  movq [edi+216],mm4   \
 \
 \
/*first:last 29:45  save 1:1  load 0:0  swap 1:0  reverse 1  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+720]    \
__asm  movq mm4,[edi+728]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+720],mm1   \
__asm  movq [edi+728],mm4   \
 \
 \
/*first:last 21:29  save 1:1  load 0:0  swap 0:1  reverse 0  loadbuffer 1:0  savebuffer 1:1*/ \
__asm  movq mm1,[edi+336]  \
__asm  movq mm4,[edi+344]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+336],mm1   \
__asm  movq [edi+344],mm4   \
__asm  movq [edi+464],mm2   \
__asm  movq [edi+472],mm5   \
 \
 \
/*first:last 14:46  save 1:1  load 1:1  swap 0:0  reverse 0  loadbuffer 0:0  savebuffer 0:1*/ \
__asm  movq mm1,[esi+2*eax+0]  \
__asm  movq mm4,[esi+2*eax+0+8] \
__asm  movq mm2,[esi+2*ecx+4]  \
__asm  movq mm5,[esi+2*ecx+4+8]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+736],mm2   \
__asm  movq [edi+744],mm5   \
 \
 \
/*first:last 14:30  save 1:1  load 0:1  swap 0:0  reverse 0  loadbuffer 0:0  savebuffer 1:0*/ \
__asm  movq mm2,[esi+4*eax+2]  \
__asm  movq mm5,[esi+4*eax+2+8]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+224],mm1   \
__asm  movq [edi+232],mm4   \
 \
 \
/*first:last 30:46  save 1:1  load 0:0  swap 1:0  reverse 1  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+736]    \
__asm  movq mm4,[edi+744]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+736],mm1   \
__asm  movq [edi+744],mm4   \
 \
 \
/*first:last 22:30  save 1:1  load 0:0  swap 0:1  reverse 0  loadbuffer 1:0  savebuffer 1:1*/ \
__asm  movq mm1,[edi+352]  \
__asm  movq mm4,[edi+360]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+352],mm1   \
__asm  movq [edi+360],mm4   \
__asm  movq [edi+480],mm2   \
__asm  movq [edi+488],mm5   \
 \
 \
/*first:last 15:47  save 1:1  load 1:1  swap 0:0  reverse 0  loadbuffer 0:0  savebuffer 0:1*/ \
__asm  movq mm1,[esi+2*eax+1]  \
__asm  movq mm4,[esi+2*eax+1+8] \
__asm  movq mm2,[esi+2*ecx+5]  \
__asm  movq mm5,[esi+2*ecx+5+8]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+752],mm2   \
__asm  movq [edi+760],mm5   \
 \
 \
/*first:last 15:31  save 1:1  load 0:1  swap 0:0  reverse 0  loadbuffer 0:0  savebuffer 1:0*/ \
__asm  movq mm2,[esi+4*eax+3]  \
__asm  movq mm5,[esi+4*eax+3+8]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+240],mm1   \
__asm  movq [edi+248],mm4   \
 \
 \
/*first:last 31:47  save 1:1  load 0:0  swap 1:0  reverse 1  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+752]    \
__asm  movq mm4,[edi+760]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+752],mm1   \
__asm  movq [edi+760],mm4   \
 \
 \
/*first:last 23:31  save 1:1  load 0:0  swap 0:1  reverse 0  loadbuffer 1:0  savebuffer 1:1*/ \
__asm  movq mm1,[edi+368]  \
__asm  movq mm4,[edi+376]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+368],mm1   \
__asm  movq [edi+376],mm4   \
__asm  movq [edi+496],mm2   \
__asm  movq [edi+504],mm5   \
 \
 \
/*first:last 16:48  save 1:1  load 1:1  swap 0:0  reverse 0  loadbuffer 0:0  savebuffer 0:1*/ \
__asm  movq mm1,[esi+2*eax+2]  \
__asm  movq mm4,[esi+2*eax+2+8] \
__asm  movq mm2,[esi+2*ecx+6]  \
__asm  movq mm5,[esi+2*ecx+6+8]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+768],mm2   \
__asm  movq [edi+776],mm5   \
 \
 \
/*first:last 0:16  save 1:1  load 0:0  swap 0:1  reverse 1  loadbuffer 1:0  savebuffer 0:1*/ \
__asm  movq mm2,[edi+0]  \
__asm  movq mm5,[edi+8]  \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+256],mm1   \
__asm  movq [edi+264],mm4   \
 \
 \
/*first:last 0:8  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 0:1  savebuffer 1:1*/ \
__asm  movq mm1,[edi+128]    \
__asm  movq mm4,[edi+136]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+0],mm2   \
__asm  movq [edi+8],mm5   \
__asm  movq [edi+128],mm1   \
__asm  movq [edi+136],mm4   \
 \
 \
/*first:last 32:48  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm2,[edi+512]  \
__asm  movq mm5,[edi+520]  \
__asm  movq mm1,[edi+768]    \
__asm  movq mm4,[edi+776]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+768],mm1   \
__asm  movq [edi+776],mm4   \
 \
 \
/*first:last 16:32  save 1:1  load 0:0  swap 0:1  reverse 0  loadbuffer 1:0  savebuffer 0:1*/ \
__asm  movq mm1,[edi+256]  \
__asm  movq mm4,[edi+264]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+512],mm2   \
__asm  movq [edi+520],mm5   \
 \
 \
/*first:last 16:24  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 1:0*/ \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm0 \
__asm  pminub mm4,mm7 \
__asm  pmaxub mm0,mm3   \
__asm  pmaxub mm7,mm6   \
__asm  movq [edi+256],mm1   \
__asm  movq [edi+264],mm4   \
 \
 \
/*first:last 24:48  save 1:1  load 0:0  swap 1:0  reverse 1  loadbuffer 0:1  savebuffer 1:1*/ \
__asm  movq mm1,[edi+768]    \
__asm  movq mm4,[edi+776]   \
__asm  movq mm3,mm0 \
__asm  movq mm6,mm7 \
__asm  pminub mm0,mm1 \
__asm  pminub mm7,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+768],mm1   \
__asm  movq [edi+776],mm4   \
 \
 \
/*first:last 1:9  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 1:1  savebuffer 1:1*/ \
__asm  movq mm2,[edi+16]  \
__asm  movq mm5,[edi+24]  \
__asm  movq mm1,[edi+144]    \
__asm  movq mm4,[edi+152]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+16],mm2   \
__asm  movq [edi+24],mm5   \
__asm  movq [edi+144],mm1   \
__asm  movq [edi+152],mm4   \
 \
 \
/*first:last 2:10  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 1:1  savebuffer 1:1*/ \
__asm  movq mm2,[edi+32]  \
__asm  movq mm5,[edi+40]  \
__asm  movq mm1,[edi+160]    \
__asm  movq mm4,[edi+168]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+32],mm2   \
__asm  movq [edi+40],mm5   \
__asm  movq [edi+160],mm1   \
__asm  movq [edi+168],mm4   \
 \
 \
/*first:last 3:11  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 1:1  savebuffer 1:1*/ \
__asm  movq mm2,[edi+48]  \
__asm  movq mm5,[edi+56]  \
__asm  movq mm1,[edi+176]    \
__asm  movq mm4,[edi+184]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+48],mm2   \
__asm  movq [edi+56],mm5   \
__asm  movq [edi+176],mm1   \
__asm  movq [edi+184],mm4   \
 \
 \
/*first:last 4:12  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm2,[edi+64]  \
__asm  movq mm5,[edi+72]  \
__asm  movq mm1,[edi+192]    \
__asm  movq mm4,[edi+200]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+192],mm1   \
__asm  movq [edi+200],mm4   \
 \
 \
/*first:last 0:4  save 1:1  load 0:0  swap 0:1  reverse 0  loadbuffer 1:0  savebuffer 1:1*/ \
__asm  movq mm1,[edi+0]  \
__asm  movq mm4,[edi+8]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+0],mm1   \
__asm  movq [edi+8],mm4   \
__asm  movq [edi+64],mm2   \
__asm  movq [edi+72],mm5   \
 \
 \
/*first:last 5:13  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+80]  \
__asm  movq mm4,[edi+88]  \
__asm  movq mm2,[edi+208]    \
__asm  movq mm5,[edi+216]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+208],mm2   \
__asm  movq [edi+216],mm5   \
 \
 \
/*first:last 1:5  save 1:1  load 0:0  swap 0:1  reverse 1  loadbuffer 1:0  savebuffer 1:1*/ \
__asm  movq mm2,[edi+16]  \
__asm  movq mm5,[edi+24]  \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+16],mm2   \
__asm  movq [edi+24],mm5   \
__asm  movq [edi+80],mm1   \
__asm  movq [edi+88],mm4   \
 \
 \
/*first:last 6:14  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm2,[edi+96]  \
__asm  movq mm5,[edi+104]  \
__asm  movq mm1,[edi+224]    \
__asm  movq mm4,[edi+232]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+224],mm1   \
__asm  movq [edi+232],mm4   \
 \
 \
/*first:last 2:6  save 1:1  load 0:0  swap 0:1  reverse 0  loadbuffer 1:0  savebuffer 0:1*/ \
__asm  movq mm1,[edi+32]  \
__asm  movq mm4,[edi+40]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+96],mm2   \
__asm  movq [edi+104],mm5   \
 \
 \
/*first:last 0:2  save 1:1  load 0:0  swap 0:1  reverse 1  loadbuffer 1:0  savebuffer 1:1*/ \
__asm  movq mm2,[edi+0]  \
__asm  movq mm5,[edi+8]  \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+0],mm2   \
__asm  movq [edi+8],mm5   \
__asm  movq [edi+32],mm1   \
__asm  movq [edi+40],mm4   \
 \
 \
/*first:last 7:15  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm2,[edi+112]  \
__asm  movq mm5,[edi+120]  \
__asm  movq mm1,[edi+240]    \
__asm  movq mm4,[edi+248]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+240],mm1   \
__asm  movq [edi+248],mm4   \
 \
 \
/*first:last 3:7  save 1:1  load 0:0  swap 0:1  reverse 0  loadbuffer 1:0  savebuffer 0:1*/ \
__asm  movq mm1,[edi+48]  \
__asm  movq mm4,[edi+56]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+112],mm2   \
__asm  movq [edi+120],mm5   \
 \
 \
/*first:last 1:3  save 1:1  load 0:0  swap 0:1  reverse 1  loadbuffer 1:0  savebuffer 0:1*/ \
__asm  movq mm2,[edi+16]  \
__asm  movq mm5,[edi+24]  \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+48],mm1   \
__asm  movq [edi+56],mm4   \
 \
 \
/*first:last 0:1  save 0:1  load 0:0  swap 0:1  reverse 0  loadbuffer 1:0  savebuffer 0:1*/ \
__asm  movq mm1,[edi+0]  \
__asm  movq mm4,[edi+8]  \
__asm  pmaxub mm2,mm1 \
__asm  pmaxub mm5,mm4 \
__asm  movq [edi+16],mm2   \
__asm  movq [edi+24],mm5   \
 \
 \
/*first:last 32:40  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+512]  \
__asm  movq mm4,[edi+520]  \
__asm  movq mm2,[edi+640]    \
__asm  movq mm5,[edi+648]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+640],mm2   \
__asm  movq [edi+648],mm5   \
 \
 \
/*first:last 8:32  save 1:1  load 0:0  swap 0:1  reverse 1  loadbuffer 1:0  savebuffer 0:1*/ \
__asm  movq mm2,[edi+128]  \
__asm  movq mm5,[edi+136]  \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+512],mm1   \
__asm  movq [edi+520],mm4   \
 \
 \
/*first:last 8:16  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 0:1  savebuffer 1:1*/ \
__asm  movq mm1,[edi+256]    \
__asm  movq mm4,[edi+264]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+128],mm2   \
__asm  movq [edi+136],mm5   \
__asm  movq [edi+256],mm1   \
__asm  movq [edi+264],mm4   \
 \
 \
/*first:last 33:41  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm2,[edi+528]  \
__asm  movq mm5,[edi+536]  \
__asm  movq mm1,[edi+656]    \
__asm  movq mm4,[edi+664]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+656],mm1   \
__asm  movq [edi+664],mm4   \
 \
 \
/*first:last 9:33  save 1:1  load 0:0  swap 0:1  reverse 0  loadbuffer 1:0  savebuffer 0:1*/ \
__asm  movq mm1,[edi+144]  \
__asm  movq mm4,[edi+152]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+528],mm2   \
__asm  movq [edi+536],mm5   \
 \
 \
/*first:last 9:17  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 1:1*/ \
__asm  movq mm2,[edi+272]    \
__asm  movq mm5,[edi+280]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+144],mm1   \
__asm  movq [edi+152],mm4   \
__asm  movq [edi+272],mm2   \
__asm  movq [edi+280],mm5   \
 \
 \
/*first:last 34:42  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+544]  \
__asm  movq mm4,[edi+552]  \
__asm  movq mm2,[edi+672]    \
__asm  movq mm5,[edi+680]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+672],mm2   \
__asm  movq [edi+680],mm5   \
 \
 \
/*first:last 10:34  save 1:1  load 0:0  swap 0:1  reverse 1  loadbuffer 1:0  savebuffer 0:1*/ \
__asm  movq mm2,[edi+160]  \
__asm  movq mm5,[edi+168]  \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+544],mm1   \
__asm  movq [edi+552],mm4   \
 \
 \
/*first:last 10:18  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 0:1  savebuffer 1:1*/ \
__asm  movq mm1,[edi+288]    \
__asm  movq mm4,[edi+296]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+160],mm2   \
__asm  movq [edi+168],mm5   \
__asm  movq [edi+288],mm1   \
__asm  movq [edi+296],mm4   \
 \
 \
/*first:last 35:43  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm2,[edi+560]  \
__asm  movq mm5,[edi+568]  \
__asm  movq mm1,[edi+688]    \
__asm  movq mm4,[edi+696]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+688],mm1   \
__asm  movq [edi+696],mm4   \
 \
 \
/*first:last 11:35  save 1:1  load 0:0  swap 0:1  reverse 0  loadbuffer 1:0  savebuffer 0:1*/ \
__asm  movq mm1,[edi+176]  \
__asm  movq mm4,[edi+184]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+560],mm2   \
__asm  movq [edi+568],mm5   \
 \
 \
/*first:last 11:19  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 1:1*/ \
__asm  movq mm2,[edi+304]    \
__asm  movq mm5,[edi+312]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+176],mm1   \
__asm  movq [edi+184],mm4   \
__asm  movq [edi+304],mm2   \
__asm  movq [edi+312],mm5   \
 \
 \
/*first:last 36:44  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+576]  \
__asm  movq mm4,[edi+584]  \
__asm  movq mm2,[edi+704]    \
__asm  movq mm5,[edi+712]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+704],mm2   \
__asm  movq [edi+712],mm5   \
 \
 \
/*first:last 12:36  save 1:1  load 0:0  swap 0:1  reverse 1  loadbuffer 1:0  savebuffer 0:1*/ \
__asm  movq mm2,[edi+192]  \
__asm  movq mm5,[edi+200]  \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+576],mm1   \
__asm  movq [edi+584],mm4   \
 \
 \
/*first:last 12:20  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+320]    \
__asm  movq mm4,[edi+328]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+320],mm1   \
__asm  movq [edi+328],mm4   \
 \
 \
/*first:last 8:12  save 1:1  load 0:0  swap 0:1  reverse 0  loadbuffer 1:0  savebuffer 1:1*/ \
__asm  movq mm1,[edi+128]  \
__asm  movq mm4,[edi+136]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+128],mm1   \
__asm  movq [edi+136],mm4   \
__asm  movq [edi+192],mm2   \
__asm  movq [edi+200],mm5   \
 \
 \
/*first:last 37:45  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+592]  \
__asm  movq mm4,[edi+600]  \
__asm  movq mm2,[edi+720]    \
__asm  movq mm5,[edi+728]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+720],mm2   \
__asm  movq [edi+728],mm5   \
 \
 \
/*first:last 13:37  save 1:1  load 0:0  swap 0:1  reverse 1  loadbuffer 1:0  savebuffer 0:1*/ \
__asm  movq mm2,[edi+208]  \
__asm  movq mm5,[edi+216]  \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+592],mm1   \
__asm  movq [edi+600],mm4   \
 \
 \
/*first:last 13:21  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+336]    \
__asm  movq mm4,[edi+344]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+336],mm1   \
__asm  movq [edi+344],mm4   \
 \
 \
/*first:last 9:13  save 1:1  load 0:0  swap 0:1  reverse 0  loadbuffer 1:0  savebuffer 1:1*/ \
__asm  movq mm1,[edi+144]  \
__asm  movq mm4,[edi+152]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+144],mm1   \
__asm  movq [edi+152],mm4   \
__asm  movq [edi+208],mm2   \
__asm  movq [edi+216],mm5   \
 \
 \
/*first:last 38:46  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+608]  \
__asm  movq mm4,[edi+616]  \
__asm  movq mm2,[edi+736]    \
__asm  movq mm5,[edi+744]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+736],mm2   \
__asm  movq [edi+744],mm5   \
 \
 \
/*first:last 14:38  save 1:1  load 0:0  swap 0:1  reverse 1  loadbuffer 1:0  savebuffer 0:1*/ \
__asm  movq mm2,[edi+224]  \
__asm  movq mm5,[edi+232]  \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+608],mm1   \
__asm  movq [edi+616],mm4   \
 \
 \
/*first:last 14:22  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+352]    \
__asm  movq mm4,[edi+360]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+352],mm1   \
__asm  movq [edi+360],mm4   \
 \
 \
/*first:last 10:14  save 1:1  load 0:0  swap 0:1  reverse 0  loadbuffer 1:0  savebuffer 1:1*/ \
__asm  movq mm1,[edi+160]  \
__asm  movq mm4,[edi+168]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+160],mm1   \
__asm  movq [edi+168],mm4   \
__asm  movq [edi+224],mm2   \
__asm  movq [edi+232],mm5   \
 \
 \
/*first:last 39:47  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+624]  \
__asm  movq mm4,[edi+632]  \
__asm  movq mm2,[edi+752]    \
__asm  movq mm5,[edi+760]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+752],mm2   \
__asm  movq [edi+760],mm5   \
 \
 \
/*first:last 15:39  save 1:1  load 0:0  swap 0:1  reverse 1  loadbuffer 1:0  savebuffer 0:1*/ \
__asm  movq mm2,[edi+240]  \
__asm  movq mm5,[edi+248]  \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+624],mm1   \
__asm  movq [edi+632],mm4   \
 \
 \
/*first:last 15:23  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+368]    \
__asm  movq mm4,[edi+376]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+368],mm1   \
__asm  movq [edi+376],mm4   \
 \
 \
/*first:last 11:15  save 1:1  load 0:0  swap 0:1  reverse 0  loadbuffer 1:0  savebuffer 1:1*/ \
__asm  movq mm1,[edi+176]  \
__asm  movq mm4,[edi+184]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+176],mm1   \
__asm  movq [edi+184],mm4   \
__asm  movq [edi+240],mm2   \
__asm  movq [edi+248],mm5   \
 \
 \
/*first:last 24:32  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:1  savebuffer 1:1*/ \
__asm  movq mm2,[edi+512]    \
__asm  movq mm5,[edi+520]   \
__asm  movq mm3,mm0 \
__asm  movq mm6,mm7 \
__asm  pminub mm0,mm2 \
__asm  pminub mm7,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+512],mm2   \
__asm  movq [edi+520],mm5   \
 \
 \
/*first:last 25:33  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:1  savebuffer 1:1*/ \
__asm  movq mm1,[edi+400]  \
__asm  movq mm4,[edi+408]  \
__asm  movq mm2,[edi+528]    \
__asm  movq mm5,[edi+536]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+400],mm1   \
__asm  movq [edi+408],mm4   \
__asm  movq [edi+528],mm2   \
__asm  movq [edi+536],mm5   \
 \
 \
/*first:last 26:34  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:1  savebuffer 1:1*/ \
__asm  movq mm1,[edi+416]  \
__asm  movq mm4,[edi+424]  \
__asm  movq mm2,[edi+544]    \
__asm  movq mm5,[edi+552]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+416],mm1   \
__asm  movq [edi+424],mm4   \
__asm  movq [edi+544],mm2   \
__asm  movq [edi+552],mm5   \
 \
 \
/*first:last 27:35  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:1  savebuffer 1:1*/ \
__asm  movq mm1,[edi+432]  \
__asm  movq mm4,[edi+440]  \
__asm  movq mm2,[edi+560]    \
__asm  movq mm5,[edi+568]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+432],mm1   \
__asm  movq [edi+440],mm4   \
__asm  movq [edi+560],mm2   \
__asm  movq [edi+568],mm5   \
 \
 \
/*first:last 28:36  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+448]  \
__asm  movq mm4,[edi+456]  \
__asm  movq mm2,[edi+576]    \
__asm  movq mm5,[edi+584]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+576],mm2   \
__asm  movq [edi+584],mm5   \
 \
 \
/*first:last 24:28  save 1:1  load 0:0  swap 0:1  reverse 1  loadbuffer 1:0  savebuffer 1:1*/ \
__asm  movq mm3,mm0 \
__asm  movq mm6,mm7 \
__asm  pminub mm0,mm1 \
__asm  pminub mm7,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+448],mm1   \
__asm  movq [edi+456],mm4   \
 \
 \
/*first:last 29:37  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm2,[edi+464]  \
__asm  movq mm5,[edi+472]  \
__asm  movq mm1,[edi+592]    \
__asm  movq mm4,[edi+600]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+592],mm1   \
__asm  movq [edi+600],mm4   \
 \
 \
/*first:last 25:29  save 1:1  load 0:0  swap 0:1  reverse 0  loadbuffer 1:0  savebuffer 1:1*/ \
__asm  movq mm1,[edi+400]  \
__asm  movq mm4,[edi+408]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+400],mm1   \
__asm  movq [edi+408],mm4   \
__asm  movq [edi+464],mm2   \
__asm  movq [edi+472],mm5   \
 \
 \
/*first:last 30:38  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+480]  \
__asm  movq mm4,[edi+488]  \
__asm  movq mm2,[edi+608]    \
__asm  movq mm5,[edi+616]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+608],mm2   \
__asm  movq [edi+616],mm5   \
 \
 \
/*first:last 26:30  save 1:1  load 0:0  swap 0:1  reverse 1  loadbuffer 1:0  savebuffer 1:1*/ \
__asm  movq mm2,[edi+416]  \
__asm  movq mm5,[edi+424]  \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+416],mm2   \
__asm  movq [edi+424],mm5   \
__asm  movq [edi+480],mm1   \
__asm  movq [edi+488],mm4   \
 \
 \
/*first:last 31:39  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm2,[edi+496]  \
__asm  movq mm5,[edi+504]  \
__asm  movq mm1,[edi+624]    \
__asm  movq mm4,[edi+632]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+624],mm1   \
__asm  movq [edi+632],mm4   \
 \
 \
/*first:last 27:31  save 1:1  load 0:0  swap 0:1  reverse 0  loadbuffer 1:0  savebuffer 1:1*/ \
__asm  movq mm1,[edi+432]  \
__asm  movq mm4,[edi+440]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+432],mm1   \
__asm  movq [edi+440],mm4   \
__asm  movq [edi+496],mm2   \
__asm  movq [edi+504],mm5   \
 \
 \
/*first:last 40:48  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+640]  \
__asm  movq mm4,[edi+648]  \
__asm  movq mm2,[edi+768]    \
__asm  movq mm5,[edi+776]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+768],mm2   \
__asm  movq [edi+776],mm5   \
 \
 \
/*first:last 40:44  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm2,[edi+704]    \
__asm  movq mm5,[edi+712]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+704],mm2   \
__asm  movq [edi+712],mm5   \
 \
 \
/*first:last 12:40  save 1:1  load 0:0  swap 0:1  reverse 1  loadbuffer 1:0  savebuffer 0:1*/ \
__asm  movq mm2,[edi+192]  \
__asm  movq mm5,[edi+200]  \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+640],mm1   \
__asm  movq [edi+648],mm4   \
 \
 \
/*first:last 12:24  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 0:1  savebuffer 1:1*/ \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm0 \
__asm  pminub mm5,mm7 \
__asm  pmaxub mm0,mm3   \
__asm  pmaxub mm7,mm6   \
__asm  movq [edi+192],mm2   \
__asm  movq [edi+200],mm5   \
 \
 \
/*first:last 16:20  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 1:1  savebuffer 1:0*/ \
__asm  movq mm2,[edi+256]  \
__asm  movq mm5,[edi+264]  \
__asm  movq mm1,[edi+320]    \
__asm  movq mm4,[edi+328]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+256],mm2   \
__asm  movq [edi+264],mm5   \
 \
 \
/*first:last 20:48  save 1:1  load 0:0  swap 1:0  reverse 0  loadbuffer 0:1  savebuffer 1:1*/ \
__asm  movq mm2,[edi+768]    \
__asm  movq mm5,[edi+776]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+320],mm1   \
__asm  movq [edi+328],mm4   \
__asm  movq [edi+768],mm2   \
__asm  movq [edi+776],mm5   \
 \
 \
/*first:last 17:21  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:1  savebuffer 1:1*/ \
__asm  movq mm1,[edi+272]  \
__asm  movq mm4,[edi+280]  \
__asm  movq mm2,[edi+336]    \
__asm  movq mm5,[edi+344]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+272],mm1   \
__asm  movq [edi+280],mm4   \
__asm  movq [edi+336],mm2   \
__asm  movq [edi+344],mm5   \
 \
 \
/*first:last 18:22  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:1  savebuffer 1:1*/ \
__asm  movq mm1,[edi+288]  \
__asm  movq mm4,[edi+296]  \
__asm  movq mm2,[edi+352]    \
__asm  movq mm5,[edi+360]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+288],mm1   \
__asm  movq [edi+296],mm4   \
__asm  movq [edi+352],mm2   \
__asm  movq [edi+360],mm5   \
 \
 \
/*first:last 19:23  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:1  savebuffer 1:1*/ \
__asm  movq mm1,[edi+304]  \
__asm  movq mm4,[edi+312]  \
__asm  movq mm2,[edi+368]    \
__asm  movq mm5,[edi+376]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+304],mm1   \
__asm  movq [edi+312],mm4   \
__asm  movq [edi+368],mm2   \
__asm  movq [edi+376],mm5   \
 \
 \
/*first:last 32:36  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+512]  \
__asm  movq mm4,[edi+520]  \
__asm  movq mm2,[edi+576]    \
__asm  movq mm5,[edi+584]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+576],mm2   \
__asm  movq [edi+584],mm5   \
 \
 \
/*first:last 4:32  save 1:1  load 0:0  swap 0:1  reverse 1  loadbuffer 1:0  savebuffer 0:1*/ \
__asm  movq mm2,[edi+64]  \
__asm  movq mm5,[edi+72]  \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+512],mm1   \
__asm  movq [edi+520],mm4   \
 \
 \
/*first:last 4:16  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+256]    \
__asm  movq mm4,[edi+264]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+256],mm1   \
__asm  movq [edi+264],mm4   \
 \
 \
/*first:last 4:8  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 0:1  savebuffer 1:1*/ \
__asm  movq mm1,[edi+128]    \
__asm  movq mm4,[edi+136]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+64],mm2   \
__asm  movq [edi+72],mm5   \
__asm  movq [edi+128],mm1   \
__asm  movq [edi+136],mm4   \
 \
 \
/*first:last 33:37  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm2,[edi+528]  \
__asm  movq mm5,[edi+536]  \
__asm  movq mm1,[edi+592]    \
__asm  movq mm4,[edi+600]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+592],mm1   \
__asm  movq [edi+600],mm4   \
 \
 \
/*first:last 5:33  save 1:1  load 0:0  swap 0:1  reverse 0  loadbuffer 1:0  savebuffer 0:1*/ \
__asm  movq mm1,[edi+80]  \
__asm  movq mm4,[edi+88]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+528],mm2   \
__asm  movq [edi+536],mm5   \
 \
 \
/*first:last 5:17  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm2,[edi+272]    \
__asm  movq mm5,[edi+280]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+272],mm2   \
__asm  movq [edi+280],mm5   \
 \
 \
/*first:last 5:9  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 1:1*/ \
__asm  movq mm2,[edi+144]    \
__asm  movq mm5,[edi+152]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+80],mm1   \
__asm  movq [edi+88],mm4   \
__asm  movq [edi+144],mm2   \
__asm  movq [edi+152],mm5   \
 \
 \
/*first:last 34:38  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+544]  \
__asm  movq mm4,[edi+552]  \
__asm  movq mm2,[edi+608]    \
__asm  movq mm5,[edi+616]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+608],mm2   \
__asm  movq [edi+616],mm5   \
 \
 \
/*first:last 6:34  save 1:1  load 0:0  swap 0:1  reverse 1  loadbuffer 1:0  savebuffer 0:1*/ \
__asm  movq mm2,[edi+96]  \
__asm  movq mm5,[edi+104]  \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+544],mm1   \
__asm  movq [edi+552],mm4   \
 \
 \
/*first:last 6:18  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+288]    \
__asm  movq mm4,[edi+296]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+288],mm1   \
__asm  movq [edi+296],mm4   \
 \
 \
/*first:last 6:10  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+160]    \
__asm  movq mm4,[edi+168]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+160],mm1   \
__asm  movq [edi+168],mm4   \
 \
 \
/*first:last 4:6  save 1:1  load 0:0  swap 0:1  reverse 0  loadbuffer 1:0  savebuffer 1:1*/ \
__asm  movq mm1,[edi+64]  \
__asm  movq mm4,[edi+72]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+64],mm1   \
__asm  movq [edi+72],mm4   \
__asm  movq [edi+96],mm2   \
__asm  movq [edi+104],mm5   \
 \
 \
/*first:last 35:39  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+560]  \
__asm  movq mm4,[edi+568]  \
__asm  movq mm2,[edi+624]    \
__asm  movq mm5,[edi+632]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+624],mm2   \
__asm  movq [edi+632],mm5   \
 \
 \
/*first:last 7:35  save 1:1  load 0:0  swap 0:1  reverse 1  loadbuffer 1:0  savebuffer 0:1*/ \
__asm  movq mm2,[edi+112]  \
__asm  movq mm5,[edi+120]  \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+560],mm1   \
__asm  movq [edi+568],mm4   \
 \
 \
/*first:last 7:19  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+304]    \
__asm  movq mm4,[edi+312]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+304],mm1   \
__asm  movq [edi+312],mm4   \
 \
 \
/*first:last 7:11  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+176]    \
__asm  movq mm4,[edi+184]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+176],mm1   \
__asm  movq [edi+184],mm4   \
 \
 \
/*first:last 5:7  save 1:1  load 0:0  swap 0:1  reverse 0  loadbuffer 1:0  savebuffer 1:1*/ \
__asm  movq mm1,[edi+80]  \
__asm  movq mm4,[edi+88]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+80],mm1   \
__asm  movq [edi+88],mm4   \
__asm  movq [edi+112],mm2   \
__asm  movq [edi+120],mm5   \
 \
 \
/*first:last 41:45  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+656]  \
__asm  movq mm4,[edi+664]  \
__asm  movq mm2,[edi+720]    \
__asm  movq mm5,[edi+728]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+720],mm2   \
__asm  movq [edi+728],mm5   \
 \
 \
/*first:last 13:41  save 1:1  load 0:0  swap 0:1  reverse 1  loadbuffer 1:0  savebuffer 0:1*/ \
__asm  movq mm2,[edi+208]  \
__asm  movq mm5,[edi+216]  \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+656],mm1   \
__asm  movq [edi+664],mm4   \
 \
 \
/*first:last 13:25  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+400]    \
__asm  movq mm4,[edi+408]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+400],mm1   \
__asm  movq [edi+408],mm4   \
 \
 \
/*first:last 13:17  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 0:1  savebuffer 1:1*/ \
__asm  movq mm1,[edi+272]    \
__asm  movq mm4,[edi+280]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+208],mm2   \
__asm  movq [edi+216],mm5   \
__asm  movq [edi+272],mm1   \
__asm  movq [edi+280],mm4   \
 \
 \
/*first:last 42:46  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm2,[edi+672]  \
__asm  movq mm5,[edi+680]  \
__asm  movq mm1,[edi+736]    \
__asm  movq mm4,[edi+744]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+736],mm1   \
__asm  movq [edi+744],mm4   \
 \
 \
/*first:last 14:42  save 1:1  load 0:0  swap 0:1  reverse 0  loadbuffer 1:0  savebuffer 0:1*/ \
__asm  movq mm1,[edi+224]  \
__asm  movq mm4,[edi+232]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+672],mm2   \
__asm  movq [edi+680],mm5   \
 \
 \
/*first:last 14:26  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm2,[edi+416]    \
__asm  movq mm5,[edi+424]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+416],mm2   \
__asm  movq [edi+424],mm5   \
 \
 \
/*first:last 14:18  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 1:1*/ \
__asm  movq mm2,[edi+288]    \
__asm  movq mm5,[edi+296]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+224],mm1   \
__asm  movq [edi+232],mm4   \
__asm  movq [edi+288],mm2   \
__asm  movq [edi+296],mm5   \
 \
 \
/*first:last 43:47  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+688]  \
__asm  movq mm4,[edi+696]  \
__asm  movq mm2,[edi+752]    \
__asm  movq mm5,[edi+760]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+752],mm2   \
__asm  movq [edi+760],mm5   \
 \
 \
/*first:last 15:43  save 1:1  load 0:0  swap 0:1  reverse 1  loadbuffer 1:0  savebuffer 0:1*/ \
__asm  movq mm2,[edi+240]  \
__asm  movq mm5,[edi+248]  \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+688],mm1   \
__asm  movq [edi+696],mm4   \
 \
 \
/*first:last 15:27  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+432]    \
__asm  movq mm4,[edi+440]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+432],mm1   \
__asm  movq [edi+440],mm4   \
 \
 \
/*first:last 15:19  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+304]    \
__asm  movq mm4,[edi+312]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+304],mm1   \
__asm  movq [edi+312],mm4   \
 \
 \
/*first:last 13:15  save 1:1  load 0:0  swap 0:1  reverse 0  loadbuffer 1:0  savebuffer 1:1*/ \
__asm  movq mm1,[edi+208]  \
__asm  movq mm4,[edi+216]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+208],mm1   \
__asm  movq [edi+216],mm4   \
__asm  movq [edi+240],mm2   \
__asm  movq [edi+248],mm5   \
 \
 \
/*first:last 20:32  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+320]  \
__asm  movq mm4,[edi+328]  \
__asm  movq mm2,[edi+512]    \
__asm  movq mm5,[edi+520]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+512],mm2   \
__asm  movq [edi+520],mm5   \
 \
 \
/*first:last 20:24  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 1:1*/ \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm0 \
__asm  pminub mm4,mm7 \
__asm  pmaxub mm0,mm3   \
__asm  pmaxub mm7,mm6   \
__asm  movq [edi+320],mm1   \
__asm  movq [edi+328],mm4   \
 \
 \
/*first:last 21:33  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+336]  \
__asm  movq mm4,[edi+344]  \
__asm  movq mm2,[edi+528]    \
__asm  movq mm5,[edi+536]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+528],mm2   \
__asm  movq [edi+536],mm5   \
 \
 \
/*first:last 21:25  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 1:1*/ \
__asm  movq mm2,[edi+400]    \
__asm  movq mm5,[edi+408]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+336],mm1   \
__asm  movq [edi+344],mm4   \
__asm  movq [edi+400],mm2   \
__asm  movq [edi+408],mm5   \
 \
 \
/*first:last 22:34  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+352]  \
__asm  movq mm4,[edi+360]  \
__asm  movq mm2,[edi+544]    \
__asm  movq mm5,[edi+552]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+544],mm2   \
__asm  movq [edi+552],mm5   \
 \
 \
/*first:last 22:26  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm2,[edi+416]    \
__asm  movq mm5,[edi+424]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+416],mm2   \
__asm  movq [edi+424],mm5   \
 \
 \
/*first:last 20:22  save 1:1  load 0:0  swap 0:1  reverse 1  loadbuffer 1:0  savebuffer 1:1*/ \
__asm  movq mm2,[edi+320]  \
__asm  movq mm5,[edi+328]  \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+320],mm2   \
__asm  movq [edi+328],mm5   \
__asm  movq [edi+352],mm1   \
__asm  movq [edi+360],mm4   \
 \
 \
/*first:last 23:35  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm2,[edi+368]  \
__asm  movq mm5,[edi+376]  \
__asm  movq mm1,[edi+560]    \
__asm  movq mm4,[edi+568]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+560],mm1   \
__asm  movq [edi+568],mm4   \
 \
 \
/*first:last 23:27  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+432]    \
__asm  movq mm4,[edi+440]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+432],mm1   \
__asm  movq [edi+440],mm4   \
 \
 \
/*first:last 21:23  save 1:1  load 0:0  swap 0:1  reverse 0  loadbuffer 1:0  savebuffer 1:1*/ \
__asm  movq mm1,[edi+336]  \
__asm  movq mm4,[edi+344]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+336],mm1   \
__asm  movq [edi+344],mm4   \
__asm  movq [edi+368],mm2   \
__asm  movq [edi+376],mm5   \
 \
 \
/*first:last 28:40  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+448]  \
__asm  movq mm4,[edi+456]  \
__asm  movq mm2,[edi+640]    \
__asm  movq mm5,[edi+648]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+640],mm2   \
__asm  movq [edi+648],mm5   \
 \
 \
/*first:last 28:32  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 1:1*/ \
__asm  movq mm2,[edi+512]    \
__asm  movq mm5,[edi+520]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+448],mm1   \
__asm  movq [edi+456],mm4   \
__asm  movq [edi+512],mm2   \
__asm  movq [edi+520],mm5   \
 \
 \
/*first:last 29:41  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+464]  \
__asm  movq mm4,[edi+472]  \
__asm  movq mm2,[edi+656]    \
__asm  movq mm5,[edi+664]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+656],mm2   \
__asm  movq [edi+664],mm5   \
 \
 \
/*first:last 29:33  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 1:1*/ \
__asm  movq mm2,[edi+528]    \
__asm  movq mm5,[edi+536]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+464],mm1   \
__asm  movq [edi+472],mm4   \
__asm  movq [edi+528],mm2   \
__asm  movq [edi+536],mm5   \
 \
 \
/*first:last 30:42  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+480]  \
__asm  movq mm4,[edi+488]  \
__asm  movq mm2,[edi+672]    \
__asm  movq mm5,[edi+680]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+672],mm2   \
__asm  movq [edi+680],mm5   \
 \
 \
/*first:last 30:34  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm2,[edi+544]    \
__asm  movq mm5,[edi+552]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+544],mm2   \
__asm  movq [edi+552],mm5   \
 \
 \
/*first:last 28:30  save 1:1  load 0:0  swap 0:1  reverse 1  loadbuffer 1:0  savebuffer 1:1*/ \
__asm  movq mm2,[edi+448]  \
__asm  movq mm5,[edi+456]  \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+448],mm2   \
__asm  movq [edi+456],mm5   \
__asm  movq [edi+480],mm1   \
__asm  movq [edi+488],mm4   \
 \
 \
/*first:last 31:43  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm2,[edi+496]  \
__asm  movq mm5,[edi+504]  \
__asm  movq mm1,[edi+688]    \
__asm  movq mm4,[edi+696]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+688],mm1   \
__asm  movq [edi+696],mm4   \
 \
 \
/*first:last 31:35  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+560]    \
__asm  movq mm4,[edi+568]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+560],mm1   \
__asm  movq [edi+568],mm4   \
 \
 \
/*first:last 29:31  save 1:1  load 0:0  swap 0:1  reverse 0  loadbuffer 1:0  savebuffer 1:1*/ \
__asm  movq mm1,[edi+464]  \
__asm  movq mm4,[edi+472]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+464],mm1   \
__asm  movq [edi+472],mm4   \
__asm  movq [edi+496],mm2   \
__asm  movq [edi+504],mm5   \
 \
 \
/*first:last 36:48  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+576]  \
__asm  movq mm4,[edi+584]  \
__asm  movq mm2,[edi+768]    \
__asm  movq mm5,[edi+776]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+768],mm2   \
__asm  movq [edi+776],mm5   \
 \
 \
/*first:last 36:40  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 1:1*/ \
__asm  movq mm2,[edi+640]    \
__asm  movq mm5,[edi+648]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+576],mm1   \
__asm  movq [edi+584],mm4   \
__asm  movq [edi+640],mm2   \
__asm  movq [edi+648],mm5   \
 \
 \
/*first:last 12:16  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+192]  \
__asm  movq mm4,[edi+200]  \
__asm  movq mm2,[edi+256]    \
__asm  movq mm5,[edi+264]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+256],mm2   \
__asm  movq [edi+264],mm5   \
 \
 \
/*first:last 12:14  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 1:1*/ \
__asm  movq mm2,[edi+224]    \
__asm  movq mm5,[edi+232]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+192],mm1   \
__asm  movq [edi+200],mm4   \
__asm  movq [edi+224],mm2   \
__asm  movq [edi+232],mm5   \
 \
 \
/*first:last 37:41  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:1  savebuffer 1:1*/ \
__asm  movq mm1,[edi+592]  \
__asm  movq mm4,[edi+600]  \
__asm  movq mm2,[edi+656]    \
__asm  movq mm5,[edi+664]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+592],mm1   \
__asm  movq [edi+600],mm4   \
__asm  movq [edi+656],mm2   \
__asm  movq [edi+664],mm5   \
 \
 \
/*first:last 38:42  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+608]  \
__asm  movq mm4,[edi+616]  \
__asm  movq mm2,[edi+672]    \
__asm  movq mm5,[edi+680]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+672],mm2   \
__asm  movq [edi+680],mm5   \
 \
 \
/*first:last 36:38  save 1:1  load 0:0  swap 0:1  reverse 1  loadbuffer 1:0  savebuffer 0:1*/ \
__asm  movq mm2,[edi+576]  \
__asm  movq mm5,[edi+584]  \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+608],mm1   \
__asm  movq [edi+616],mm4   \
 \
 \
/*first:last 6:36  save 1:1  load 0:0  swap 0:1  reverse 0  loadbuffer 1:0  savebuffer 0:1*/ \
__asm  movq mm1,[edi+96]  \
__asm  movq mm4,[edi+104]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+576],mm2   \
__asm  movq [edi+584],mm5   \
 \
 \
/*first:last 6:20  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm2,[edi+320]    \
__asm  movq mm5,[edi+328]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+320],mm2   \
__asm  movq [edi+328],mm5   \
 \
 \
/*first:last 6:12  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 1:1*/ \
__asm  movq mm2,[edi+192]    \
__asm  movq mm5,[edi+200]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+96],mm1   \
__asm  movq [edi+104],mm4   \
__asm  movq [edi+192],mm2   \
__asm  movq [edi+200],mm5   \
 \
 \
/*first:last 39:43  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+624]  \
__asm  movq mm4,[edi+632]  \
__asm  movq mm2,[edi+688]    \
__asm  movq mm5,[edi+696]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+688],mm2   \
__asm  movq [edi+696],mm5   \
 \
 \
/*first:last 37:39  save 1:1  load 0:0  swap 0:1  reverse 1  loadbuffer 1:0  savebuffer 0:1*/ \
__asm  movq mm2,[edi+592]  \
__asm  movq mm5,[edi+600]  \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+624],mm1   \
__asm  movq [edi+632],mm4   \
 \
 \
/*first:last 7:37  save 1:1  load 0:0  swap 0:1  reverse 0  loadbuffer 1:0  savebuffer 0:1*/ \
__asm  movq mm1,[edi+112]  \
__asm  movq mm4,[edi+120]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+592],mm2   \
__asm  movq [edi+600],mm5   \
 \
 \
/*first:last 7:21  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm2,[edi+336]    \
__asm  movq mm5,[edi+344]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+336],mm2   \
__asm  movq [edi+344],mm5   \
 \
 \
/*first:last 7:13  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 1:1*/ \
__asm  movq mm2,[edi+208]    \
__asm  movq mm5,[edi+216]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+112],mm1   \
__asm  movq [edi+120],mm4   \
__asm  movq [edi+208],mm2   \
__asm  movq [edi+216],mm5   \
 \
 \
/*first:last 44:48  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+704]  \
__asm  movq mm4,[edi+712]  \
__asm  movq mm2,[edi+768]    \
__asm  movq mm5,[edi+776]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+768],mm2   \
__asm  movq [edi+776],mm5   \
 \
 \
/*first:last 44:46  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm2,[edi+736]    \
__asm  movq mm5,[edi+744]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+736],mm2   \
__asm  movq [edi+744],mm5   \
 \
 \
/*first:last 14:44  save 1:1  load 0:0  swap 0:1  reverse 1  loadbuffer 1:0  savebuffer 0:1*/ \
__asm  movq mm2,[edi+224]  \
__asm  movq mm5,[edi+232]  \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+704],mm1   \
__asm  movq [edi+712],mm4   \
 \
 \
/*first:last 14:28  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+448]    \
__asm  movq mm4,[edi+456]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+448],mm1   \
__asm  movq [edi+456],mm4   \
 \
 \
/*first:last 14:20  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 0:1  savebuffer 1:1*/ \
__asm  movq mm1,[edi+320]    \
__asm  movq mm4,[edi+328]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+224],mm2   \
__asm  movq [edi+232],mm5   \
__asm  movq [edi+320],mm1   \
__asm  movq [edi+328],mm4   \
 \
 \
/*first:last 8:10  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 1:1  savebuffer 1:1*/ \
__asm  movq mm2,[edi+128]  \
__asm  movq mm5,[edi+136]  \
__asm  movq mm1,[edi+160]    \
__asm  movq mm4,[edi+168]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+128],mm2   \
__asm  movq [edi+136],mm5   \
__asm  movq [edi+160],mm1   \
__asm  movq [edi+168],mm4   \
 \
 \
/*first:last 9:11  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 1:1  savebuffer 1:1*/ \
__asm  movq mm2,[edi+144]  \
__asm  movq mm5,[edi+152]  \
__asm  movq mm1,[edi+176]    \
__asm  movq mm4,[edi+184]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+144],mm2   \
__asm  movq [edi+152],mm5   \
__asm  movq [edi+176],mm1   \
__asm  movq [edi+184],mm4   \
 \
 \
/*first:last 16:18  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 1:1  savebuffer 1:0*/ \
__asm  movq mm2,[edi+256]  \
__asm  movq mm5,[edi+264]  \
__asm  movq mm1,[edi+288]    \
__asm  movq mm4,[edi+296]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+256],mm2   \
__asm  movq [edi+264],mm5   \
 \
 \
/*first:last 18:48  save 1:1  load 0:0  swap 1:0  reverse 0  loadbuffer 0:1  savebuffer 1:1*/ \
__asm  movq mm2,[edi+768]    \
__asm  movq mm5,[edi+776]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+288],mm1   \
__asm  movq [edi+296],mm4   \
__asm  movq [edi+768],mm2   \
__asm  movq [edi+776],mm5   \
 \
 \
/*first:last 17:19  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:1  savebuffer 1:1*/ \
__asm  movq mm1,[edi+272]  \
__asm  movq mm4,[edi+280]  \
__asm  movq mm2,[edi+304]    \
__asm  movq mm5,[edi+312]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+272],mm1   \
__asm  movq [edi+280],mm4   \
__asm  movq [edi+304],mm2   \
__asm  movq [edi+312],mm5   \
 \
 \
/*first:last 24:26  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:1  savebuffer 1:1*/ \
__asm  movq mm2,[edi+416]    \
__asm  movq mm5,[edi+424]   \
__asm  movq mm3,mm0 \
__asm  movq mm6,mm7 \
__asm  pminub mm0,mm2 \
__asm  pminub mm7,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+416],mm2   \
__asm  movq [edi+424],mm5   \
 \
 \
/*first:last 25:27  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:1  savebuffer 1:1*/ \
__asm  movq mm1,[edi+400]  \
__asm  movq mm4,[edi+408]  \
__asm  movq mm2,[edi+432]    \
__asm  movq mm5,[edi+440]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+400],mm1   \
__asm  movq [edi+408],mm4   \
__asm  movq [edi+432],mm2   \
__asm  movq [edi+440],mm5   \
 \
 \
/*first:last 32:34  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+512]  \
__asm  movq mm4,[edi+520]  \
__asm  movq mm2,[edi+544]    \
__asm  movq mm5,[edi+552]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+544],mm2   \
__asm  movq [edi+552],mm5   \
 \
 \
/*first:last 2:32  save 1:1  load 0:0  swap 0:1  reverse 1  loadbuffer 1:0  savebuffer 0:1*/ \
__asm  movq mm2,[edi+32]  \
__asm  movq mm5,[edi+40]  \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+512],mm1   \
__asm  movq [edi+520],mm4   \
 \
 \
/*first:last 2:16  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+256]    \
__asm  movq mm4,[edi+264]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+256],mm1   \
__asm  movq [edi+264],mm4   \
 \
 \
/*first:last 2:8  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+128]    \
__asm  movq mm4,[edi+136]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+128],mm1   \
__asm  movq [edi+136],mm4   \
 \
 \
/*first:last 2:4  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 0:1  savebuffer 1:1*/ \
__asm  movq mm1,[edi+64]    \
__asm  movq mm4,[edi+72]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+32],mm2   \
__asm  movq [edi+40],mm5   \
__asm  movq [edi+64],mm1   \
__asm  movq [edi+72],mm4   \
 \
 \
/*first:last 33:35  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm2,[edi+528]  \
__asm  movq mm5,[edi+536]  \
__asm  movq mm1,[edi+560]    \
__asm  movq mm4,[edi+568]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+560],mm1   \
__asm  movq [edi+568],mm4   \
 \
 \
/*first:last 3:33  save 1:1  load 0:0  swap 0:1  reverse 0  loadbuffer 1:0  savebuffer 0:1*/ \
__asm  movq mm1,[edi+48]  \
__asm  movq mm4,[edi+56]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+528],mm2   \
__asm  movq [edi+536],mm5   \
 \
 \
/*first:last 3:17  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm2,[edi+272]    \
__asm  movq mm5,[edi+280]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+272],mm2   \
__asm  movq [edi+280],mm5   \
 \
 \
/*first:last 3:9  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm2,[edi+144]    \
__asm  movq mm5,[edi+152]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+144],mm2   \
__asm  movq [edi+152],mm5   \
 \
 \
/*first:last 3:5  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm2,[edi+80]    \
__asm  movq mm5,[edi+88]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+80],mm2   \
__asm  movq [edi+88],mm5   \
 \
 \
/*first:last 2:3  save 0:1  load 0:0  swap 0:1  reverse 1  loadbuffer 1:0  savebuffer 0:1*/ \
__asm  movq mm2,[edi+32]  \
__asm  movq mm5,[edi+40]  \
__asm  pmaxub mm1,mm2 \
__asm  pmaxub mm4,mm5 \
__asm  movq [edi+48],mm1   \
__asm  movq [edi+56],mm4   \
 \
 \
/*first:last 40:42  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm2,[edi+640]  \
__asm  movq mm5,[edi+648]  \
__asm  movq mm1,[edi+672]    \
__asm  movq mm4,[edi+680]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+672],mm1   \
__asm  movq [edi+680],mm4   \
 \
 \
/*first:last 10:40  save 1:1  load 0:0  swap 0:1  reverse 0  loadbuffer 1:0  savebuffer 0:1*/ \
__asm  movq mm1,[edi+160]  \
__asm  movq mm4,[edi+168]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+640],mm2   \
__asm  movq [edi+648],mm5   \
 \
 \
/*first:last 10:24  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm0 \
__asm  pminub mm4,mm7 \
__asm  pmaxub mm0,mm3   \
__asm  pmaxub mm7,mm6   \
 \
 \
/*first:last 10:16  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm2,[edi+256]    \
__asm  movq mm5,[edi+264]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+256],mm2   \
__asm  movq [edi+264],mm5   \
 \
 \
/*first:last 10:12  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 1:1*/ \
__asm  movq mm2,[edi+192]    \
__asm  movq mm5,[edi+200]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+160],mm1   \
__asm  movq [edi+168],mm4   \
__asm  movq [edi+192],mm2   \
__asm  movq [edi+200],mm5   \
 \
 \
/*first:last 41:43  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+656]  \
__asm  movq mm4,[edi+664]  \
__asm  movq mm2,[edi+688]    \
__asm  movq mm5,[edi+696]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+688],mm2   \
__asm  movq [edi+696],mm5   \
 \
 \
/*first:last 11:41  save 1:1  load 0:0  swap 0:1  reverse 1  loadbuffer 1:0  savebuffer 0:1*/ \
__asm  movq mm2,[edi+176]  \
__asm  movq mm5,[edi+184]  \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+656],mm1   \
__asm  movq [edi+664],mm4   \
 \
 \
/*first:last 11:25  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+400]    \
__asm  movq mm4,[edi+408]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+400],mm1   \
__asm  movq [edi+408],mm4   \
 \
 \
/*first:last 11:17  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+272]    \
__asm  movq mm4,[edi+280]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+272],mm1   \
__asm  movq [edi+280],mm4   \
 \
 \
/*first:last 11:13  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+208]    \
__asm  movq mm4,[edi+216]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+208],mm1   \
__asm  movq [edi+216],mm4   \
 \
 \
/*first:last 10:11  save 0:1  load 0:0  swap 0:1  reverse 0  loadbuffer 1:0  savebuffer 0:1*/ \
__asm  movq mm1,[edi+160]  \
__asm  movq mm4,[edi+168]  \
__asm  pmaxub mm2,mm1 \
__asm  pmaxub mm5,mm4 \
__asm  movq [edi+176],mm2   \
__asm  movq [edi+184],mm5   \
 \
 \
/*first:last 45:47  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+720]  \
__asm  movq mm4,[edi+728]  \
__asm  movq mm2,[edi+752]    \
__asm  movq mm5,[edi+760]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+752],mm2   \
__asm  movq [edi+760],mm5   \
 \
 \
/*first:last 15:45  save 1:1  load 0:0  swap 0:1  reverse 1  loadbuffer 1:0  savebuffer 0:1*/ \
__asm  movq mm2,[edi+240]  \
__asm  movq mm5,[edi+248]  \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+720],mm1   \
__asm  movq [edi+728],mm4   \
 \
 \
/*first:last 15:29  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+464]    \
__asm  movq mm4,[edi+472]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+464],mm1   \
__asm  movq [edi+472],mm4   \
 \
 \
/*first:last 15:21  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+336]    \
__asm  movq mm4,[edi+344]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+336],mm1   \
__asm  movq [edi+344],mm4   \
 \
 \
/*first:last 15:17  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 0:1  savebuffer 1:1*/ \
__asm  movq mm1,[edi+272]    \
__asm  movq mm4,[edi+280]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+240],mm2   \
__asm  movq [edi+248],mm5   \
__asm  movq [edi+272],mm1   \
__asm  movq [edi+280],mm4   \
 \
 \
/*first:last 18:32  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm2,[edi+288]  \
__asm  movq mm5,[edi+296]  \
__asm  movq mm1,[edi+512]    \
__asm  movq mm4,[edi+520]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+512],mm1   \
__asm  movq [edi+520],mm4   \
 \
 \
/*first:last 18:24  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm0 \
__asm  pminub mm5,mm7 \
__asm  pmaxub mm0,mm3   \
__asm  pmaxub mm7,mm6   \
 \
 \
/*first:last 18:20  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 0:1  savebuffer 1:1*/ \
__asm  movq mm1,[edi+320]    \
__asm  movq mm4,[edi+328]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+288],mm2   \
__asm  movq [edi+296],mm5   \
__asm  movq [edi+320],mm1   \
__asm  movq [edi+328],mm4   \
 \
 \
/*first:last 19:33  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm2,[edi+304]  \
__asm  movq mm5,[edi+312]  \
__asm  movq mm1,[edi+528]    \
__asm  movq mm4,[edi+536]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+528],mm1   \
__asm  movq [edi+536],mm4   \
 \
 \
/*first:last 19:25  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+400]    \
__asm  movq mm4,[edi+408]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+400],mm1   \
__asm  movq [edi+408],mm4   \
 \
 \
/*first:last 19:21  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+336]    \
__asm  movq mm4,[edi+344]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+336],mm1   \
__asm  movq [edi+344],mm4   \
 \
 \
/*first:last 18:19  save 0:1  load 0:0  swap 0:1  reverse 0  loadbuffer 1:0  savebuffer 0:1*/ \
__asm  movq mm1,[edi+288]  \
__asm  movq mm4,[edi+296]  \
__asm  pmaxub mm2,mm1 \
__asm  pmaxub mm5,mm4 \
__asm  movq [edi+304],mm2   \
__asm  movq [edi+312],mm5   \
 \
 \
/*first:last 22:36  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+352]  \
__asm  movq mm4,[edi+360]  \
__asm  movq mm2,[edi+576]    \
__asm  movq mm5,[edi+584]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+576],mm2   \
__asm  movq [edi+584],mm5   \
 \
 \
/*first:last 22:28  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm2,[edi+448]    \
__asm  movq mm5,[edi+456]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+448],mm2   \
__asm  movq [edi+456],mm5   \
 \
 \
/*first:last 22:24  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 1:1*/ \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm0 \
__asm  pminub mm4,mm7 \
__asm  pmaxub mm0,mm3   \
__asm  pmaxub mm7,mm6   \
__asm  movq [edi+352],mm1   \
__asm  movq [edi+360],mm4   \
 \
 \
/*first:last 23:37  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+368]  \
__asm  movq mm4,[edi+376]  \
__asm  movq mm2,[edi+592]    \
__asm  movq mm5,[edi+600]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+592],mm2   \
__asm  movq [edi+600],mm5   \
 \
 \
/*first:last 23:29  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm2,[edi+464]    \
__asm  movq mm5,[edi+472]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+464],mm2   \
__asm  movq [edi+472],mm5   \
 \
 \
/*first:last 23:25  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm2,[edi+400]    \
__asm  movq mm5,[edi+408]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+400],mm2   \
__asm  movq [edi+408],mm5   \
 \
 \
/*first:last 22:23  save 0:1  load 0:0  swap 0:1  reverse 1  loadbuffer 1:0  savebuffer 0:1*/ \
__asm  movq mm2,[edi+352]  \
__asm  movq mm5,[edi+360]  \
__asm  pmaxub mm1,mm2 \
__asm  pmaxub mm4,mm5 \
__asm  movq [edi+368],mm1   \
__asm  movq [edi+376],mm4   \
 \
 \
/*first:last 26:40  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm2,[edi+416]  \
__asm  movq mm5,[edi+424]  \
__asm  movq mm1,[edi+640]    \
__asm  movq mm4,[edi+648]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+640],mm1   \
__asm  movq [edi+648],mm4   \
 \
 \
/*first:last 26:32  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+512]    \
__asm  movq mm4,[edi+520]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+512],mm1   \
__asm  movq [edi+520],mm4   \
 \
 \
/*first:last 26:28  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 0:1  savebuffer 1:1*/ \
__asm  movq mm1,[edi+448]    \
__asm  movq mm4,[edi+456]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+416],mm2   \
__asm  movq [edi+424],mm5   \
__asm  movq [edi+448],mm1   \
__asm  movq [edi+456],mm4   \
 \
 \
/*first:last 27:41  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm2,[edi+432]  \
__asm  movq mm5,[edi+440]  \
__asm  movq mm1,[edi+656]    \
__asm  movq mm4,[edi+664]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+656],mm1   \
__asm  movq [edi+664],mm4   \
 \
 \
/*first:last 27:33  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+528]    \
__asm  movq mm4,[edi+536]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+528],mm1   \
__asm  movq [edi+536],mm4   \
 \
 \
/*first:last 27:29  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+464]    \
__asm  movq mm4,[edi+472]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+464],mm1   \
__asm  movq [edi+472],mm4   \
 \
 \
/*first:last 26:27  save 1:0  load 0:0  swap 0:1  reverse 0  loadbuffer 1:0  savebuffer 1:0*/ \
__asm  movq mm1,[edi+416]  \
__asm  movq mm4,[edi+424]  \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  movq [edi+416],mm1   \
__asm  movq [edi+424],mm4   \
 \
 \
/*first:last 30:44  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+480]  \
__asm  movq mm4,[edi+488]  \
__asm  movq mm2,[edi+704]    \
__asm  movq mm5,[edi+712]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+704],mm2   \
__asm  movq [edi+712],mm5   \
 \
 \
/*first:last 30:36  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm2,[edi+576]    \
__asm  movq mm5,[edi+584]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+576],mm2   \
__asm  movq [edi+584],mm5   \
 \
 \
/*first:last 30:32  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 1:1*/ \
__asm  movq mm2,[edi+512]    \
__asm  movq mm5,[edi+520]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+480],mm1   \
__asm  movq [edi+488],mm4   \
__asm  movq [edi+512],mm2   \
__asm  movq [edi+520],mm5   \
 \
 \
/*first:last 31:45  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+496]  \
__asm  movq mm4,[edi+504]  \
__asm  movq mm2,[edi+720]    \
__asm  movq mm5,[edi+728]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+720],mm2   \
__asm  movq [edi+728],mm5   \
 \
 \
/*first:last 31:37  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm2,[edi+592]    \
__asm  movq mm5,[edi+600]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+592],mm2   \
__asm  movq [edi+600],mm5   \
 \
 \
/*first:last 31:33  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm2,[edi+528]    \
__asm  movq mm5,[edi+536]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+528],mm2   \
__asm  movq [edi+536],mm5   \
 \
 \
/*first:last 30:31  save 1:0  load 0:0  swap 0:1  reverse 1  loadbuffer 1:0  savebuffer 1:0*/ \
__asm  movq mm2,[edi+480]  \
__asm  movq mm5,[edi+488]  \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  movq [edi+480],mm2   \
__asm  movq [edi+488],mm5   \
 \
 \
/*first:last 34:48  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm2,[edi+544]  \
__asm  movq mm5,[edi+552]  \
__asm  movq mm1,[edi+768]    \
__asm  movq mm4,[edi+776]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+768],mm1   \
__asm  movq [edi+776],mm4   \
 \
 \
/*first:last 34:40  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+640]    \
__asm  movq mm4,[edi+648]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+640],mm1   \
__asm  movq [edi+648],mm4   \
 \
 \
/*first:last 34:36  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 0:1  savebuffer 1:1*/ \
__asm  movq mm1,[edi+576]    \
__asm  movq mm4,[edi+584]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+544],mm2   \
__asm  movq [edi+552],mm5   \
__asm  movq [edi+576],mm1   \
__asm  movq [edi+584],mm4   \
 \
 \
/*first:last 35:41  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm2,[edi+560]  \
__asm  movq mm5,[edi+568]  \
__asm  movq mm1,[edi+656]    \
__asm  movq mm4,[edi+664]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+656],mm1   \
__asm  movq [edi+664],mm4   \
 \
 \
/*first:last 35:37  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+592]    \
__asm  movq mm4,[edi+600]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+592],mm1   \
__asm  movq [edi+600],mm4   \
 \
 \
/*first:last 34:35  save 1:0  load 0:0  swap 0:1  reverse 0  loadbuffer 1:0  savebuffer 0:0*/ \
__asm  movq mm1,[edi+544]  \
__asm  movq mm4,[edi+552]  \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
 \
 \
/*first:last 3:34  save 0:1  load 0:0  swap 0:1  reverse 1  loadbuffer 1:0  savebuffer 0:0*/ \
__asm  movq mm2,[edi+48]  \
__asm  movq mm5,[edi+56]  \
__asm  pmaxub mm1,mm2 \
__asm  pmaxub mm4,mm5 \
 \
 \
/*first:last 19:34  save 1:0  load 0:0  swap 0:0  reverse 1  loadbuffer 1:0  savebuffer 1:0*/ \
__asm  movq mm2,[edi+304]  \
__asm  movq mm5,[edi+312]  \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  movq [edi+304],mm2   \
__asm  movq [edi+312],mm5   \
 \
 \
/*first:last 38:44  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm2,[edi+608]  \
__asm  movq mm5,[edi+616]  \
__asm  movq mm1,[edi+704]    \
__asm  movq mm4,[edi+712]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+704],mm1   \
__asm  movq [edi+712],mm4   \
 \
 \
/*first:last 38:40  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 0:1  savebuffer 1:1*/ \
__asm  movq mm1,[edi+640]    \
__asm  movq mm4,[edi+648]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+608],mm2   \
__asm  movq [edi+616],mm5   \
__asm  movq [edi+640],mm1   \
__asm  movq [edi+648],mm4   \
 \
 \
/*first:last 39:45  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm2,[edi+624]  \
__asm  movq mm5,[edi+632]  \
__asm  movq mm1,[edi+720]    \
__asm  movq mm4,[edi+728]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+720],mm1   \
__asm  movq [edi+728],mm4   \
 \
 \
/*first:last 39:41  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+656]    \
__asm  movq mm4,[edi+664]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+656],mm1   \
__asm  movq [edi+664],mm4   \
 \
 \
/*first:last 38:39  save 1:0  load 0:0  swap 0:1  reverse 0  loadbuffer 1:0  savebuffer 1:0*/ \
__asm  movq mm1,[edi+608]  \
__asm  movq mm4,[edi+616]  \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  movq [edi+608],mm1   \
__asm  movq [edi+616],mm4   \
 \
 \
/*first:last 42:48  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+672]  \
__asm  movq mm4,[edi+680]  \
__asm  movq mm2,[edi+768]    \
__asm  movq mm5,[edi+776]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+768],mm2   \
__asm  movq [edi+776],mm5   \
 \
 \
/*first:last 42:44  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 1:1*/ \
__asm  movq mm2,[edi+704]    \
__asm  movq mm5,[edi+712]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+672],mm1   \
__asm  movq [edi+680],mm4   \
__asm  movq [edi+704],mm2   \
__asm  movq [edi+712],mm5   \
 \
 \
/*first:last 6:8  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:1  savebuffer 1:1*/ \
__asm  movq mm1,[edi+96]  \
__asm  movq mm4,[edi+104]  \
__asm  movq mm2,[edi+128]    \
__asm  movq mm5,[edi+136]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+96],mm1   \
__asm  movq [edi+104],mm4   \
__asm  movq [edi+128],mm2   \
__asm  movq [edi+136],mm5   \
 \
 \
/*first:last 7:9  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+112]  \
__asm  movq mm4,[edi+120]  \
__asm  movq mm2,[edi+144]    \
__asm  movq mm5,[edi+152]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+144],mm2   \
__asm  movq [edi+152],mm5   \
 \
 \
/*first:last 6:7  save 0:1  load 0:0  swap 0:1  reverse 1  loadbuffer 1:0  savebuffer 0:0*/ \
__asm  movq mm2,[edi+96]  \
__asm  movq mm5,[edi+104]  \
__asm  pmaxub mm1,mm2 \
__asm  pmaxub mm4,mm5 \
 \
 \
/*first:last 7:38  save 0:1  load 0:0  swap 1:0  reverse 0  loadbuffer 0:1  savebuffer 0:0*/ \
__asm  movq mm2,[edi+608]    \
__asm  movq mm5,[edi+616]   \
__asm  pmaxub mm2,mm1 \
__asm  pmaxub mm5,mm4 \
 \
 \
/*first:last 23:38  save 1:0  load 0:0  swap 0:0  reverse 0  loadbuffer 1:0  savebuffer 1:0*/ \
__asm  movq mm1,[edi+368]  \
__asm  movq mm4,[edi+376]  \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  movq [edi+368],mm1   \
__asm  movq [edi+376],mm4   \
 \
 \
/*first:last 14:16  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+224]  \
__asm  movq mm4,[edi+232]  \
__asm  movq mm2,[edi+256]    \
__asm  movq mm5,[edi+264]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+256],mm2   \
__asm  movq [edi+264],mm5   \
 \
 \
/*first:last 14:15  save 0:1  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm2,[edi+240]    \
__asm  movq mm5,[edi+248]   \
__asm  pmaxub mm2,mm1 \
__asm  pmaxub mm5,mm4 \
__asm  movq [edi+240],mm2   \
__asm  movq [edi+248],mm5   \
 \
 \
/*first:last 43:45  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+688]  \
__asm  movq mm4,[edi+696]  \
__asm  movq mm2,[edi+720]    \
__asm  movq mm5,[edi+728]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+720],mm2   \
__asm  movq [edi+728],mm5   \
 \
 \
/*first:last 42:43  save 1:0  load 0:0  swap 0:1  reverse 1  loadbuffer 1:0  savebuffer 0:0*/ \
__asm  movq mm2,[edi+672]  \
__asm  movq mm5,[edi+680]  \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
 \
 \
/*first:last 11:42  save 1:0  load 0:0  swap 0:1  reverse 0  loadbuffer 1:0  savebuffer 0:0*/ \
__asm  movq mm1,[edi+176]  \
__asm  movq mm4,[edi+184]  \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
 \
 \
/*first:last 11:26  save 0:1  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 0:0*/ \
__asm  movq mm2,[edi+416]    \
__asm  movq mm5,[edi+424]   \
__asm  pmaxub mm2,mm1 \
__asm  pmaxub mm5,mm4 \
 \
 \
/*first:last 19:26  save 0:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:0  savebuffer 0:1*/ \
__asm  movq mm1,[edi+304]  \
__asm  movq mm4,[edi+312]  \
__asm  pmaxub mm2,mm1 \
__asm  pmaxub mm5,mm4 \
__asm  movq [edi+416],mm2   \
__asm  movq [edi+424],mm5   \
 \
 \
/*first:last 46:48  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+736]  \
__asm  movq mm4,[edi+744]  \
__asm  movq mm2,[edi+768]    \
__asm  movq mm5,[edi+776]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+768],mm2   \
__asm  movq [edi+776],mm5   \
 \
 \
/*first:last 46:47  save 1:0  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 0:0*/ \
__asm  movq mm2,[edi+752]    \
__asm  movq mm5,[edi+760]   \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
 \
 \
/*first:last 15:46  save 1:0  load 0:0  swap 0:1  reverse 1  loadbuffer 1:0  savebuffer 0:0*/ \
__asm  movq mm2,[edi+240]  \
__asm  movq mm5,[edi+248]  \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
 \
 \
/*first:last 15:30  save 0:1  load 0:0  swap 0:0  reverse 1  loadbuffer 0:1  savebuffer 0:0*/ \
__asm  movq mm1,[edi+480]    \
__asm  movq mm4,[edi+488]   \
__asm  pmaxub mm1,mm2 \
__asm  pmaxub mm4,mm5 \
 \
 \
/*first:last 23:30  save 1:0  load 0:0  swap 0:0  reverse 1  loadbuffer 1:0  savebuffer 0:0*/ \
__asm  movq mm2,[edi+368]  \
__asm  movq mm5,[edi+376]  \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
 \
 \
/*first:last 23:26  save 1:0  load 0:0  swap 0:0  reverse 1  loadbuffer 0:1  savebuffer 1:0*/ \
__asm  movq mm1,[edi+416]    \
__asm  movq mm4,[edi+424]   \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  movq [edi+368],mm2   \
__asm  movq [edi+376],mm5   \
 \
 \
/*first:last 4:5  save 0:1  load 0:0  swap 0:0  reverse 1  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm2,[edi+64]  \
__asm  movq mm5,[edi+72]  \
__asm  movq mm1,[edi+80]    \
__asm  movq mm4,[edi+88]   \
__asm  pmaxub mm1,mm2 \
__asm  pmaxub mm4,mm5 \
__asm  movq [edi+80],mm1   \
__asm  movq [edi+88],mm4   \
 \
 \
/*first:last 8:9  save 0:1  load 0:0  swap 0:0  reverse 1  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm2,[edi+128]  \
__asm  movq mm5,[edi+136]  \
__asm  movq mm1,[edi+144]    \
__asm  movq mm4,[edi+152]   \
__asm  pmaxub mm1,mm2 \
__asm  pmaxub mm4,mm5 \
__asm  movq [edi+144],mm1   \
__asm  movq [edi+152],mm4   \
 \
 \
/*first:last 12:13  save 0:1  load 0:0  swap 0:0  reverse 1  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm2,[edi+192]  \
__asm  movq mm5,[edi+200]  \
__asm  movq mm1,[edi+208]    \
__asm  movq mm4,[edi+216]   \
__asm  pmaxub mm1,mm2 \
__asm  pmaxub mm4,mm5 \
__asm  movq [edi+208],mm1   \
__asm  movq [edi+216],mm4   \
 \
 \
/*first:last 16:17  save 0:1  load 0:0  swap 0:0  reverse 1  loadbuffer 1:1  savebuffer 0:0*/ \
__asm  movq mm2,[edi+256]  \
__asm  movq mm5,[edi+264]  \
__asm  movq mm1,[edi+272]    \
__asm  movq mm4,[edi+280]   \
__asm  pmaxub mm1,mm2 \
__asm  pmaxub mm4,mm5 \
 \
 \
/*first:last 17:48  save 1:0  load 0:0  swap 1:0  reverse 0  loadbuffer 0:1  savebuffer 1:0*/ \
__asm  movq mm2,[edi+768]    \
__asm  movq mm5,[edi+776]   \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  movq [edi+272],mm1   \
__asm  movq [edi+280],mm4   \
 \
 \
/*first:last 20:21  save 0:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+320]  \
__asm  movq mm4,[edi+328]  \
__asm  movq mm2,[edi+336]    \
__asm  movq mm5,[edi+344]   \
__asm  pmaxub mm2,mm1 \
__asm  pmaxub mm5,mm4 \
__asm  movq [edi+336],mm2   \
__asm  movq [edi+344],mm5   \
 \
 \
/*first:last 24:25  save 1:0  load 0:0  swap 0:0  reverse 0  loadbuffer 1:1  savebuffer 1:0*/ \
__asm  movq mm2,[edi+400]    \
__asm  movq mm5,[edi+408]   \
__asm  pminub mm0,mm2 \
__asm  pminub mm7,mm5 \
 \
 \
/*first:last 28:29  save 1:0  load 0:0  swap 0:0  reverse 0  loadbuffer 1:1  savebuffer 1:0*/ \
__asm  movq mm1,[edi+448]  \
__asm  movq mm4,[edi+456]  \
__asm  movq mm2,[edi+464]    \
__asm  movq mm5,[edi+472]   \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  movq [edi+448],mm1   \
__asm  movq [edi+456],mm4   \
 \
 \
/*first:last 32:33  save 1:0  load 0:0  swap 0:0  reverse 0  loadbuffer 1:1  savebuffer 0:0*/ \
__asm  movq mm1,[edi+512]  \
__asm  movq mm4,[edi+520]  \
__asm  movq mm2,[edi+528]    \
__asm  movq mm5,[edi+536]   \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
 \
 \
/*first:last 1:32  save 0:1  load 0:0  swap 0:1  reverse 1  loadbuffer 1:0  savebuffer 0:0*/ \
__asm  movq mm2,[edi+16]  \
__asm  movq mm5,[edi+24]  \
__asm  pmaxub mm1,mm2 \
__asm  pmaxub mm4,mm5 \
 \
 \
/*first:last 17:32  save 1:0  load 0:0  swap 0:0  reverse 1  loadbuffer 1:0  savebuffer 1:0*/ \
__asm  movq mm2,[edi+272]  \
__asm  movq mm5,[edi+280]  \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  movq [edi+272],mm2   \
__asm  movq [edi+280],mm5   \
 \
 \
/*first:last 36:37  save 1:0  load 0:0  swap 0:0  reverse 1  loadbuffer 1:1  savebuffer 0:0*/ \
__asm  movq mm2,[edi+576]  \
__asm  movq mm5,[edi+584]  \
__asm  movq mm1,[edi+592]    \
__asm  movq mm4,[edi+600]   \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
 \
 \
/*first:last 5:36  save 0:1  load 0:0  swap 0:1  reverse 0  loadbuffer 1:0  savebuffer 0:0*/ \
__asm  movq mm1,[edi+80]  \
__asm  movq mm4,[edi+88]  \
__asm  pmaxub mm2,mm1 \
__asm  pmaxub mm5,mm4 \
 \
 \
/*first:last 21:36  save 1:0  load 0:0  swap 0:0  reverse 0  loadbuffer 1:0  savebuffer 1:0*/ \
__asm  movq mm1,[edi+336]  \
__asm  movq mm4,[edi+344]  \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  movq [edi+336],mm1   \
__asm  movq [edi+344],mm4   \
 \
 \
/*first:last 40:41  save 1:0  load 0:0  swap 0:0  reverse 0  loadbuffer 1:1  savebuffer 0:0*/ \
__asm  movq mm1,[edi+640]  \
__asm  movq mm4,[edi+648]  \
__asm  movq mm2,[edi+656]    \
__asm  movq mm5,[edi+664]   \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
 \
 \
/*first:last 9:40  save 1:0  load 0:0  swap 0:1  reverse 1  loadbuffer 1:0  savebuffer 0:0*/ \
__asm  movq mm2,[edi+144]  \
__asm  movq mm5,[edi+152]  \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
 \
 \
/*first:last 9:24  save 0:1  load 0:0  swap 0:0  reverse 1  loadbuffer 0:1  savebuffer 0:0*/ \
__asm  pmaxub mm0,mm2 \
__asm  pmaxub mm7,mm5 \
 \
 \
/*first:last 17:24  save 0:1  load 0:0  swap 0:0  reverse 1  loadbuffer 1:0  savebuffer 0:1*/ \
__asm  movq mm2,[edi+272]  \
__asm  movq mm5,[edi+280]  \
__asm  pmaxub mm0,mm2 \
__asm  pmaxub mm7,mm5 \
 \
 \
/*first:last 44:45  save 1:0  load 0:0  swap 0:0  reverse 1  loadbuffer 1:1  savebuffer 0:0*/ \
__asm  movq mm2,[edi+704]  \
__asm  movq mm5,[edi+712]  \
__asm  movq mm1,[edi+720]    \
__asm  movq mm4,[edi+728]   \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
 \
 \
/*first:last 13:44  save 1:0  load 0:0  swap 0:1  reverse 0  loadbuffer 1:0  savebuffer 0:0*/ \
__asm  movq mm1,[edi+208]  \
__asm  movq mm4,[edi+216]  \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
 \
 \
/*first:last 13:28  save 0:1  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 0:0*/ \
__asm  movq mm2,[edi+448]    \
__asm  movq mm5,[edi+456]   \
__asm  pmaxub mm2,mm1 \
__asm  pmaxub mm5,mm4 \
 \
 \
/*first:last 21:28  save 1:0  load 0:0  swap 0:0  reverse 0  loadbuffer 1:0  savebuffer 0:0*/ \
__asm  movq mm1,[edi+336]  \
__asm  movq mm4,[edi+344]  \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
 \
 \
/*first:last 21:24  save 0:1  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 0:0*/ \
__asm  pmaxub mm0,mm1 \
__asm  pmaxub mm7,mm4 \
 \
 \
/*first:last 23:24  save 0:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:0  savebuffer 0:1*/ \
__asm  movq mm1,[edi+368]  \
__asm  movq mm4,[edi+376]  \
__asm  pmaxub mm0,mm1 \
__asm  pmaxub mm7,mm4 \
 \
 \
__asm movq mm2,mm0 \
__asm movq mm5,mm7 \
}
//asm mediancalc
//edi = medians
//mm2 & mm5 contains the 16 medians
//regbuffer 1
#define MEDIAN_MM { \
/*first:last 0:1  save 1:1  load 1:1  swap 0:0  reverse 0  loadbuffer 0:0  savebuffer 1:1*/ \
__asm  movq mm1,[edi]  \
__asm  movq mm4,[edi+8] \
__asm  movq mm0,[edi+16]  \
__asm  movq mm7,[edi+16+8]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm0 \
__asm  pminub mm4,mm7 \
__asm  pmaxub mm0,mm3   \
__asm  pmaxub mm7,mm6   \
__asm  movq [edi+0],mm1   \
__asm  movq [edi+8],mm4   \
 \
 \
/*first:last 3:4  save 1:1  load 1:1  swap 0:0  reverse 0  loadbuffer 0:0  savebuffer 0:1*/ \
__asm  movq mm1,[edi+48]  \
__asm  movq mm4,[edi+48+8] \
__asm  movq mm2,[edi+64]  \
__asm  movq mm5,[edi+64+8]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+64],mm2   \
__asm  movq [edi+72],mm5   \
 \
 \
/*first:last 0:3  save 0:1  load 0:0  swap 0:1  reverse 1  loadbuffer 1:0  savebuffer 0:1*/ \
__asm  movq mm2,[edi+0]  \
__asm  movq mm5,[edi+8]  \
__asm  pmaxub mm1,mm2 \
__asm  pmaxub mm4,mm5 \
__asm  movq [edi+48],mm1   \
__asm  movq [edi+56],mm4   \
 \
 \
/*first:last 1:4  save 1:0  load 0:0  swap 0:0  reverse 1  loadbuffer 1:1  savebuffer 0:0*/ \
__asm  movq mm1,[edi+64]    \
__asm  movq mm4,[edi+72]   \
__asm  pminub mm0,mm1 \
__asm  pminub mm7,mm4 \
 \
 \
/*first:last 1:2  save 1:1  load 0:1  swap 0:0  reverse 1  loadbuffer 0:0  savebuffer 1:0*/ \
__asm  movq mm1,[edi+32]  \
__asm  movq mm4,[edi+32+8]  \
__asm  movq mm3,mm0 \
__asm  movq mm6,mm7 \
__asm  pminub mm0,mm1 \
__asm  pminub mm7,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
 \
 \
/*first:last 2:3  save 1:0  load 0:0  swap 1:0  reverse 0  loadbuffer 0:1  savebuffer 0:0*/ \
__asm  movq mm2,[edi+48]    \
__asm  movq mm5,[edi+56]   \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
 \
 \
/*first:last 1:2  save 0:1  load 0:0  swap 0:1  reverse 1  loadbuffer 1:0  savebuffer 0:1*/ \
__asm  pmaxub mm1,mm0 \
__asm  pmaxub mm4,mm7 \
 \
 \
__asm movq mm2,mm1 \
__asm movq mm5,mm4 \
}
//asm mediancalc
//edi = temp buffer
//esi = centerframe srcp
//ebx = prevframe srcp
//edx = nextframe srcp
//eax = pitch
//mm2 & mm5 contains the 16 medians
//regbuffer 0
#define MEDIAN_W7 { \
/*first:last 0:1  save 1:1  load 1:1  swap 0:0  reverse 0  loadbuffer 0:0  savebuffer 1:0*/ \
__asm  movq mm0,[ebx+eax+1]  \
__asm  movq mm7,[ebx+eax+1+8] \
__asm  movq mm2,[esi+eax+1]  \
__asm  movq mm5,[esi+eax+1+8]  \
__asm  movq mm3,mm0 \
__asm  movq mm6,mm7 \
__asm  pminub mm0,mm2 \
__asm  pminub mm7,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
 \
 \
/*first:last 1:2  save 1:0  load 0:1  swap 1:0  reverse 1  loadbuffer 0:0  savebuffer 0:0*/ \
__asm  movq mm1,[edx+eax+1]  \
__asm  movq mm4,[edx+eax+1+8]  \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
 \
 \
/*first:last 0:1  save 0:1  load 0:0  swap 0:1  reverse 0  loadbuffer 1:0  savebuffer 0:1*/ \
__asm  pmaxub mm2,mm0 \
__asm  pmaxub mm5,mm7 \
 \
 \
}
//asm mediancalc
//edi = temp buffer
//esi = centerframe srcp
//ebx = prevframe srcp
//edx = nextframe srcp
//eax = pitch
//mm2 & mm5 contains the 16 medians
//regbuffer 3
#define MEDIAN_W6 { \
/*first:last 0:5  save 1:1  load 1:1  swap 0:0  reverse 0  loadbuffer 0:0  savebuffer 0:1*/ \
__asm  movq mm1,[ebx+eax+1]  \
__asm  movq mm4,[ebx+eax+1+8] \
__asm  movq mm2,[esi+2*eax+2]  \
__asm  movq mm5,[esi+2*eax+2+8]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+80],mm2   \
__asm  movq [edi+88],mm5   \
 \
 \
/*first:last 0:3  save 1:1  load 0:1  swap 0:0  reverse 0  loadbuffer 0:0  savebuffer 1:0*/ \
__asm  movq mm0,[esi+eax+1]  \
__asm  movq mm7,[esi+eax+1+8]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm0 \
__asm  pminub mm4,mm7 \
__asm  pmaxub mm0,mm3   \
__asm  pmaxub mm7,mm6   \
__asm  movq [edi+0],mm1   \
__asm  movq [edi+8],mm4   \
 \
 \
/*first:last 3:5  save 1:1  load 0:0  swap 1:0  reverse 1  loadbuffer 0:1  savebuffer 1:1*/ \
__asm  movq mm1,[edi+80]    \
__asm  movq mm4,[edi+88]   \
__asm  movq mm3,mm0 \
__asm  movq mm6,mm7 \
__asm  pminub mm0,mm1 \
__asm  pminub mm7,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+80],mm1   \
__asm  movq [edi+88],mm4   \
 \
 \
/*first:last 1:6  save 1:1  load 1:1  swap 0:0  reverse 1  loadbuffer 0:0  savebuffer 0:1*/ \
__asm  movq mm2,[esi]  \
__asm  movq mm5,[esi+8] \
__asm  movq mm1,[edx+eax+1]  \
__asm  movq mm4,[edx+eax+1+8]  \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+96],mm1   \
__asm  movq [edi+104],mm4   \
 \
 \
/*first:last 0:1  save 0:1  load 0:0  swap 0:1  reverse 0  loadbuffer 1:0  savebuffer 0:1*/ \
__asm  movq mm1,[edi+0]  \
__asm  movq mm4,[edi+8]  \
__asm  pmaxub mm2,mm1 \
__asm  pmaxub mm5,mm4 \
__asm  movq [edi+16],mm2   \
__asm  movq [edi+24],mm5   \
 \
 \
/*first:last 2:4  save 1:1  load 1:1  swap 0:0  reverse 0  loadbuffer 0:0  savebuffer 0:1*/ \
__asm  movq mm1,[esi+2]  \
__asm  movq mm4,[esi+2+8] \
__asm  movq mm2,[esi+2*eax]  \
__asm  movq mm5,[esi+2*eax+8]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+64],mm2   \
__asm  movq [edi+72],mm5   \
 \
 \
/*first:last 2:6  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm2,[edi+96]    \
__asm  movq mm5,[edi+104]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+96],mm2   \
__asm  movq [edi+104],mm5   \
 \
 \
/*first:last 2:3  save 0:1  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 0:0*/ \
__asm  pmaxub mm0,mm1 \
__asm  pmaxub mm7,mm4 \
 \
 \
/*first:last 3:6  save 1:0  load 0:0  swap 1:0  reverse 1  loadbuffer 0:1  savebuffer 1:0*/ \
__asm  movq mm1,[edi+96]    \
__asm  movq mm4,[edi+104]   \
__asm  pminub mm0,mm1 \
__asm  pminub mm7,mm4 \
 \
 \
/*first:last 4:5  save 1:0  load 0:0  swap 0:0  reverse 1  loadbuffer 1:1  savebuffer 0:0*/ \
__asm  movq mm2,[edi+64]  \
__asm  movq mm5,[edi+72]  \
__asm  movq mm1,[edi+80]    \
__asm  movq mm4,[edi+88]   \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
 \
 \
/*first:last 1:4  save 1:1  load 0:0  swap 0:1  reverse 0  loadbuffer 1:0  savebuffer 0:1*/ \
__asm  movq mm1,[edi+16]  \
__asm  movq mm4,[edi+24]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
 \
 \
/*first:last 1:3  save 0:1  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 0:0*/ \
__asm  pmaxub mm0,mm1 \
__asm  pmaxub mm7,mm4 \
 \
 \
/*first:last 3:4  save 1:0  load 0:0  swap 1:0  reverse 1  loadbuffer 0:1  savebuffer 1:0*/ \
__asm  pminub mm0,mm2 \
__asm  pminub mm7,mm5 \
 \
 \
__asm movq mm2,mm0 \
__asm movq mm5,mm7 \
}
//asm mediancalc
//edi = temp buffer
//esi = centerframe srcp
//ebx = prevframe srcp
//edx = nextframe srcp
//eax = pitch
//mm2 & mm5 contains the 16 medians
//regbuffer 3
#define MEDIAN_W5 { \
/*first:last 0:5  save 1:1  load 1:1  swap 0:0  reverse 0  loadbuffer 0:0  savebuffer 0:1*/ \
__asm  movq mm1,[esi+2*eax+1]  \
__asm  movq mm4,[esi+2*eax+1+8] \
__asm  movq mm2,[esi+eax+1]  \
__asm  movq mm5,[esi+eax+1+8]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+80],mm2   \
__asm  movq [edi+88],mm5   \
 \
 \
/*first:last 0:3  save 1:1  load 0:1  swap 0:0  reverse 0  loadbuffer 0:0  savebuffer 1:0*/ \
__asm  movq mm0,[esi+1]  \
__asm  movq mm7,[esi+1+8]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm0 \
__asm  pminub mm4,mm7 \
__asm  pmaxub mm0,mm3   \
__asm  pmaxub mm7,mm6   \
__asm  movq [edi+0],mm1   \
__asm  movq [edi+8],mm4   \
 \
 \
/*first:last 3:5  save 1:1  load 0:0  swap 1:0  reverse 1  loadbuffer 0:1  savebuffer 1:1*/ \
__asm  movq mm1,[edi+80]    \
__asm  movq mm4,[edi+88]   \
__asm  movq mm3,mm0 \
__asm  movq mm6,mm7 \
__asm  pminub mm0,mm1 \
__asm  pminub mm7,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+80],mm1   \
__asm  movq [edi+88],mm4   \
 \
 \
/*first:last 1:6  save 1:1  load 1:1  swap 0:0  reverse 1  loadbuffer 0:0  savebuffer 0:1*/ \
__asm  movq mm2,[ebx+eax+1]  \
__asm  movq mm5,[ebx+eax+1+8] \
__asm  movq mm1,[esi+eax+2]  \
__asm  movq mm4,[esi+eax+2+8]  \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+96],mm1   \
__asm  movq [edi+104],mm4   \
 \
 \
/*first:last 0:1  save 0:1  load 0:0  swap 0:1  reverse 0  loadbuffer 1:0  savebuffer 0:1*/ \
__asm  movq mm1,[edi+0]  \
__asm  movq mm4,[edi+8]  \
__asm  pmaxub mm2,mm1 \
__asm  pmaxub mm5,mm4 \
__asm  movq [edi+16],mm2   \
__asm  movq [edi+24],mm5   \
 \
 \
/*first:last 2:4  save 1:1  load 1:1  swap 0:0  reverse 0  loadbuffer 0:0  savebuffer 0:1*/ \
__asm  movq mm1,[edx+eax+1]  \
__asm  movq mm4,[edx+eax+1+8] \
__asm  movq mm2,[esi+eax]  \
__asm  movq mm5,[esi+eax+8]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+64],mm2   \
__asm  movq [edi+72],mm5   \
 \
 \
/*first:last 2:6  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm2,[edi+96]    \
__asm  movq mm5,[edi+104]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+96],mm2   \
__asm  movq [edi+104],mm5   \
 \
 \
/*first:last 2:3  save 0:1  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 0:0*/ \
__asm  pmaxub mm0,mm1 \
__asm  pmaxub mm7,mm4 \
 \
 \
/*first:last 3:6  save 1:0  load 0:0  swap 1:0  reverse 1  loadbuffer 0:1  savebuffer 1:0*/ \
__asm  movq mm1,[edi+96]    \
__asm  movq mm4,[edi+104]   \
__asm  pminub mm0,mm1 \
__asm  pminub mm7,mm4 \
 \
 \
/*first:last 4:5  save 1:0  load 0:0  swap 0:0  reverse 1  loadbuffer 1:1  savebuffer 0:0*/ \
__asm  movq mm2,[edi+64]  \
__asm  movq mm5,[edi+72]  \
__asm  movq mm1,[edi+80]    \
__asm  movq mm4,[edi+88]   \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
 \
 \
/*first:last 1:4  save 1:1  load 0:0  swap 0:1  reverse 0  loadbuffer 1:0  savebuffer 0:1*/ \
__asm  movq mm1,[edi+16]  \
__asm  movq mm4,[edi+24]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
 \
 \
/*first:last 1:3  save 0:1  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 0:0*/ \
__asm  pmaxub mm0,mm1 \
__asm  pmaxub mm7,mm4 \
 \
 \
/*first:last 3:4  save 1:0  load 0:0  swap 1:0  reverse 1  loadbuffer 0:1  savebuffer 1:0*/ \
__asm  pminub mm0,mm2 \
__asm  pminub mm7,mm5 \
 \
 \
__asm movq mm2,mm0 \
__asm movq mm5,mm7 \
}
//asm mediancalc
//edi = temp buffer
//esi = centerframe srcp
//ebx = prevframe srcp
//edx = nextframe srcp
//eax = pitch
//mm2 & mm5 contains the 16 medians
//regbuffer 8
#define MEDIAN_W8 { \
/*first:last 0:8  save 1:1  load 1:1  swap 0:0  reverse 0  loadbuffer 0:0  savebuffer 0:1*/ \
__asm  movq mm1,[esi+eax+1]  \
__asm  movq mm4,[esi+eax+1+8] \
__asm  movq mm0,[edx+eax+1]  \
__asm  movq mm7,[edx+eax+1+8]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm0 \
__asm  pminub mm4,mm7 \
__asm  pmaxub mm0,mm3   \
__asm  pmaxub mm7,mm6   \
 \
 \
/*first:last 0:4  save 1:1  load 0:1  swap 0:0  reverse 0  loadbuffer 0:0  savebuffer 1:0*/ \
__asm  movq mm2,[ebx+eax+2]  \
__asm  movq mm5,[ebx+eax+2+8]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+0],mm1   \
__asm  movq [edi+8],mm4   \
 \
 \
/*first:last 4:8  save 1:1  load 0:0  swap 1:0  reverse 1  loadbuffer 0:1  savebuffer 1:1*/ \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm0 \
__asm  pminub mm5,mm7 \
__asm  pmaxub mm0,mm3   \
__asm  pmaxub mm7,mm6   \
__asm  movq [edi+64],mm2   \
__asm  movq [edi+72],mm5   \
 \
 \
/*first:last 1:9  save 1:1  load 1:1  swap 0:0  reverse 1  loadbuffer 0:0  savebuffer 0:1*/ \
__asm  movq mm2,[ebx+1]  \
__asm  movq mm5,[ebx+1+8] \
__asm  movq mm1,[edx+eax+2]  \
__asm  movq mm4,[edx+eax+2+8]  \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+144],mm1   \
__asm  movq [edi+152],mm4   \
 \
 \
/*first:last 1:5  save 1:1  load 0:1  swap 0:0  reverse 1  loadbuffer 0:0  savebuffer 1:0*/ \
__asm  movq mm1,[ebx+2*eax+1]  \
__asm  movq mm4,[ebx+2*eax+1+8]  \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+16],mm2   \
__asm  movq [edi+24],mm5   \
 \
 \
/*first:last 5:9  save 1:1  load 0:0  swap 1:0  reverse 0  loadbuffer 0:1  savebuffer 1:1*/ \
__asm  movq mm2,[edi+144]    \
__asm  movq mm5,[edi+152]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+80],mm1   \
__asm  movq [edi+88],mm4   \
__asm  movq [edi+144],mm2   \
__asm  movq [edi+152],mm5   \
 \
 \
/*first:last 2:10  save 1:1  load 1:1  swap 0:0  reverse 0  loadbuffer 0:0  savebuffer 0:1*/ \
__asm  movq mm1,[ebx+eax]  \
__asm  movq mm4,[ebx+eax+8] \
__asm  movq mm2,[edx+2*eax+1]  \
__asm  movq mm5,[edx+2*eax+1+8]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+160],mm2   \
__asm  movq [edi+168],mm5   \
 \
 \
/*first:last 2:6  save 1:1  load 0:1  swap 0:0  reverse 0  loadbuffer 0:0  savebuffer 1:0*/ \
__asm  movq mm2,[edx+1]  \
__asm  movq mm5,[edx+1+8]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+32],mm1   \
__asm  movq [edi+40],mm4   \
 \
 \
/*first:last 6:10  save 1:1  load 0:0  swap 1:0  reverse 1  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+160]    \
__asm  movq mm4,[edi+168]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+160],mm1   \
__asm  movq [edi+168],mm4   \
 \
 \
/*first:last 4:6  save 1:1  load 0:0  swap 0:1  reverse 0  loadbuffer 1:0  savebuffer 1:1*/ \
__asm  movq mm1,[edi+64]  \
__asm  movq mm4,[edi+72]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+64],mm1   \
__asm  movq [edi+72],mm4   \
__asm  movq [edi+96],mm2   \
__asm  movq [edi+104],mm5   \
 \
 \
/*first:last 3:7  save 1:1  load 1:1  swap 0:0  reverse 0  loadbuffer 0:0  savebuffer 0:1*/ \
__asm  movq mm1,[ebx+eax+1]  \
__asm  movq mm4,[ebx+eax+1+8] \
__asm  movq mm2,[edx+eax]  \
__asm  movq mm5,[edx+eax+8]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+112],mm2   \
__asm  movq [edi+120],mm5   \
 \
 \
/*first:last 1:3  save 1:1  load 0:0  swap 0:1  reverse 1  loadbuffer 1:0  savebuffer 1:0*/ \
__asm  movq mm2,[edi+16]  \
__asm  movq mm5,[edi+24]  \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+16],mm2   \
__asm  movq [edi+24],mm5   \
 \
 \
/*first:last 3:9  save 1:1  load 0:0  swap 1:0  reverse 0  loadbuffer 0:1  savebuffer 1:1*/ \
__asm  movq mm2,[edi+144]    \
__asm  movq mm5,[edi+152]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+48],mm1   \
__asm  movq [edi+56],mm4   \
__asm  movq [edi+144],mm2   \
__asm  movq [edi+152],mm5   \
 \
 \
/*first:last 0:2  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+0]  \
__asm  movq mm4,[edi+8]  \
__asm  movq mm2,[edi+32]    \
__asm  movq mm5,[edi+40]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+32],mm2   \
__asm  movq [edi+40],mm5   \
 \
 \
/*first:last 0:1  save 0:1  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm2,[edi+16]    \
__asm  movq mm5,[edi+24]   \
__asm  pmaxub mm2,mm1 \
__asm  pmaxub mm5,mm4 \
__asm  movq [edi+16],mm2   \
__asm  movq [edi+24],mm5   \
 \
 \
/*first:last 5:7  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+80]  \
__asm  movq mm4,[edi+88]  \
__asm  movq mm2,[edi+112]    \
__asm  movq mm5,[edi+120]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+112],mm2   \
__asm  movq [edi+120],mm5   \
 \
 \
/*first:last 3:5  save 1:1  load 0:0  swap 0:1  reverse 1  loadbuffer 1:0  savebuffer 1:1*/ \
__asm  movq mm2,[edi+48]  \
__asm  movq mm5,[edi+56]  \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+48],mm2   \
__asm  movq [edi+56],mm5   \
__asm  movq [edi+80],mm1   \
__asm  movq [edi+88],mm4   \
 \
 \
/*first:last 8:10  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+160]    \
__asm  movq mm4,[edi+168]   \
__asm  movq mm3,mm0 \
__asm  movq mm6,mm7 \
__asm  pminub mm0,mm1 \
__asm  pminub mm7,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+160],mm1   \
__asm  movq [edi+168],mm4   \
 \
 \
/*first:last 2:8  save 1:1  load 0:0  swap 0:1  reverse 0  loadbuffer 1:0  savebuffer 0:1*/ \
__asm  movq mm1,[edi+32]  \
__asm  movq mm4,[edi+40]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm0 \
__asm  pminub mm4,mm7 \
__asm  pmaxub mm0,mm3   \
__asm  pmaxub mm7,mm6   \
 \
 \
/*first:last 2:4  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm2,[edi+64]    \
__asm  movq mm5,[edi+72]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+64],mm2   \
__asm  movq [edi+72],mm5   \
 \
 \
/*first:last 2:3  save 0:1  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 0:0*/ \
__asm  movq mm2,[edi+48]    \
__asm  movq mm5,[edi+56]   \
__asm  pmaxub mm2,mm1 \
__asm  pmaxub mm5,mm4 \
 \
 \
/*first:last 3:10  save 1:0  load 0:0  swap 1:0  reverse 1  loadbuffer 0:1  savebuffer 1:0*/ \
__asm  movq mm1,[edi+160]    \
__asm  movq mm4,[edi+168]   \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  movq [edi+48],mm2   \
__asm  movq [edi+56],mm5   \
 \
 \
/*first:last 6:8  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 1:1  savebuffer 1:1*/ \
__asm  movq mm2,[edi+96]  \
__asm  movq mm5,[edi+104]  \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm0 \
__asm  pminub mm5,mm7 \
__asm  pmaxub mm0,mm3   \
__asm  pmaxub mm7,mm6   \
__asm  movq [edi+96],mm2   \
__asm  movq [edi+104],mm5   \
 \
 \
/*first:last 7:9  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm2,[edi+112]  \
__asm  movq mm5,[edi+120]  \
__asm  movq mm1,[edi+144]    \
__asm  movq mm4,[edi+152]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+144],mm1   \
__asm  movq [edi+152],mm4   \
 \
 \
/*first:last 6:7  save 1:0  load 0:0  swap 0:1  reverse 0  loadbuffer 1:0  savebuffer 0:0*/ \
__asm  movq mm1,[edi+96]  \
__asm  movq mm4,[edi+104]  \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
 \
 \
/*first:last 3:6  save 0:1  load 0:0  swap 0:1  reverse 1  loadbuffer 1:0  savebuffer 0:1*/ \
__asm  movq mm2,[edi+48]  \
__asm  movq mm5,[edi+56]  \
__asm  pmaxub mm1,mm2 \
__asm  pmaxub mm4,mm5 \
__asm  movq [edi+96],mm1   \
__asm  movq [edi+104],mm4   \
 \
 \
/*first:last 4:5  save 0:1  load 0:0  swap 0:0  reverse 1  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm2,[edi+64]  \
__asm  movq mm5,[edi+72]  \
__asm  movq mm1,[edi+80]    \
__asm  movq mm4,[edi+88]   \
__asm  pmaxub mm1,mm2 \
__asm  pmaxub mm4,mm5 \
__asm  movq [edi+80],mm1   \
__asm  movq [edi+88],mm4   \
 \
 \
/*first:last 8:9  save 1:0  load 0:0  swap 0:0  reverse 1  loadbuffer 1:1  savebuffer 0:0*/ \
__asm  movq mm1,[edi+144]    \
__asm  movq mm4,[edi+152]   \
__asm  pminub mm0,mm1 \
__asm  pminub mm7,mm4 \
 \
 \
/*first:last 1:8  save 0:1  load 0:0  swap 0:1  reverse 0  loadbuffer 1:0  savebuffer 0:0*/ \
__asm  movq mm1,[edi+16]  \
__asm  movq mm4,[edi+24]  \
__asm  pmaxub mm0,mm1 \
__asm  pmaxub mm7,mm4 \
 \
 \
/*first:last 5:8  save 1:0  load 0:0  swap 0:0  reverse 0  loadbuffer 1:0  savebuffer 0:0*/ \
__asm  movq mm1,[edi+80]  \
__asm  movq mm4,[edi+88]  \
__asm  pminub mm1,mm0 \
__asm  pminub mm4,mm7 \
 \
 \
/*first:last 5:6  save 1:0  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 1:0*/ \
__asm  movq mm2,[edi+96]    \
__asm  movq mm5,[edi+104]   \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
 \
 \
__asm movq mm2,mm1 \
__asm movq mm5,mm4 \
}
//asm mediancalc
//edi = temp buffer
//esi = centerframe srcp
//ebx = prevframe srcp
//edx = nextframe srcp
//eax = pitch
//mm2 & mm5 contains the 16 medians
//regbuffer 8
#define MEDIAN_W9 { \
/*first:last 0:8  save 1:1  load 1:1  swap 0:0  reverse 0  loadbuffer 0:0  savebuffer 0:1*/ \
__asm  movq mm1,[esi+eax+1]  \
__asm  movq mm4,[esi+eax+1+8] \
__asm  movq mm0,[edx+eax+1]  \
__asm  movq mm7,[edx+eax+1+8]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm0 \
__asm  pminub mm4,mm7 \
__asm  pmaxub mm0,mm3   \
__asm  pmaxub mm7,mm6   \
 \
 \
/*first:last 0:4  save 1:1  load 0:1  swap 0:0  reverse 0  loadbuffer 0:0  savebuffer 1:0*/ \
__asm  movq mm2,[ebx+2*eax]  \
__asm  movq mm5,[ebx+2*eax+8]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+0],mm1   \
__asm  movq [edi+8],mm4   \
 \
 \
/*first:last 4:8  save 1:1  load 0:0  swap 1:0  reverse 1  loadbuffer 0:1  savebuffer 1:1*/ \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm0 \
__asm  pminub mm5,mm7 \
__asm  pmaxub mm0,mm3   \
__asm  pmaxub mm7,mm6   \
__asm  movq [edi+64],mm2   \
__asm  movq [edi+72],mm5   \
 \
 \
/*first:last 1:9  save 1:1  load 1:1  swap 0:0  reverse 1  loadbuffer 0:0  savebuffer 0:1*/ \
__asm  movq mm2,[ebx]  \
__asm  movq mm5,[ebx+8] \
__asm  movq mm1,[edx+2*eax]  \
__asm  movq mm4,[edx+2*eax+8]  \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+144],mm1   \
__asm  movq [edi+152],mm4   \
 \
 \
/*first:last 1:5  save 1:1  load 0:1  swap 0:0  reverse 1  loadbuffer 0:0  savebuffer 1:0*/ \
__asm  movq mm1,[ebx+2*eax+2]  \
__asm  movq mm4,[ebx+2*eax+2+8]  \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+16],mm2   \
__asm  movq [edi+24],mm5   \
 \
 \
/*first:last 5:9  save 1:1  load 0:0  swap 1:0  reverse 0  loadbuffer 0:1  savebuffer 1:1*/ \
__asm  movq mm2,[edi+144]    \
__asm  movq mm5,[edi+152]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+80],mm1   \
__asm  movq [edi+88],mm4   \
__asm  movq [edi+144],mm2   \
__asm  movq [edi+152],mm5   \
 \
 \
/*first:last 2:10  save 1:1  load 1:1  swap 0:0  reverse 0  loadbuffer 0:0  savebuffer 0:1*/ \
__asm  movq mm1,[ebx+2]  \
__asm  movq mm4,[ebx+2+8] \
__asm  movq mm2,[edx+2*eax+2]  \
__asm  movq mm5,[edx+2*eax+2+8]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+160],mm2   \
__asm  movq [edi+168],mm5   \
 \
 \
/*first:last 2:6  save 1:1  load 0:1  swap 0:0  reverse 0  loadbuffer 0:0  savebuffer 1:0*/ \
__asm  movq mm2,[edx]  \
__asm  movq mm5,[edx+8]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+32],mm1   \
__asm  movq [edi+40],mm4   \
 \
 \
/*first:last 6:10  save 1:1  load 0:0  swap 1:0  reverse 1  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+160]    \
__asm  movq mm4,[edi+168]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+160],mm1   \
__asm  movq [edi+168],mm4   \
 \
 \
/*first:last 4:6  save 1:1  load 0:0  swap 0:1  reverse 0  loadbuffer 1:0  savebuffer 1:1*/ \
__asm  movq mm1,[edi+64]  \
__asm  movq mm4,[edi+72]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+64],mm1   \
__asm  movq [edi+72],mm4   \
__asm  movq [edi+96],mm2   \
__asm  movq [edi+104],mm5   \
 \
 \
/*first:last 3:7  save 1:1  load 1:1  swap 0:0  reverse 0  loadbuffer 0:0  savebuffer 0:1*/ \
__asm  movq mm1,[ebx+eax+1]  \
__asm  movq mm4,[ebx+eax+1+8] \
__asm  movq mm2,[edx+2]  \
__asm  movq mm5,[edx+2+8]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+112],mm2   \
__asm  movq [edi+120],mm5   \
 \
 \
/*first:last 1:3  save 1:1  load 0:0  swap 0:1  reverse 1  loadbuffer 1:0  savebuffer 1:0*/ \
__asm  movq mm2,[edi+16]  \
__asm  movq mm5,[edi+24]  \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+16],mm2   \
__asm  movq [edi+24],mm5   \
 \
 \
/*first:last 3:9  save 1:1  load 0:0  swap 1:0  reverse 0  loadbuffer 0:1  savebuffer 1:1*/ \
__asm  movq mm2,[edi+144]    \
__asm  movq mm5,[edi+152]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+48],mm1   \
__asm  movq [edi+56],mm4   \
__asm  movq [edi+144],mm2   \
__asm  movq [edi+152],mm5   \
 \
 \
/*first:last 0:2  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+0]  \
__asm  movq mm4,[edi+8]  \
__asm  movq mm2,[edi+32]    \
__asm  movq mm5,[edi+40]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+32],mm2   \
__asm  movq [edi+40],mm5   \
 \
 \
/*first:last 0:1  save 0:1  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm2,[edi+16]    \
__asm  movq mm5,[edi+24]   \
__asm  pmaxub mm2,mm1 \
__asm  pmaxub mm5,mm4 \
__asm  movq [edi+16],mm2   \
__asm  movq [edi+24],mm5   \
 \
 \
/*first:last 5:7  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+80]  \
__asm  movq mm4,[edi+88]  \
__asm  movq mm2,[edi+112]    \
__asm  movq mm5,[edi+120]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+112],mm2   \
__asm  movq [edi+120],mm5   \
 \
 \
/*first:last 3:5  save 1:1  load 0:0  swap 0:1  reverse 1  loadbuffer 1:0  savebuffer 1:1*/ \
__asm  movq mm2,[edi+48]  \
__asm  movq mm5,[edi+56]  \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+48],mm2   \
__asm  movq [edi+56],mm5   \
__asm  movq [edi+80],mm1   \
__asm  movq [edi+88],mm4   \
 \
 \
/*first:last 8:10  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm1,[edi+160]    \
__asm  movq mm4,[edi+168]   \
__asm  movq mm3,mm0 \
__asm  movq mm6,mm7 \
__asm  pminub mm0,mm1 \
__asm  pminub mm7,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+160],mm1   \
__asm  movq [edi+168],mm4   \
 \
 \
/*first:last 2:8  save 1:1  load 0:0  swap 0:1  reverse 0  loadbuffer 1:0  savebuffer 0:1*/ \
__asm  movq mm1,[edi+32]  \
__asm  movq mm4,[edi+40]  \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm0 \
__asm  pminub mm4,mm7 \
__asm  pmaxub mm0,mm3   \
__asm  pmaxub mm7,mm6   \
 \
 \
/*first:last 2:4  save 1:1  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 0:1*/ \
__asm  movq mm2,[edi+64]    \
__asm  movq mm5,[edi+72]   \
__asm  movq mm3,mm1 \
__asm  movq mm6,mm4 \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
__asm  pmaxub mm2,mm3   \
__asm  pmaxub mm5,mm6   \
__asm  movq [edi+64],mm2   \
__asm  movq [edi+72],mm5   \
 \
 \
/*first:last 2:3  save 0:1  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 0:0*/ \
__asm  movq mm2,[edi+48]    \
__asm  movq mm5,[edi+56]   \
__asm  pmaxub mm2,mm1 \
__asm  pmaxub mm5,mm4 \
 \
 \
/*first:last 3:10  save 1:0  load 0:0  swap 1:0  reverse 1  loadbuffer 0:1  savebuffer 1:0*/ \
__asm  movq mm1,[edi+160]    \
__asm  movq mm4,[edi+168]   \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  movq [edi+48],mm2   \
__asm  movq [edi+56],mm5   \
 \
 \
/*first:last 6:8  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 1:1  savebuffer 1:1*/ \
__asm  movq mm2,[edi+96]  \
__asm  movq mm5,[edi+104]  \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm0 \
__asm  pminub mm5,mm7 \
__asm  pmaxub mm0,mm3   \
__asm  pmaxub mm7,mm6   \
__asm  movq [edi+96],mm2   \
__asm  movq [edi+104],mm5   \
 \
 \
/*first:last 7:9  save 1:1  load 0:0  swap 0:0  reverse 1  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm2,[edi+112]  \
__asm  movq mm5,[edi+120]  \
__asm  movq mm1,[edi+144]    \
__asm  movq mm4,[edi+152]   \
__asm  movq mm3,mm2 \
__asm  movq mm6,mm5 \
__asm  pminub mm2,mm1 \
__asm  pminub mm5,mm4 \
__asm  pmaxub mm1,mm3   \
__asm  pmaxub mm4,mm6   \
__asm  movq [edi+144],mm1   \
__asm  movq [edi+152],mm4   \
 \
 \
/*first:last 6:7  save 1:0  load 0:0  swap 0:1  reverse 0  loadbuffer 1:0  savebuffer 0:0*/ \
__asm  movq mm1,[edi+96]  \
__asm  movq mm4,[edi+104]  \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
 \
 \
/*first:last 3:6  save 0:1  load 0:0  swap 0:1  reverse 1  loadbuffer 1:0  savebuffer 0:1*/ \
__asm  movq mm2,[edi+48]  \
__asm  movq mm5,[edi+56]  \
__asm  pmaxub mm1,mm2 \
__asm  pmaxub mm4,mm5 \
__asm  movq [edi+96],mm1   \
__asm  movq [edi+104],mm4   \
 \
 \
/*first:last 4:5  save 0:1  load 0:0  swap 0:0  reverse 1  loadbuffer 1:1  savebuffer 0:1*/ \
__asm  movq mm2,[edi+64]  \
__asm  movq mm5,[edi+72]  \
__asm  movq mm1,[edi+80]    \
__asm  movq mm4,[edi+88]   \
__asm  pmaxub mm1,mm2 \
__asm  pmaxub mm4,mm5 \
__asm  movq [edi+80],mm1   \
__asm  movq [edi+88],mm4   \
 \
 \
/*first:last 8:9  save 1:0  load 0:0  swap 0:0  reverse 1  loadbuffer 1:1  savebuffer 0:0*/ \
__asm  movq mm1,[edi+144]    \
__asm  movq mm4,[edi+152]   \
__asm  pminub mm0,mm1 \
__asm  pminub mm7,mm4 \
 \
 \
/*first:last 1:8  save 0:1  load 0:0  swap 0:1  reverse 0  loadbuffer 1:0  savebuffer 0:0*/ \
__asm  movq mm1,[edi+16]  \
__asm  movq mm4,[edi+24]  \
__asm  pmaxub mm0,mm1 \
__asm  pmaxub mm7,mm4 \
 \
 \
/*first:last 5:8  save 1:0  load 0:0  swap 0:0  reverse 0  loadbuffer 1:0  savebuffer 0:0*/ \
__asm  movq mm1,[edi+80]  \
__asm  movq mm4,[edi+88]  \
__asm  pminub mm1,mm0 \
__asm  pminub mm4,mm7 \
 \
 \
/*first:last 5:6  save 1:0  load 0:0  swap 0:0  reverse 0  loadbuffer 0:1  savebuffer 1:0*/ \
__asm  movq mm2,[edi+96]    \
__asm  movq mm5,[edi+104]   \
__asm  pminub mm1,mm2 \
__asm  pminub mm4,mm5 \
 \
 \
__asm movq mm2,mm1 \
__asm movq mm5,mm4 \
}
